// ----------------------------------------------------------
// NINTV-DS Global Manual File v1.0
// Last updated 3-Dec-2021
// Place this file with your roms or in wherever
// your config says your .man files should be.
//
// You can add to this file or you can override
// anything here (or add new manuals) by creating
// a [rom-filename].man file. Basically it must
// have the same base name as your game rom and
// have a .man extension. 
// ----------------------------------------------------------

//==============================
// 2048
//==============================
$9415DAD4
2048
(c)2016 OSCAR TOLEDO GUTIERREZ

Numbered tiles appear on a 4x4
grid. Your task is to combine
tiles having the same number
by sliding them horizontally
and vertically into each other.
The resulting tile will have a
value equal to the sum of the
first two.

SELECT OPTIONS:
---------------
Press a side button for options. 
Use keypad button "1" to select
a theme for the game board.
Select game type by using the
"5" button. Toggle music On or
Off at any time by pressing "2".

HOW TO PLAY:
------------
Press up, down, left, and right
on the Disc to move the tiles on
the board. With each move, a new
tile appears on the board with a
value of either 2 or 4. Continue
moving tiles until two of them
combine to total 2048. When no
tiles can be combined and no 
space remains on the board, the
game is over.

EXTENDED PLAY:
--------------
For an even greater challenge,
press 5 at the game's title
screen to play to 4096 or 8192!

SCORING:
--------
As tiles are combined during the
game, you score points for each
new tile that is created. The
number of points awarded equals
the value of the new tile.

//==============================
// AARDVARK
//==============================
$DE11D8AE
$D38DF17A
AARDVARK
(c)2019 INTELLIVISIONREVOLUTION

OBJECT OF THE GAME:
-------------------
Use the tip of the aardvark's
tongue to eat all of the ant
eggs inside each anthill. Lap up
the various ants, worms, and
caterpillars that also inhabit
the anthill without getting
stung on the backside of your
tongue.

CONTROLS:
---------
DISC - Extend tongue
ANY SIDE BUTTON - Retract Tongue
Press 1+9 together - Pause

SCORING:
---------------------------
Eggs              10 points
Ants             100 points
Red Ants         150 points
Caterpillars     150 points
Worms            200 points
Spider           200 points
Queen Ants     1,000 points
Extra Lives   20,000 points

GAMEPLAY:
---------
As you move from one anthill to
the next, the game's difficulty
increases. AARDVARK's randomized
levels provide new challenges
each time you play! Test your
skill with Wild modes 1, 2 and 3
which have stones blocking some
routes plus other random
elements and added difficulty.

HIDDEN BONUS:
-------------
If you're able to clear an
anthill without eating a queen
ant, you'll unlock a secret
hidden level!

//==============================
// AD&D TREASURE OF TARMIN
//==============================
$16C3B62F
$6746607B
$5A4CE519
$BD731E3C
$2F9C93FC
AD&D TREASURE OF TARMIN
(c)1982 MATTEL ELECTRONICS

The Minotaur guards the coveted
Treasure of Tarmin - your goal
is to decend to meet him in 
battle and claim the treasure!

GAMEPLAY LEVEL
--------------------------------
GAME 3:  EASIEST - Minotaur Lv2
GAME 2:  EASY    - Minotaur Lv4
GAME 1:  HARD    - Minotaur Lv8
DISC:    HARDEST - Minotaur Lv12

On Hard and Hardest the damage 
you receive when attacked is 
full. On Easy and Easiest levels
the damage is reduced.

DUNGEON COLORS
--------------------------------
GREEN:  WAR LEVEL
BLUE:   SPIRITUAL LEVEL
TAN:    MIXED WAR/SPIRITUAL

GATE COLORS
--------------------------------
GREEN:  MAKES YOU MORE WARLIKE
BLUE:   MAKES YOU MORE SPIRITUAL
TAN:    DOESNT CHANGE YOU 

ALWAYS REST AFTER GOING THROUGH
A GATE.

WEAPON   TAN ORG BLU GRY YEL WHT
--------------------------------
KNIFE     9  15  21  30  42  57
AXE      15  21  27  36  51  66
DART     21  27  33  42  57  75
SPEAR    27  33  45  69  84  99
BOW       6   9  15  21  27  33
CROSSBOW 18  24  30  36  42  99

WEAPON   BLU GRY WHT PNK RED PUR
--------------------------------
SMALL FB  5   9  13  19  27  37
SMALL LB  9  13  17  23  33  43
LARGE FB 13  17  21  27  37  49
LARGE LB 17  21  29  45  55  65
SCROLL    3   5   9  13  17  21
BOOK     13  15  19  23  27  65

ARMOR   TAN  ORG  BLU  GRY  YEL
--------------------------------
SM SH   5/0  8/1 11/1 14/1 17/2
LG SH  10/1 14/1 18/2 22/2 26/3
GLOVE   1/0  2/0  3/0  5/0  7/0
HELM    2/0  4/0  6/0  9/1 12/1
HAUBK   2/0  4/0  6/0  9/1 12/1
PLATE  10/1 14/1 18/2 22/2 26/3

POTIONS
--------------------------------
SM BLUE:    RESTORE WAR/SPIRIT
SM PINK:    FIND BETTER OBJECTS
SM PURP:    INVISIBLE MONSTERS
LG BLUE:    MAX HEALTH +10 WAR
LG PINK:    MAX HEALTH +10 SPI
LG PURP:    SWAP WAR/SPIRITUAL

RINGS       SMALL    LARGE
--------------------------------
BLUE         2/5      4/8
GREY         5/10     8/16
WHITE        7/15     9/19
PINK        10/20    13/26
RED         12/25    16/33
PURPLE      15/30    20/40

BOOKS
--------------------------------
CLEAR COVER:  WAR BOOK
   BLUE : Turn HP BLUE   MAX 99
   PINK : Turn HP TAN   MAX 149
   PURP : Turn HP WHITE MAX 199

SOLID COVER:  SPIRITUAL BOOK
   BLUE : Turn SP BLUE   MAX 49
   PINK : Turn SP TAN    MAX 69
   PURP : Turn SP WHITE  MAX 99
  
X ON COVER:   SPECIAL BOOK
   BLUE : TRANSPORT THRU WALLS
   PINK : SEE THROUGH WALLS
   PURP : TURN OBJECT PLATINUM

KEYS
--------------------------------
Tan Key opens Tan Containers
Orange Key opens Tan + Orange
Blue Key opens everything

SENTIENT DOORS
--------------------------------
Lt.Blue - Hides Lg Blue Book
Tan     - Hides Lg Pink Book
Yellow  - Hides Lg Purple Book

WAR MONSTERS
--------------------------------
White Skeleton    Tan Knife   9
Grey Skeleton     Red Knife  15
Orange Skeleton   Blue Knife 21
White Cloak Skel  Tan Axe    15
Grey Cloak Skel   Red Axe    21
Orange Cloak Skel Blue Axe   27
Yellow Giant      Tan Spear  21
Yellow Giant Sld  Red Spear  27
Tan Giant         Blue Spear 33
Tan Giant Shield  Sil Spear  42
Orange Giant      Gold Spear 57
Orange Giant Sld  Plat Spear 75

SPIRITUAL MONSTERS
--------------------------------
Blue Ant          Blue FB     5
Pink Ant          Grey FB     9
Purple Ant        White FB   13
Yellow Dwarf      Grey FB     9
Yellow Dwarf Sld  Grey FB     9
Tan Dwarf         White FB   13
Tan Dwarf Shield  Pink FB    19
Orange Dwarf      Orange FB  27
Orange Dwarf Sld  Purple FB  43
Blue Scorpion     Blue LB     9
Pink Scorpion     Grey LB    13
Purple Scorpion   Pink LB    23
Blue Alligator    Orange LB  33
Pink Alligator    Purple LB  43
Purple Alligator  Pink LB    45
Blue Dragon       Grey FB    17
Pink Dragon       Orange FB  36
Purple Dragon     Purple FB  49

Mixed War/Spiritual Monsters
--------------------------------
White Ghoul       Axe/LB   36/23
Grey Ghoul        Axe/LB   57/33
Orange Ghoul      Axe/LB   66/43
White Wraith     Spear/LB  27/17
White Wraith Sld Spear/LB  33/23
Grey Wraith      Spear/LB  45/29
Grey Wraith Sld  Spear/LB  69/45
Orange Wraith    Spear/LB  84/55
Org Wraith Sld   Spear/LB  99/65
MINOTAUR!        Spear/LB  69/45


//==============================
// AD&D CLOUDY MOUNTAIN
//==============================
$F8B1F2B7
$11C3BCFA
AD&D CLOUDY MOUNTAIN
(c)1982, 1998 INTELLIVISION
PRODUCTIONS INC.

You control a 3-man expedition
of adventurers. Your object is
to acquire the two halves of the
ancient Crown of Kings, hidden
deep within the caverns of the
legendary Cloudy Mountain.

CONTROLS:
---------
DISC - Walk (in caves)
[1-4,6-9] - Move (strategy map),
  Shoot arrows (in caves)
SIDE ACTION BUTTONS - Run
CLEAR - Pick up object
[0] - Count arrows
ENTER - Exit mountain

Select skill level on title scr:
[3] - GRAY (Easy)
[2] - BLUE (Medium)
[1] - RED (Medium Hard)
DISC - PURPLE (Hard)

OBSTACLES INCLUDE:
------------------
BROWN MOUNTAINS -- Impassable
BLACK MOUNTAINS -- Contain caves
  that permit passage
RIVERS -- Can be crossed by BOAT
FORESTS -- Can be cleared by AXE
WALLS -- Contain gates that can
  be opened by KEY

TOOLS:
------
A tool (boat, axe or key) is
always guarded by a dangerous
monster. A tool can be used
REPEATEDLY. Without the right
tool, you are unable to pass an
obstacle.

BLACK MOUNTAINS CONTAIN:
------------------------
-Monsters& other nasty creatures
-Tools needed to cross obstacles
-Arrows needed to slay monsters
-One exit

As you move next to a black mtn,
it changes color to reflect the
type of cave and its contents.

GRAY (EASY) - Quivers of arrows
BLUE (MEDIUM) - Boat and arrows
RED (MED HARD) - Axe and arrows
PURPLE (HARD) - Key and arrows

WATCH OUT FOR MONSTERS!
-----------------------
A bat, spider or rat can be
killed with one shot. A dragon,
demon or snake takes two shots.
Blobs are indestructible (but
slow). And a Winged Dragon takes
three shots to kill.

ATTACK ON A WARRIOR:
--------------------
A warrior can be wounded or
killed by monsters or by
ricocheting arrows. The degree
of a warrior's injury is
indicated by his color. Black
means strong. Blue means wounded.
Red means seriously hurt. If
killed, a warrior disintegrates.

EXIT:
-----
A warrior cannot get out of a
mountain the same way he got in.
You must find the exit.

RETURN TO STRATEGY MAP:
-----------------------
After you have fought your way
through a mountain, the Strategy
Map appears. The entire
expedition automatically joins
your warrior on the other side
of the mountain. This mountain
remains clear of monsters, until
you pass through four more
mountains. After that, monsters
re-claim the first mountain.

CLOUDY MOUNTAIN:
----------------
Find the TWO SEPARATE HALVES of
the Crown of Kings and you win!
Beware! Each half of the Crown
is guarded by one of the
deadliest monsters of all -
the Winged Dragons!

STRATEGY TIPS:
--------------
1. Start with an Easy game,
until you learn the character-
istics of different monster
types. Learn which sight and
sound clues go with which
monsters.

2. Approach all the accessible
black mountains, before entering
any of them, to find out which
tools are in which mountains.

3. After entering your first
cave system, look for arrows
before taking on any of the
really nasty monsters. 3 arrows
do not last long against dragons
and snakes.

4. Move slowly in the caves and
LISTEN. Many beasts can be heard
as you approach.

5. When you find a monster
guarding a tool or exit, be
prepared to RUN in retreat,
until you reach a place where
you can get off a clear shot or
two.

6. Practice bouncing arrows off
cave walls, to learn how they
ricochet. The ability to shoot
around corners gives you a
distinct advantage over the
monsters.

7. Learn to find and shoot
monsters in the dark. Remember
that arrows follow corridors and
bounce off walls in the dark.
Only by shooting dangerous
monsters from a safe distance,
can your warrior avoid being
eaten, especially on the harder
levels.

//==============================
// ANTARCTIC TALES
//==============================
$9BA5A798
$54F3A391
ANTARCTIC TALES
(c)2020 CARLOS MADRUGA,
INTELLIVISIONREVOLUTION

Our spunky penguin hero is in a
race against the clock to circle
the continent of Antarctica. To
do so, he'll have to reach the
remote research outposts of ten
different countries. The journey
is hazardous. Slippery puddles
of water dot his route. Large
crevasses in the ice have to be
avoided. Friendly seals pop up
to say hello, but they really
get in the way. On the plus side,
tasty fish provide a welcome
snack. But time is short. Gotta
get going!

CONTROLS:
---------
DISC (LEFT/RIGHT) - Move penguin
DISC (UP) - Increase speed
DISC (DOWN) - Decrease speed
ANY SIDE BUTTON - Jump(optional)
TOP SIDE BUTTONS - Select
Press 1+9 together to pause game

GETTING STARTED:
----------------
When you see the ANTARCTIC TALES
title screen, use the DISC to
select Start or Credits. Then
press a TOP ACTION BUTTON. A map
of Antarctica shows the route
you'll follow and the upcoming
stage. Press a TOP ACTION BUTTON
to get started!

Note: You can also use the key-
pad to enter a four digit code
to play an alternate game mode.
See the "ALTERNATE GAMES CODES"
section for a list of codes.

HOW TO PLAY:
------------
Race across the ice to reach a
remote outpost before time runs
out. It's a tricky balance of
speed and skill!

Change Direction - Press left or
right on the DISC to steer the
penguin across the ice, avoiding
hazards while catching fish, and
grabbing flags.

Speed Up or Slow Down - Press up
on the DISC to increase the
penguin's speed or down to
decrease speed. He stays at a
given speed until he collides
with a seal or puddle or falls
into a crevasse.

Jump - Press ANY ACTION BUTTON
to jump out of a crevasse or
over an obstacle in the
penguin's path. NOTE: In the
"Enhanced Edition" (unless you
engage "Classic Mode"), your
penguin will jump automatically
when faced with an obstacle.

OBJECTIVES AND HAZARDS:
-----------------------
Your Stage 1 objective is to
reach the Australian outpost,
the first pitstop on your
Antarctic trip. Keep moving as
quickly as you can, but you may
need to slow down on the curves
to avoid these obstacles:

PUDDLES
-------
Puddles will slow you down, so
you'll either want to jump over
them or go around. Seals some-
times pop up out of holes in the
ice. Their size makes them hard
to jump over, so it's best to go
around them.

CREVASSES
---------
Crevasses are the biggest hazard
on your trek. Either go around
or jump over them. Touching the
edge will slow you down, but if
you fall in, you'll have to jump
out of the water and back onto
the ice before continuing.

Two things on your route can
boost your score:

1. Fish occasionally jump out of
holes in the ice. Catching one
as a snack will earn you points.

2. Flags along the route are not
a hazard. In fact, grabbing one
as a souvenir gets you points.

When you reach the 10th outpost
and complete the circuit around
Antarctica, you're ready for a
second lap, this time at a
higher difficulty level.

SCORING:
--------
If the timer reaches zero, the
game ends. Your final score is
tabulated and shown on screen.

Distance Traveled        1 pt/km
Catch A Fish              10 pts
Grab A Green Flag         50 pts
Grab A Purple Flag       250 pts

ALTERNATE GAME CODES:
---------------------
At the title screen, use the
keypad to enter one of the nine
codes below for even more fun!

[1234]- Fast Fwd. Start on lap 2
[1979]- Hard Mode. Start on lap3
[1610]- Tuxedo Night.Dark skies,
 penguin outposts, lots of fish
[1867]- Maple Leaf. Canadian OP
[1822]- Ordem e progresso.
 Brazilian outposts
[1990]- German Unity. German OP
[2021]- Classic Mode.Player must
 manually jump+ higher top speed
[1002]- Trainer Mode
[0000]- Remove any active codes

TIPS FOR SUCCESS:
-----------------
1. Slow and steady will not win
this race! If you play it too
safe, you'll run out of time.

2. Don't go too far out of your
way to catch fish or capture
flags. You could end up with no
time to dodge an obstacle.

3. As you get close to an out-
post, the number of obstacles
will diminish.That's a good time
to go full speed to the finish!

//==============================
// ASTROSMASH
//==============================
$00BE8BBA
$FAB2992C
$E15BE3BB
ASTROSMASH
(c)1981, 1998 INTELLIVISION
PRODUCTIONS, INC.

OBJECT OF THE GAME:
-------------------
To hit as many meteors, bombs,
missiles and flying saucers as
possible, without being hit
yourself. As your score grows
higher, the game speeds up and
becomes more challenging.

CONTROLS:
---------
DISC - Move laser gun
SIDE ACTION BUTTON - Fire
[1] - Auto-fire
[2] - Single shot
[3] - Hyperspace
Press 1+9 together - Pause

Press DISC or any key to start.

GET READY!
----------
1. When you are under a falling
rock or other object, FIRE by 
pressing ANY SIDE ACTION BUTTON
(or press AUTO-FIRE [1] and the
computer will shoot 3 times each
second for you). For rapid fire,
use SINGLE SHOT mode, keep
depressing a FIRE button and tap
the DISC.

2. Hit as many rocks as you can-
every one that lands reduces
your score.

3. Be sure to hit every white
"spinner"! Try to hit or avoid
guided missiles and attacking
UFOs (which appear when your
score is over 20,000 points)!

4. Every time your peak score
goes up another 1,000 points,
you get another laser gun in
your arsenal.

5. Scoring formula:

Your score goes UP when you hit:
--------------------------------
Big Rock                  10 pts
Small Rock                20 pts
Big Spinner               40 pts
Small Spinner             80 pts
Guided Missile            50 pts
UFO (level 4+)           100 pts

Point values are multiplied by
the level number.

Your score goes DOWN when:
-------------------------------
Big Rock Lands           -5 pts
Small Rock Lands        -10 pts
Gun Hit/Spinner Lands  -100 pts

Point values are multiplied by
the level number.

Scoring level changes:
-------------------------------
1x: Black       Score up to 999
2x: Blue            1,000-4,999
3x: Purple         5,000-19,999
4x: Turquoise     20,000-49,999
5x: Gray          50,000-99,999
6x: Black      100,000 and over

NOTE: EVERYTHING SPEEDS UP AND
YOU HAVE MORE TARGETS AND 
ATTACKERS, MOVING FASTER, AT THE
HIGHER SCORES ESPECIALLY WHEN
THE TOTAL PASSES 100,000,
200,000, 500,000 AND 1,000,000!

6. When you hit a rock and it
splits in two, try to hit both
of those fragments: they each
give you twice as many points as
the original big rock!

7. Whenever you see a white
object, concentrate on avoiding
it or shooting it down.

White spinners (big and small)
------------------------------
Be sure to hit every one you
can, if one lands, you lose a
laser gun (when you lose them
all, the game is over).

Pulsating guided missiles
-------------------------
Will seek out your active laser
gun and blow it up on impact! If
you can, get directly under a GM
while it is correcting course,
and shoot it! If the missile
gets to the ground, sometimes it
will home in on your laser,
flying horizontally. If this 
happens, your only chance of
escape is to go into HYPERSPACE! 
(move instantly to another spot)

When you press HYPERSPACE [3]
your laser will immediately move
to the left or right a random
distance determined by the
computer. The guided missile
will attempt to follow you there
and you might have to go into
HYPERSPACE more than once -- and
risk finding yourself under a
falling rock!

Attack UFOs
-----------
Appear  occasionally when your
score is over 20,000 points.
They sweep across the screen,
aiming huge bombs at your active
laser gun. The bombs fall slowly
enough for you to move out of
the way. Keep moving! Try to get
directly beneath the UFO and
shoot it down!

8. Do not shoot at falling rocks
that are very close to your
active laser, as the explosion
may produce shrapnel and blow up
your gun.

9. When you get good at
ASTROSMASH, the game can go on
for some time. If you want a
break in the action, remember
the "interrupt code" (press 1
and 9 simultaneously).

Restart by pressing DISC.

//==============================
// ATLANTIS
//==============================
$13FF363C
ATLANTIS
(c)1982 ACTIVISION, INC,(c)2001
INTELLIVISION PRODUCTIONS, INC.

Atlantis, the fabled city of
antiquity, lies in peaceful
waters. The major districts
of the city - the Domed Palace
and the Imperial Quarter -
murmur with activity while vital
generators whirl. All seems well.
Three defense installations
guard the skies over the
metropolis. Acropolis Command
Posts maintain close watch.

Red Alert! The Gorgon Fleet,
fierce warriors intent on
demolishing Atlantis, attacks in
force. General Tarrick, Imperial
Commander of all Atlantean
forces, mobilizes every citizen
on emergency military stand-by.
He issues Tactical Defense
Instructions. "Review these
quickly but carefully," he tells
the assembled citizenry. "The
very existence of Atlantis - and
of us all - is in jeopardy. We
must fight for our survival. How
long Atlantis survives is up to
you. To your stations!"

CONTROLS:
---------
DISC - Move Sight/Saucer
TOP SIDE BUTTONS - Fire Left
LOWER SIDE BUTTONS - Fire Right
[0] - Launch Saucer
[1] - Start
[3] - Reset
Difficulty:
[4] - Easy
[5] - Medium
[6] - Hard
Players:
[7] - One player
[9] - Two players
Pause- Press 1+9 or 3+7 together

Press DISC to begin game.

OBJECTIVES:
-----------
# Blast Gorgon vessels before
they can demolish sectors of
Atlantis with their deathrays.
# Deploy your weaponry wisely.
# Use the cross-hair sights to
aim shots fired from the two
sentry posts stationed on the
outskirts of Atlantis.
# Launch the Sentinel Saucer and
destroy Gorgon vessels.
# Battle through day, dusk, and
night.

ATLANTIS ARSENAL:
-----------------
Two types of weapons make up the
arsenal which defends Atlantis.

Anti-Aircraft Guns
------------------
One anti-aircraft gun is
positioned at each sentry post
on either side of Atlantis. Aim
anti-aircraft shots with the
floating cross-hair sight.

# Anti-aircraft guns destroy any
vessel in their line of fire.
# Anti-aircraft guns have
unlimited firing power.
# Shots will fire from the anti-
aircraft guns to the cross-hair
sight.

Sentinel Saucer
---------------
Launch the Sentinel Saucer to do
battle with the Gorgon Fleet in
the skies over Atlantis.

To Launch the Sentinel Saucer:
press "0". Sentinel Saucer will
take off from its launch pad.
Move the Sentinel Saucer with
DISC. The Sentinel Saucer fires
to the left and right.

The Sentinel Saucer fuel level
appears at the bottom center of
the screen. When a Sentinel
Saucer is launched:

# Cross-hair sight disappears.
# The fuel supply decreases by 1
fuel unit at regular intervals.
# A warning buzzer sounds when
only 5 fuel units remain. To
restore fuel supplies, return
Sentinel Saucer to its launch
pad. It refuels once inside.
# Fuel level gradually increases
at regular intervals to a
maximum of 90 fuel levels.

Be Careful! The Sentinel Saucer
explodes whenever:

# Its fuel reaches zero.
# It crashes into any part of
Atlantis. When Sentinel Saucer
explodes or returns to its
launch pad the cross-hair sight
will reappear on the screen.

NOTE: Avoid colliding with
Gorgon vessels. Sentinel Saucer
loses 10 fuel units per
collision. If saucer explodes, a
new saucer appears on the launch
pad at dawn of the next day. 

THE GORGON FLEET:
-----------------
General Tarrick's agents cracked
tight Gorgon security and
discovered the following:

# There are nine types of Gorgon
vessels with variable flight
patterns.

# The Gorgon Fleet follows a
rigid plan of attack. Four
identical ships form a squadron.
three different squadrons form a
wave. Exception - by Day 10,
heavy casualties cause the
Gorgon Fleet to mix ship types
in each squadron.

# Duration of attack: One wave
at dawn; one wave at dusk; one
wave at night - for as many days
as Atlantis can survive. Enemies
fly faster every day.

# A squadron begins its approach
high above Atlantis. Each enemy
ship tries to make four passes,
from the left or right. Each
pass brings the ship one level
closer to Atlantis. In its
fourth and final pass, the enemy
aircraft fires its sole weapon:
the Gorgon deathray, which can
demolish an entire sector of the
city upon contact.

Analysis
--------
Destroy Gorgon ships before they
reach their fourth pass. For the
duration of the attack, search-
lights will automatically scan
the skies over Atlantis at night.

Point of Vulnerability
----------------------
Searchlights incompletely scan
the sky. Defenders must 
anticipate flight patterns.

SCORING:
--------
Day One:
 Anti-Aircraft Gun Hit    10 pts
 Saucer Hit               40 pts
Day Two and After:
 Anti-Air Gun Hit  Day# x 10 pts
 Saucer Hit        Day# x 40 pts

Example: On day three, earn 30
points (3x10pts) for each anti-
aircraft gun hit and 120 points
(3x40pts) for each saucer hit.

TACTICAL TIPS:
--------------
1. Study the pre-game screen of
Atlantis before beginning play.
You'll see different Gorgon
ships and get a couple of clues
on how to position the cross-
hair sight for an effective
defense.

2. When learning to use the
cross-hair sight, try keeping
the sight at the top center of
the screen. You can pick off
Gorgon vessels as they cross
your path of fire.

3. Destroy every Gorgon vessel
you can while it is making its
first pass at the top of the
screen. Once destroyed, it
cannot fly lower.

4. Practice anticipating the
location, speed and movement of
each squadron. This will help
you when night falls and you
must rely more heavily on your
ability to anticipate the
pattern of enemy action.

5. Try using the Sentinel Saucer
during night assaults. Let your
fuel supplies build up during
dusk assaults by the Gorgon
Fleet, then launch your saucer
and blast away. Be careful! Land
before your fuel runs out.

//==============================
// BEAMRIDER
//==============================
$EAF650CC
BEAMRIDER
(c)1983 ACTIVISION, INC, (c)2001
INTELLIVISION PRODUCTIONS, INC.

BEAMRIDER BASICS:
-----------------
The Restrictor Shield, 99
sectors deep, now surrounds the
Earth. You are the Beamrider,
thrust from your Space Station,
on a mission to clear the
Shield. There you must demolish
an onslaught of aliens as you
dodge from beam to beam.

CONTROLS:
---------
DISC - Move left or right
TOP SIDE BUTTONS - Fire Lasers
LOWER SIDE BUTTONS - Torpedoes
[1] - One player
Press 1+9 or 3+7 together- Pause

GETTING STARTED:
----------------
You will start in the Space
Station. Its control panel
displays your score, two reserve
ships, sector, number of enemy
saucers in the sector and three
torpedoes. To start the action,
open the Space Station's hatch
doors and enter the Restrictor
Shield by pressing the DISC.

Enemy Saucers
-------------
There are fifteen enemy saucers
in each sector. They must all be
destroyed before you can go to
the next sector. Every time a
saucer is hit, the number in the
upper left corner of the screen
will count down by one.

Weapons
-------
Laser lariats are only effective
against certain invaders (see
Dangerous Encounters). Torpedoes
however, will destroy the first
object they meet on a beam. You
are only given three torpedoes
per sector. Use them sparingly
since they are your only weapon
against the Sector Sentinel (see
Special Features).

The Space Station
-----------------
Whenever your ship is destroyed,
or when you complete a sector,
you will return via hyperspace
to the Space Station. When
you're ready to continue, press
any button or the DISC. The
hatch doors will open and you'll
be on your way.

Scoring
-------
Points are scored each time an
enemy saucer, chirper ship or
Sector Sentinel is destroyed.
Additionally, a sector bonus,
added to all scores, increases
as you progress to higher
sectors. The higher the sector,
the higher the bonus.

White Saucers:    40 pts + bonus
Yellow Chirper:  200 pts + bonus
Sector Sentinel: 300 pts + bonus

The exact point value for each
hit appears in red, briefly
replacing your score the moment
an enemy craft is destroyed.

Also, if you manage to destroy
the Sector Sentinel, you'll
receive the points described
above plus a bonus for each ship
in your fleet (each ship will
light up and add 100 points plus
a sector bonus to your score).

You begin the game with one
active ship and two on reserve.
The game ends when all your
ships are gone.

SPECIAL FEATURES OF BEAMRIDER:
------------------------------

The Sector Sentinel
-------------------
When all fifteen white enemy
saucers have been destroyed in a
sector, their Sentinel ship will
be defenseless and will cruise
across the top of the beams.
Only a torpedo can destroy it.

Yellow Rejuvenators
-------------------
Occasionally yellow rejuvenators
will float through the beam
matrix. Allow them to land on
you deck, as each connection
will add a bonus ship to your
fleet. If you shoot or torpedo a
rejuvenator by mistake, it will
turn red from the heated blast.
Get out of the way! The wreckage
will destroy you on contact. 

DANGEROUS ENCOUNTERS:
---------------------
With the first swing of your
laser lariat, the white enemy
saucers approach. But there's
more. As you progress through
the Restrictor Shield, a
sinister collection of aliens
will materialize. A new danger
is added with every other sector
up to sector 14.

Only "vulnerable" objects are
affected by laser lariats
(saucers and chirpers are
destroyed; chargers and zig
bombs are deflected). Everything
else can only be dodged or in
extreme cases, torpedoed.

SEC  CRAFT           VULNERABLE?
1    White Enemy Saucers    Yes
2    Brown Space Debris      No
4    Yellow Chirper Ships   Yes
6    Green Blocker Ships     No
8    Green Bounce Craft      No
10   Blue Chargers          Yes
12   Orange Trackers         No
14   Red Zig Bombs          Yes

HOW TO BE A "BEAMRIDER":
------------------------
Tips from Dave Rolfe, designer
of Beamrider. Greetings from
sector 26 and moving! If you
want to make it to the outer
sectors, pay attention to these
tips.

1. First of all, don't hold down
the DISC. Maintain precise
control by learning to TAP the
DISC to move a single beam at a
time. And stay near the center
beams so you won't get boxed
into a corner with nowhere to
run.

2. Zap the white enemy saucers as
early in their approach as
possible. And check this out:
You can hit them when they're
slightly off the beam, before
they can drop their missiles.

3. When you see a yellow
rejuvenator, don't abandon all
caution as you move to catch it,
or you'll likely wreck your
ship. If an invulnerable object
is blocking it, you can use a
torpedo to blast it out of the
way. Then, catch the rejuvenator.
But remember, you only have
three torpedoes and they're your
only weapon against the Sector
Sentinel.

4. And while we're on the
subject, when the Sentinel is
about to approach, don't sit on
the beam you plan to shoot from.
Green Blockers will swarm onto
it immediately! Instead, wait on
a beam you're not going to shoot
from (like the one nearest the
Sentinel's first sighting). As
soon as the Blockers are
'locked' onto that beam, zip
over to an unblocked beam and
torpedo the ship.

5. Finally, take time to notice
the enemy attack movements. They
generally follow a pattern of
motion that allows you to
anticipate many of their moves.

//==============================
// BEAUTY AND THE BEAST
//==============================
$C047D487
BEAUTY & THE BEAST
(c)1982 ACTIVISION, INC, (c)2001
INTELLIVISION PRODUCTIONS, INC.

Horrible Hank has run off with
Tiny Mabel. She's Bashful
Buford's girl. Buford may be
scrawny, but he's got spunk.
He's cornered them up on the old
Mutton Building. Buford jumps
over those boulders Horrible
Hank throws his way. He dodges
birds and bats and leaps clean
over rats - all to get his
little love back!

CONTROLS:
---------
DISC - Move Buford
ANY SIDE BUTTON - Jump
Pause- Press 1+9 or 3+7 together

Press any button to start game.

GAME OBJECTIVES:
----------------
Earn the highest number of
points you can! Reach top of
each section of building by
helping Buford climb up open
windows. Avoid obstacles, unless
Buford catches a heart. Then
tackle every boulder, bird, bat
and rat you can while Buford
glows. Complete as many
buildings as possible. Game ends
when Buford runs out of lives.

GAME PLAY:
----------
Press any SIDE BUTTON to make
Buford jump. Move Buford with
the DISC. Walk left and right on
ledges. Climb up or down at open
windows.

Buford must be directly in front
of an open window to climb up. 
He must be directly over a
window in order to climb down.
Careful! If a window closes
while Buford is climbing, he'll
fall to the bottom of the
current section of building.

AWKWARD OBSTACLES:
------------------
As Bashful Buford edges up
toward his goal, he contends
with BOULDERS, BATS, RATS and
BIRDS. If any critter or boulder
touches Buford, he falls to the
bottom of the section of the
building he's climbing and loses
a life.

About Boulders
--------------
Horrible Hank's boulders not
only roll, they also fall. Each
ledge has three bumpers. When a
boulder hits a bumper, it can
roll in the opposite direction,
or fall to the floor below.

When boulders fall, some break
in two. Buford has to watch
those birds and bats, too. He
can find the two areas on the
ledge where birds and bats will
fly over him. He can climb up or
down through open windows to
avoid them. Buford can also leap
over rats and boulders.

To make Buford jump, press any
SIDE BUTTON. Buford takes a
longer leap the farther he's
walked in the same direction
along the ledge. Watch it! Too
long a leap and Bashful Buford
may fall.

HER PRECIOUS LOVE:
------------------
Tiny Mabel sends her heart out
to her humble hero. Bashful
Buford tries to capture every
heart he can. When he does,
you'll hear "their song" and be
awarded 50 points. He'll then
glow and become invincible.
During that time, chase and
catch boulders, bats, birds and
rats for 50 points each.

THE MUTTON BUILDING:
--------------------
A complete building consists of
eleven sections of four floors
each. Each time Buford gets near
enough to touch Horrible Hank
and Tiny Mabel (100 points),
Horrible Hank carries her higher
until they reach the top. The
top of the building gets
narrower as they climb higher.
Careful! Those ledges get might
skimpy.

When Buford succeeds in climbing
a section, the screen shifts to
overview of the Mutton Building.
The building is tinted red to
show how high Buford has
climbed. The number of complete
buildings Buford has conquered
appears at lower right. Your
score appears at upper right.
Blue figures at lower left show
how many lives Buford has left.
A biplane buzzes by to show how
you and Buford are doing.

When Buford reaches the top of
the building it will turn
completely red and he will earn
500 points. Horrible Hank will
drop like a rock to the bottom
of the building. Tiny Mabel and
her hero wave. A biplane then
carries them to safety.

Don't stop now! The more
buildings Buford scales, the
tougher the going gets. Boulders
split and make the climb doubly
dangerous. Rats, birds and bats
multiply and make it even
trickier to survive. You can
earn fewer bonus lives.

SCORING:
--------                     Pts
Catch Mabel's heart           50
Catch boulder/rat/bat/bird    50
Get to Horrible Hank         100
Rescue Mabel                 500

Buford starts with three lives.
He loses a life when an obstacle
hits him or he falls. Buford can
gain lives - up to a total of
six at one time. Buford gains an
extra life every time he reaches
Horrible Hank and Tiny Mabel on
the first five buildings. A
total of five bonus lives per
building are possible. Beginning
with the sixth building, lives
are fewer and farther between;
he earns an extra life every
fourth time he reaches Horrible
Hank and Tiny Mabel. Two bonus
lives per building are possible.

TIPS:
-----
1. Don't let Buford linger under
bumpers. A boulder may bash him.

2. Hurry up! The longer Buford
takes, the more obstacles he'll
encounter.

//==============================
// BUMP 'N' JUMP
//==============================
$999CCEED
BUMP 'N' JUMP*
(c)1982, 1998 INTELLIVISION
PRODUCTIONS, INC.
*TRADEMARK OF DATA EAST USA, INC.

OBJECT OF THE GAME:
-------------------
Bump 'em and jump 'em! Blast 'em
and crash 'em. Send cars
screeching off the road! Watch
out for obstacles and tricky
turns. Peel down the road but
don't total your car. Bump and
jump your way to tougher and
tougher roadways.

CONTROLS:
---------
DISC(LEFT/RIGHT)- Steer your car
DISC(UP) - Accelerate
DISC(DOWN) - Brake
ANY SIDE ACTION KEY - Jump

To begin the game, press DISC.

HOW TO PLAY:
------------
The game begins immediately with
you at the wheel of the red car.
You're on the open road,
surrounded by a pack of cars.
They're out to bump you off the
road, smash you into the
railings and crash you into
trees and water.

Use the DISC as your steering
wheel and react quickly. Press
the edge in the direction you
want to steer the car. Use the
DISC as your gas pedal. Press
top of DISC to accelerate and
press the bottom to decelerate.
Chase cars down and bump them
into the weeds! Crash as many of
them as you can!

Watch the roadway. Be on the
lookout for obstacles in your
way. Build up speed through the
straightaways, tighten your
steering through the curves.
Don't hug the side or you could
get bumped off! When you
approach water make a split
second decision. Accelerate and
jump over it. Or drive on the
causeway that runs along the 
side -- if there is one!

When you reach the end of a road
way, you get bonus points! Then
the action automatically begins
on the next roadway. Each one is
a little tougher than the last.
The game ends when you crash all
of your cars!

YOUR CAR:
---------
Start the game with 5 red cars.
Go from a cruising speed of 20
mph to flat out 220 mph. Look at
the screen to see your current
speed. Each time you crash, you
lose a car. The number of cars
left shows on the screen. When
you reach the first 20,000
points, you get another car!

BUMPING:
--------
Bump into cars and send them
reeling off the road to crash!
Bump with the front of your car
and you lose speed. Get bumped
from behind and you gain speed.
Try bumping from different
directions and at different
angles. The faster your speed,
the further you will bump the
other car. But be careful -- any
time you make contact with
another car, your car ricochets
too. Use the DISC to quickly
regain your course.

JUMPING:
--------
To jump press any ACTION BUTTON.
Your car gets bigger as it jumps
into the air, then gets smaller
as it lands again. Be careful
when you jump. If you come down
in the water or onto the edge of
the roadway, you will crash!

You can jump any time, as long
as you're going 100 mph or
faster. Jump when you are boxed
in -- jump onto another car to
crash it -- jump to fly over
water. The faster your speed,
the farther your car will jump.
Use DISC when you're in midair
to control your landing point.

If you've got lightning reflexes
then jump and land on the island
in the water -- then jump to the
roadway. You get bonus points
for landing on the island!

ROADWAYS:
---------
There are lots of different
roadways. As you progress
through the game, the roadways
get more difficult, with more
road debris, center islands,
water and turns.

Every time you approach water
you will hear a beep and see "!"
Keep your eyes peeled. Sometimes
there's a causeway on the side
so you can drive around the
water. Sometimes the only way to
get over the water is to jump!
You never know until you get
there. Response time is critical.

You complete a roadway when your
car drives up to the gas pump
and refuels. You see your score,
the number of cars that crashed,
bonus points, the roadway number
you are about to begin and the
season you will drive through
next. (The scenery along the
roadways is a different color
for each season.)

CRASHING:
---------
A car crashes when it runs into
the railing of trees at the side
of the road, when it hits debris
in the road or when it runs into
the water. But you have an edge
on the other cars. You can jump
on top of one and it will crash!
When another car bites the dust
look at the crash site to see
the points you get for that car.

When you crash, you lose a car.
Then your next car is auto-
matically placed on the road
before your crash site.

TYPES OF CARS:
--------------
There are 10 types of cars on
the road. Get to know 'em!

1. The tractor is really heavy
and cannot be bumped very far.
It always drives straight ahead
and very slowly.

2. The cycle is extremely light
and can be bumped a long way.
It drives at medium speed and
weaves back and forth a lot.

3. The skull car travels really
fast and is light. It frequently
heads straight toward your car!

4. The race car is super light,
goes really fast and zig zags
across the road occasionally.

5. The dump truck moves fast and
sporadically dumps debris on the
road. It explodes on contact!

6. The white car is fairly
light, can be bumped a long
distance and frequently heads
straight toward your car.

7. The yellow truck is the
second heaviest vehicle. It
weaves back and forth a lot.

8. The green car is very light
and can be bumped a long way. It
zig zags a lot.

9. The blue car is really light
and fast, and weaves back and
forth a lot.

10. The brown car is fairly
light, can be bumped a long
distance and zig zags a lot.

START A NEW GAME:
-----------------
When you crash all of your cars,
press RESET or ENTER to begin a 
new game.

SCORING:
--------
You accumulate points as you
drive through each roadway. The
further you drive, the more
points you get. You also get
points for each car that crashes.
Cars are worth different points.
Get 1,000 bonus points if you
land on an island in the water.
Your score shows on the screen
at the end of each roadway, or
when you crash. 

Make it to the end of a roadway
and you get bonus points for
each car you crash:

Roadway 1- 300 pts / car crashed
Roadway 2- 400 pts / car crashed
Roadway 3+ 500 pts / car crashed

Get 50,000 points if you don't
crash another car during an
entire roadway.

TIPS:
-----
1. Keep your speed over 100 mph
so you can jump at any time!

2. Steer your car toward the
center of the roadway. If you're
near the side you could get
bumped off the road and crash!

3. Drive between two cars so you
can bump back and forth!

4. Watch out on the causeways,
they can be tricky. Another car
can speed ahead and block your
way. If you bump into it, you'll
likely crash into the side.

//==============================
// BURGERTIME
//==============================
$43806375
$C92BAAE8
BURGERTIME*
(c)1983, 1998 INTELLIVISION
PRODUCTIONS, INC.
*TRADEMARK OF DATA EAST USA, INC

Your chef, Peter Pepper, is
surrounded! Pickles and hot dogs
are everywhere!

CONTROLS:
---------
DISC - Move chef in 4 directions
ANY SIDE BUTTON - Throw pepper

Playing Speed: DISC=Fastest,
1=Fast, 2=Medium, 3=Slow

Press ENTER to start game.

OBJECT OF THE GAME:
-------------------
Score points while building
hamburgers. Avoid dangerous hot
dogs, pickles and eggs. Points
are scored for dropping
ingredients and squashing
nasties. Maximum point value is
received for giving those foes
a ride on a falling bun, patty,
tomato, or lettuce leaf.

THE CHEF:
---------
You control the chef. Move him
up ladders and across planks
using the direction disc. Move
your chef completely across a
bun and it drops down one level.
You rack up 50 points. You also
rack up 50 points for each
patty, tomato slice, and lettuce
leaf that you drop.

You start with 5 chefs. For
every 10,000 points scored, you
get an extra chef. The number of
chefs you have waiting are
displayed in the lower right
corner of the screen.

NASTIES AND MAZES:
------------------
Hot Dogs, Eggs and Pickles chase
your chef wherever he goes in
the maze. If they catch him, the
round is over. All the nasties
get smarter as you go along.

There are 7 mazes consisting of
ladders and planks. Some are
more difficult than others. When
you successfully build all the
hamburgers in one maze, you move
on to the next maze. When all 7
mazes have been completed, you
start over again with the first
maze -- only at a more difficult
level. Your current level is
displayed after you lose a chef.

FOR MORE POINTS:
----------------
DROP the ingredients ON TOP of
the nasties. You will get 100
points for each one you squash.
Squashed nasties come back to
life from either side of the
screen.

FOR EVEN MORE POINTS:
---------------------
Tempt the nasties out onto a
bun and then drop it by stepping
off. The bun will drop 2 levels.
The more nasties on the bun, the
higher the point value. After a
few seconds, dropped nasties
return from the point where they
ended their fall.

FOR MAXIMUM POINTS:
-------------------
Lead the nasties on a chase and
get them to meet at corners. If
they meet and head in the same
direction (and you're lucky),
they will stick together. Get as
many stuck together as you can
and give them a ride on a
falling bun or other ingredient.
You will score big.

AND A PINCH OF PEPPER:
----------------------
Pepper may be used to
temporarily stun nasties if you
are trapped. This tactic allows
you to move out of corners
unharmed. You can only throw
pepper IN THE DIRECTION YOU ARE
MOVING OR LAST MOVED.

You start with 4 pinches of
pepper which are displayed in
the lower left corner of the
screen. You can earn extra
pinches of pepper by gobbling
ice cream, coffee, ketchup, or
french fries depending on your
level. You get 500 points and a
pinch of pepper for each item
gobbled. Smart cooks only use
pepper when they need to. That
pepper can be very valuable at
the upper levels.

SCORE DISPLAY:
--------------
The running score is tallied on
the upper left in yellow. The
center score (green) is the
highest score achieved at that 
game speed.

MAXIMUM SCORE:
--------------
(For Burger-Maniacs Only)
Once you get 1,000,000 points,
the scoring begins at -0- again.
At the end of each game you will
see a number under the center
score. This tells you how many
times you have reached 1,000,000.
You may reach 1,000,000 a total
of 255 times - for a possible
score of 255,999,950. GOOD LUCK!

SCORING CHART:
--------------
Drop hamburger part       50 pts
Squash a nasty           100 pts
Give 1 nasty a ride      500 pts
Give 2 nasties a ride  1,000 pts
Give 3 nasties a ride  2,000 pts
Give 4 nasties a ride  4,000 pts
Give 5 nasties a ride  8,000 pts
Gobble a pepper prize    500 pts

//==============================
// SUPER CHEF BT
//==============================
$0cba0677
SUPER CHEF BT
(c)2013 INTELLIGENTVISION

Freeze them or pepper them?
Either way, decide quickly! The
nasties are coming to get you!
Do you have enough pepper to
make your way through them or do
you have to outsmart them? You
are the chef and have a job to
do. How many burgers will you be
able to complete? Run!

CONTROLS:
---------
DISC - Move chef in 4 directions
UPPER BUTTONS - Freeze nasties
LOWER BUTTONS - Throw pepper

Playing Speed: DISC=Fastest,
1=Fast, 2=Medium, 3=Slow

Press ENTER to start game.

HERE THEY COME:
---------------
You are Peter the Super Chef,
and your job is to build burgers.
Use the DISC to move Peter
across the platforms, up and
down the ladders running over
the pieces dropping them down to
complete the sandwich. You will
be hunted down by sausages,
pickles, and an egg trying to
stop you. 

When game play starts, Peter
will always be at the same
starting position; bottom left
side of the screen. The nasties
(sausages, eggs, and pickles)
will always enter from the same
four entry points on the side of
the maze.

THE PLAYERS:
------------
Everyone is after Peter the chef
as they do not want to be part
of his quality burgers! You are
in control of him and your
objective is to make burgers, as
many as you can!

You will assemble the burgers by
navigating the different mazes
and stomping down on the diff-
erent components of the burger.
All the pieces need to reach the
bottom of the screen before you
can move on to the next level.

You may not want to run away
from the nasties, but you
definitely do not want to touch
them as they will stop you from
completing your task. The
nasties include the sausage,
egg and pickle. Each of them has
their own personality.

The first screens will consist
of 3 sausages and one egg. The
pickle does not appear in the
game until screen 46 of level
one. Once they do, they will
replace 2 of the sausages.

As game play continues, the
nasties will begin to move
faster. You may want to just
complete the maze instead of
trying to collect as many points
as possible. Still convinced you
want to focus on points? Then
try to get the nasties to bunch
up together and get them all to
fall on one piece of sandwich.

YOUR WEAPONS:
-------------
You do not have to just outsmart
the nasties. You have a tool
belt that converts condiments
and snacks to weapons! Your
weapon of choice is pepper!

After you stomp and drop 3
burger pieces, the condiments
and snacks will show up in the
maze. Collect fries, ketchup,
mustard, tea and lemonade to add
to your pepper stash. Not only
will they come in handy during
the game, collecting them adds
points to your score!

To freeze and stun one nasty,
press the LOWER SIDE BUTTON and
a small amount of pepper will be
thrown in the direction you are
running. You can then run past
them. Do not wait around though,
they will wake up and continue
their pursuit.

Pressing the TOP SIDE BUTTON
will freeze ALL nasties! Doing
this will use 2 units of pepper,
so use this wisely. You need to
plan ahead as they will not be
stunned, so you can NOT run past
them.

INDICATORS:
-----------
The score is shown at the top
left of the screen in yellow,
the high score in the center.
The amount of pepper in your
inventory is shown on the bottom
left, the number of remaining
chefs on the bottom right.

LEVELS, STAGES, AND STATISTICS:
-------------------------------
The game consists of 70 diff-
erent stages. After a stage is
completed, the following stage
is randomly selected and will be
a higher stage than what you
last played. The level increases
as you pass stage 70 and loops
back to the first stages. When
the game ends, you will see the
level and stage reached and how
many screens you played("Total").

//==============================
// BUZZ BOMBERS
//==============================
$FA492BBD
$2A1E0C1C
BUZZ BOMBERS
(c)1983, 1998 INTELLIVISION
PRODUCTIONS, INC.

Little Buzz Bombers keep
barreling down towards your
spray can. Blast one with a
spray that sends him into a
tailspin. Now you've got a
honeycomb and 100 points, but
KEEP MOVING. Moment by moment
your spray can is being hemmed
in by flowers. Make every shot
count. You hit two bees with one
shot - but the Buzz Bombers have
other tricks up their little bee
sleeves. Here come the worst
bees of them all -- the Buzz
Bomber KILLER BEES. Spray them
all and watch the points pile up. 

CONTROLS:
---------
DISC - Move spray can right/left
SIDE BUTTONS - Spray

Press any key or DISC to start.

OBJECT OF THE GAME:
-------------------
Spray bees as quickly as you can
with your spray can before they
fly down and pollinate the
flowers. Flowers can surround
and trap your can. A sprayed bee
creates a honeycomb which your
friendly Hummingbird will eat.
Points are scored for spraying
bees and allowing the
Hummingbird to eat the honey-
combs. Additional points may be
scored at the end of a level for
any beehive on the screen. A
beehive is created by a trapped
worker bee. Score enough points
and you win an extra spray can.
Be thankful because you're going
to need that can at the higher
levels. The game gets tougher
as you play.

THE SPRAY CAN:
--------------
You control the spray can. Move
the spray can either right or
left using the DISC. You start
with 3 spray cans. One is used
immediately. The other 2 are
displayed in the lower left
corner of the screen. Each spray
can provides 56 sprays. Every 8
sprays, the spray level in the
can will lower so you can see
how much spray you have left. 

When you use up all the spray in
a can, the replacement can (if
there is one) will automatically
take its place. Regardless of
how much spray is left in your
can, it will fill up again when
you complete a level. 

THE FLIGHT OF THE BUZZ BOMBERS:
-------------------------------
The Buzz Bombers are the bees
that fly down on your spray can
(to the tune of The Flight of
the Bumblebee). They fly down on
invisible flight paths called
"tiers". Each time they bump
into the side of the screen they
reverse direction and drop to
the next lower tier.

When they reach the bottom, they
pollinate the flowers. Polli-
nation causes flowers to multi-
ply and restrict the movement of
your can. When the flowers
completely hem in your spray can
you lose it. 

WORKER BEES:
------------
Worker bees are YELLOW. At the
lower levels, most of the
attacking Buzz Bombers will be
worker bees. A worker bee
becomes a YELLOW HONEYCOMB when
hit by spray. Worker bees drop
one tier each time they reach
the side of the screen OR bounce
off a honeycomb. 

KILLER BEES:
------------
Killer bees are WHITE and fly
much faster than worker bees.
The higher the playing level,
the more likely it is that a
killer bee will appear. Don't be
surprised if 5 or 6 dive on you
at once. Killer bees turn into
RED HONEYCOMBS if you are
skilled enough to hit them with
spray. They DO NOT bounce off a
honeycomb and drop one tier.
They ONLY reverse direction and
drop a tier when they reach the
side of the screen.

THE HUMMINGBIRD:
----------------
The Hummingbird is your friend
in this battle of the bees. She
darts around the screen looking
for honeycombs. Every time she
finds and eats one, you get
points. Spray won't kill your
Hummingbird, but it will make
her sick. If you spray her too
much, she turns green and leaves
the screen for a breath of fresh
air. She'll return later. 

HONEYCOMBS:
-----------
A honeycomb is created by any
bee after he is hit by spray.
You get points for spraying the
bee, but you can earn more
points by leaving the honeycomb
for your Hummingbird. The red
honeycomb of the killer bee is
worth more than the yellow
honeycomb of the worker bee 
(see chart). A honeycomb will
DISAPPEAR if sprayed. Sometimes
a honeycomb gets in the way and
should be sprayed. It depends on
your situation. Consult the
Scoring Chart and design your
own Buzz Bombers strategy. 

BEEHIVES:
---------
On occasion, a worker bee will
get stuck on a flight down,
usually between a honeycomb and
the side of the screen. If this
happens, the worker bee will
build a BEEHIVE. The beehive is
worth big points when you
successfully complete the level.
Spray will destroy the beehive,
so be careful where you spray. 

FLOWERS:
--------
Flowers usually grow from both
sides toward the middle, but
don't count on it. Flowers can
also start growing in the center
and push your can to one side.
When the flowers restrict your
can, it will magically leap to
the open space (if there is one).
If flowers kick your can out of
the garden and you still have a
spray can left, then the screen
will clear of all flowers and
you will get another chance
(using the extra can) to
successfully complete the level.
Unfortunately, you must start
the level again from scratch.

SCORING CHART:
--------------
Hitting a Worker Bee     100 pts
Hummingbird Eats YELLOW Honeycmb:
 Top two screen tiers   1000 pts
 3rd, 4th and 5th tiers  800 pts
 All remaining tiers     500 pts
Hitting a Killer Bee    1000 pts
Hummingbird Eats RED Honeycomb
 Top two screen tiers   2000 pts
 3rd, 4th and 5th tiers 1800 pts
 All remaining tiers    1500 pts
Beehives(after completing level)
 Hive on top two tiers  2000 pts
 3rd, 4th and 5th tiers 1600 pts
 All remaining tiers    1000 pts

BONUS CAN RECEIVED AT 20,000 pts
                      40,000 pts
                      80,000 pts
  Every 80,000 POINTS thereafter

MAXIMUM SCORE:
--------------
Once you get 1,000,000 points,
the scoring begins at -0- again.
At the end of each game you will
see a number over the flower bed.
This tells you how many times
you have reached 1,000,000. You
may reach 1,000,000 a total of
255 times - for a possible score
of 255,999,900. GOOD LUCK!!!

//==============================
// D2K ARCADE
//==============================
|D2K|
DIIK ARCADE
(c)2012 CARL MUELLER, JR.,
ELECTRONITE

One smart ape has escaped from
his cage. Mario, the zookeeper,
is in a real fix! The gorilla
Donkey Kong has captured a very
special lady and made his way
onto a construction site and up
bewildering, unfinished
structures - a veritable King
Kong! Leap for your life over
bouncing barrels, ride fast-
moving platforms to dizzying
heights, scurry under runaway
springs, and avoid roaming
flames and dangerous balls of
gas as you make your way up. It
will take not only Mario but one
of his brothers - Toni and Bruno
- to outsmart the big ape and
return the girl to safety.

CONTROLS:
---------
DISC - Move Mario/Toni/Bruno
TOP SIDE BUTTONS - Jump
[8] - Pause game

NOTE: Make the player jump
straight up by pressing either
TOP SIDE BUTTON. Make the player
jump left or right by pressing
the DISC in the desired direc-
tion and either TOP SIDE BUTTON
simultaneously. YOUR ACCURACY
MUST BE PERFECT, AS YOU CANNOT
CHANGE YOUR DIRECTION AFTER YOUR
JUMP BEGINS.

STARTING GAME:
--------------
When game title appears, it is
time to select the character you
wish to play as and the game to
play. You may press the corre-
sponding key on the numeric pad
(described below), or you may
also press the DISC left or
right to cycle through available
options. Press ENTER to use the
value already displayed.

CHOOSE YOUR CHARACTER:
----------------------
Press [1] to play as Mario.
Press [2] to play as Toni.
Press [3] to play as Bruno.

MARIO -- Donkey Kong's zookeeper.
  A solid jumper with adequate
  speed. He pounds a mean hammer,
  but is unable to jump or climb
  once he's nabbed one.

TONI -- Mario's younger brother.
  Faster and able to leap
  further than his brothers, his
  nimbleness extends to jumping
  while smashing with the hammer.

BRUNO -- Mario's older brother.
  While not as fast on his feet,
  he can take a fall like no one
  else. This tough guy is even
  able to hold onto his hammer
  while climbing.

When you have finished selecting
your character, press ENTER.

SELECTING THE GAME:
-------------------
Press [1] to play Game 1.
Press [2] to play Game 2.

GAME 1 -- Classic mode.
  Play from 4 different classic
  boards from the game DK ARCADE.

GAME 2 -- Sequel mode.
  Play from 7 different boards - 
  5 all new and 2 classic - from
  the sequel D2K ARCADE.

Press ENTER to start game.

THE PLAYER:
-----------
You control "the player" (Mario,
Toni, or Bruno). Move him up
ladders or across girders using
the direction DISC. Hold DISC
left or right and press either
upper action button to span gaps
between girders or to board and
exit elevators.

In Game #1, you start with three
lives. In Game #2, you start
with six. Only one can be used
at a time. If you break 10,000
points, you get an extra life.

ENEMIES:
--------
Barrels, flames, springs, balls
of gas, and even cement pies are
all deadly to the player. They
either appear to chase or
obstruct the player in some way
as he makes his way up. Touch
one of them and you lose a life.
They get smarter and faster or
appear more quickly as the game
progresses.

Jump over an enemy or let it
pass under you by jumping
straight up. A well-timed jump
over a single nasty gets you 100
points - jump two, 300 points -
three or more, and it's 500
points! Listen for the jingle
and you know you've got it! A
successful jump will not always
display points, but will always
be accompanied by a melody and
an increase in score.

Jump under a hammer to nab it
and start smashing...but beware,
you're not invincible! Allow a
nasty to slip under your hammer
and it's over. A well-timed hit
gets you 300 pts.For a fireball,
pie, or blue barrel up to 800!

PLAYING SCREENS:
----------------
There are nine different boards
in all, shared between two
adventures. Some are more diffi-
cult than others. When you've
successfully rescued the lady on
one board, you move on to the
next. When you clear a "round"
of boards, you start again at
the first - only at a more
difficult level!

GAME #1
-------
BARRELS -- DK's tantrum has
  crushed and warped five levels
  of girders, turning them into
  a nightmare of ramps and
  rolling barrels! Jump for your
  life or grab a hammer and
  start smashing!

PIE FACTORY -- Treacherous con-
  veyors, leaping flames, and
  "pies" that look almost good
  enough to eat...but don't be
  fooled! These trays of cement
  are massively dangerous!

ELEVATORS -- Two fast-moving
  columns of elevators and some
  nasty fireballs await you.
  Take the easy way out but be
  wary of the springs.

RIVETS -- Your only chance to
  reunite yourself with your
  loved one! Dismantle the
  structure by pulling out the
  support rivets and give the
  big ape a concussion he won't
  soon forget!

GAME #2
-------
TWISTED GIRDERS -- DK has
  "twisted" five more levels of
  girders! Barrels bounce high
  and come at you from both
  directions while flames rain
  down on you from above!

THE MIXER -- A mixer tops off
  empty "pie" plates while full
  ones twirl down from the sky!
  Master the timing of the
  stopping conveyor or risk an
  embarrassing tumble into a
  tray full of cement!

THE REFINERY -- Oil, gas, and
  an array of safety valves...
  this level has "danger"
  written all over it! Outwit DK
  by putting out fires at the
  top of both towers...before
  the timer runs out!

TRIPLE ELEVATORS -- Three
  elevator columns separate you
  from narrow structures guarded
  by merciless fireballs. Span
  treacherous gaps while dodging
  a barrage of bouncing springs.

THE ELIMINATOR -- Only appearing
  on level 3, this is DK's final
  attempt to "eliminate" you.
  Don't be afraid of the blue
  fire...it won't hurt you,
  unlike everything else!

SCREEN CONTENTS:
----------------
EDGES -- Sometimes, in order to
snag a hammer (or escape from a
tight spot), you may have to
take a leap of faith...toward
the edge of the screen! Time it
right and the player will bounce
back up from the edge with
hammer in hand (or back to
safety). Be too ambitious and
your jump may soon turn into a
fall you can't pull out of!

TRINKETS -- Objects scattered
throughout the structure - your
girlfriend's personal affects -
provide you with a virtual trail
of breadcrumbs...and an oppor-
tunity to score points! At level
1, 100 pts...at level 2, 300 pts
and 800 pts for levels 3 and up!
The more risk, the more reward!

HAMMERS -- Stand precisely under
a hammer and jump straight up to
nab it - or better yet, jump to
the left or right and snag it as
you hit the peak of your jump!
(Also, see "EDGES", above.)

LADDERS -- Push up or down to
board a ladder in that direction
but be careful! Broken ladders
can only be climbed halfway up
(handy for escaping a barrage of
barrels), but not down! Retract-
able ladders can only be climbed
all the way when they're
connected with the girder above.
Time it wrong and the ladder re-
tracts, taking you down with it!

CONVEYOR BELTS -- Conveyor belts
are what make "pies" move.
They're always moving left or
right, and sometimes switch
direction or even stop! Learn
their timing and avoid headlong
falls into trays of cement!

ELEVATORS -- To board or exit an
elevator, simply jump on or off
a moving platform...but pay
attention to where it's taking
you! Dangerous and unforgiving
columns, patrolled by fireballs,
may await you! Linger too long
and you may find yourself with-
out an exit - crushed at a
terminal - above or below you!

RIVETS/SAFETY VALVES -- Some
boards may have rivets or safety
valves that need pulling or
turning. Walk or jump over them
to score some points, and bring
yourself one step closer to
completing the board! Outwit DK
by dismantling his structure or
his ingenious traps of fire!

SPRINGS -- Springs require pre-
cise hand-eye coordination and
impeccable timing! Study their
patterns to discover areas of
"safety" where the springs
never touch - and make a run for
the girl's platform!

CODES:
------
Use the following codes to
unlock special features within
D2K ARCADE. Wait for the intro
screen, when DK first appears,
then punch in the code. You may
wish to pause the game first by
pressing "8". If you enter the
code correctly, you'll hear the
girl say "right!".

[1981] Girl now says "help!"
  during intro and after each
  screen.

[1889] Girl says "help!" during
  intro and after each screen.
  DK uses “correct” growl
  (omitted by mistake).

[3030] Objects flicker at 30 FPS
  Corrects "disappearing object"
  problem on some HD displays.

SCORE DISPLAY:
--------------
There are three "nooks" or
groupings of numbers on the
right edge of the screen. The
running score is tallied, verti-
cally, in the top nook. The num-
ber of lives remaining appears
in the center nook. The bottom
nook serves a dual purpose. When
the game challenges you with
"How High Can You Get?" and the
board's height is displayed, the
level is shown here in red.

During gameplay, a bonus timer
is displayed. This timer counts
down. When you successfully
complete a board, you are
awarded 100 points for every
timer unit left...but be fore-
warned! If the timer reaches
zero before you rescue the girl,
you're gone!

SCORING:
--------
Jumping an Object:
 1 Object                100 pts
 2 Objects               300 pts
 3 or More Objects       500 pts
Smashing with the Hammer:
 Brown Barrel            300 pts
 Blue Barrel, Fireball,
 or Pie     (random) 300-800 pts
Picking up Trinket, Pulling a
Rivet or Turning Safety Valve:
 Level 1                 100 pts
 Level 2                 300 pts
 Levels 3 and Up         800 pts

You also earn 100 points for
every unit left in the timer
upon successful completion of
each screen. Complete the screen
with 26 units left and that's
2,600 points!

When you hear the bell - "ding,
ding, ding" - you've broken the
current high score! Play another
game to see if you can beat your
new high, or challenge a friend,
the bell sounding each time
you've broken the other's new
record!

You earn an extra life at 10,000
points - but you only get one,
so use it wisely!

TIPS:
-----
1. Master your jumping skills.
You need to take the player to
the very edge of the platform to
make some jumps. For others, you
may have to backup first to
avoid over jumping your target!

2. On the TWISTED GIRDERS screen,
stay away from areas where
barrels fall - they bounce high!
Instead, wait for an opening
then make your way up. When you
come to the oil drum in the
center, take the left ladder and
avoid the area completely...OR
bounce off the left side of the
screen and nab the hammer!

3. Never wait for a barrel to
pass overhead while climbing or
standing under a ladder...more
likely than not, it will come
down on your head! Play it safe,
or learn to control barrels by
pushing in the opposite
direction, forcing them down
ladders and away from you!

//==============================
// DIG DUG
//==============================
$159AF7F7
DIG DUG*
(c)1987, 1998 INTELLIVISION
PRODUCTIONS, INC.
*TRADEMARK OF NAMCO

CONTROLS:
---------
DISC - Move Dig Dug
SIDE ACTION BUTTON - Use air gun
Press 1+9 together - Pause

Press any KEY or DISC to start.

GAME PLAY:
----------
At the beginning of the game,
Dig Dug burrows his way to the
center of the earth. Once he's
there, you control him with the
hand controller DISC. Dig your
own tunnels, or break into
existing ones. Stun or explode
monsters with your air gun, or
drop rocks on them. When no
monsters are left on screen,
the game continues at the next
level, harder than before!

You start the game with three
turns (notice you have two
helmets "in reserve" in the
lower left corner). Your turn
ends when you are caught by a
monster or hit by a falling
rock. The game ends when you run
out of turns. Press the DISC to
play again.

MONSTERS:
---------
There are two types of monsters;
Pooka and Fygar. They are easy
to tell apart since Fygar
breathes fire. If you are in the
same tunnel with them, they'll
attack. If they catch you, your
turn is over!

If you don't go after them
quickly, watch out, because they
will come after you! Pooka and
Fygar cannot dig tunnels, but
they can become GHOSTS and pass
right through the ground,
directly toward YOU! Once they
pass into a tunnel, they become
solid again.

AIR GUN:
--------
So how can you defend yourself?
Your main weapon is your air gun.
Press any SIDE ACTION KEY to
shoot your air hose in the
direction you are facing. If you
hit a monster, keep pressing a
SIDE ACTION KEY to inflate him.
You can pump the key a couple of
times to stun the monster,
letting you walk right past him,
or you can keep pumping or hold
the key down to inflate the
monster until he pops.

ROCKS:
------
Another way to stop a monster is
to drop a rock on him. Tunnel
underneath a rock when a monster
is chasing you. If you're
tunneling upward, make a sharp
turn just before you reach the
rock and let it fall on him! If
you're tunneling sideways, time
it so that the rock falls just
as the monster runs underneath.

With good timing you can drop a
rock on two or more monsters for
big points! You can even drop a
rock on a monster while he is a
ghost! Be careful! You can
accidentally drop a rock on you!

VEGETABLES:
-----------
Now and then, a vegetable will
appear in the center of the
earth for several seconds.
Gobble it for extra points!

HIGHER LEVELS:
--------------
When no monsters are left on the
screen, the round is over. The
game continues with new monsters
at a more difficult level. The
round number is shown in the
upper right corner.

SCORING:
--------
Your score is shown in the upper
left corner. Your high score so
far (since pressing RESET) is
shown at top center. You earn
points in the following ways:

1. Burrowing: Each chunk of dirt
you dig is worth 5 points.

2. Popping Monsters: How many
points you earn for blowing up
Pooka and Fygar depends on how
deep in the earth you are. On
the surface or top layer you
earn 200 points. In the middle
layer you earn 300 points. In
the bottom layer, you earn 500
points.

3. Popping Fygar from the Side:
Since this is much more
dangerous (Fygar breathes fire
left and right!), you earn
DOUBLE the points listed above.

4. Dropping Rocks: The more
monsters you hit with one rock,
the more points you get! 1,000
for 1 monster, 2,500 for 2
monsters, 4,000 for 3 monsters,
and 2,000 points for each one
after that!

5. Picking up Vegetables: The
carrot in Round 1 is worth 400
points, the turnip in Round 2 is
worth 600, and the mushroom in
Round 3 is worth 800. In higher
rounds, you will find zucchinis,
tomatoes, and other vegetables.
How much are they worth? Gobble
'em and find out!

6. Extra Turns: You earn an
extra turn at 10,000 points,
40,000 points, and every 40,000
points thereafter.

//==============================
// DINER
//==============================
$13EE56F1
DINER
(c)1987, 1998 INTELLIVISION
PRODUCTIONS, INC.

He's back! Peter Pepper, that
brave chef who will face any
ordeal to get the lunch done,
has taken on the task of short
order cook at Ray's Diner.

Unfortunately, there's some
Rotten Food in the diner
(probably spoiled when it was
still Baby Food) -- Hot Dogs,
Cherries, Bananas, and their
leader Mugsy, the Mug o' Root
Beer!

The Rotten Food has thrown lunch
all over the diner -- Meatballs,
Lettuce Heads, Rice, Mashed
Potatoes, and Macaroni are
everywhere! Peter Pepper has to
get lunch back on the plate
before the Rotten Food gets HIM!

CONTROLS:
---------
DISC - Move Peter Pepper
SIDE BUTTONS - Shake pepper
[1-4] - Difficulty (4=hardest)
Press 1+9 together - Pause

Press ENTER to start game.

GAME PLAY:
----------
You control Peter Pepper by
pressing the hand controller
DISC. Run around Ray's Diner,
kicking Food Balls down the
ramps to the plate at the bottom
of the screen. Avoid the Rotten
Food -- Hot Dogs, Bananas,
Cherries, and Mugsy. If they
catch you, your turn is over!

Save yourself by squashing them
under rolling Food Balls,
shaking pepper on them, or
running away! And watch your
step! In some parts of the diner,
the floor is constantly moving,
opening up holes that you might
fall through (ending your turn)
or that might whisk you -- or
Rotten Food -- up and down.

When you've kicked all the Food
Balls onto the plate, you do the
Peter Pepper victory wave and
the game continues in a diff-
erent part of the diner, harder
than before! Complete 4 plates
and go to the Blue Plate Special,
an all-you-can-eat bonus round!

FOOD BALLS:
-----------
Food Balls (red Meatballs, green
Lettuce Heads, white Rice, tan
Mashed Potatoes, and yellow
Macaroni) are scattered through-
out the diner. Walk into one to
kick it -- BAM! -- 50 points.
The Food Ball will roll across
the floor, down ramps, and over
ledges. If it's close enough to
the bottom of the screen, it
will roll right onto the plate.

You have to wait till the Food
Ball stops rolling before you
can kick another. If a piece of
Rotten Food gets in the way of a
rolling Food Ball, SQUISH! --
good-bye Rotten Food, hello 500
points! Squash more than one
piece of Rotten Food with the
same roll and the points
multiply -- 1,000 points, 2,000
points, up to 8,000 points!

There are always five pieces of
Rotten Food in the diner. After
you squash one, it will get up
after a moment and start chasing
you again!
  
PEPPERING:
----------
Sometimes you just can't avoid
Rotten Food -- that's why you're
carrying pepper! One shake of
pepper momentarily stops Rotten
Food in its tracks, giving you a
chance to get away! It's safe to
touch Rotten Food after it's
been peppered, but be careful!
It will start moving again at
any second!
    
To shake pepper, press any SIDE
BUTTON on the hand controller.
Peppering takes a little prac-
tice -- the pepper sprays ONLY
in the direction you are facing.
If Rotten Food is chasing you,
you will have to TURN AROUND to
pepper it. A well-timed shake of
pepper can stop more than one
piece of Rotten Food. 

Use your pepper carefully. You
start the game with only five
shakes worth, although you can
get more by picking up Side
Orders. The number of peppers
you have left is shown by the
number in the upper right corner.

SIDE ORDERS:
------------
As the plate fills at the bottom
Side Orders will appear in the
diner -- Ice Cream Sundaes,
Cans of Pop, and Hamburger Buns.
Pick up a side order for 250
points and an extra shake of
pepper! And the more Side Orders
you pick up, the more Food Balls
will appear in the Blue Plate
Special bonus round!

TAKING TURNS:
-------------
You start the game with five
turns. Your turn ends when you
fall through the floor or are
caught by Rotten Food. The
number of turns you have left is
displayed in the upper left
corner of the screen. You earn
an extra turn each time you
score 20,000 points. 
    
HIGHER LEVELS:
--------------
Each time you complete a plate,
you move to a different part of
the diner and the game play
becomes harder. The level you
are on is shown by the number in
the lower right corner.

THE BLUE PLATE SPECIAL:
-----------------------
Every time you fill four plates
(finish four game screens) you
play the Blue Plate Special
bonus round! Food Balls start
raining across the screen -- all
for you! Each one you eat (just
run into it) is worth 1,000
points! The number of Food Balls
that appear is determined by how
well you did picking up Side
Orders on the previous 4 screens.
    
Just one warning: DON'T EAT THE
FLASHING FOOD BALLS! If a
flashing Food Ball hits you, not
only is the Blue Plate Special
over, you LOSE A TURN! If you
don't have any more turns left,
THE GAME IS OVER!

THE MENU AT RAY'S DINER:
------------------------
CHEF'S SPECIALS-Made Fresh Daily
--------------------------------
Turns, Start of Game           5
Peppers, Start of Game         5
Extra Turn      Every 20,000 pts
Extra Pepper w/Every Side Order!

FOOD BALLS-Our Exclusive Recipe!
--------------------------------
Red Meatballs             50 pts
Tan Mashed Potatoes       50 pts
White Rice Balls          50 pts
Green Lettuce Heads       50 pts
Yellow Macaroni           50 pts

ROTTEN FOOD-At Least We Admit It
--------------------------------
Squash Hot Dogs, Bananas,
Cherries or Mugsy:
  One Rotten Food        500 pts
Squashed Together:
  Two Rotten Foods     1,000 pts
  Three Rotten Foods   2,000 pts
  Four Rotten Foods    4,000 pts
  Five Rotten Foods    8,000 pts

SIDE ORDERS- Complete Your Meal!
--------------------------------
(+1 Extra Pepper with each)
Cup of Coffee            250 pts
Hot Fudge Sundae         250 pts
Double Thick Malt        250 pts
Can of Soda Pop          250 pts
Hamburger Bun            250 pts

BLUE PLATE SPEC.-All You Can Eat
--------------------------------
(Available After Every 4 Plates)
Non-Flashing Food Ball: 1000 pts
Flashing Food Ball:
 END OF SPECIAL & LOSS OF 1 TURN

//==============================
// DWARVEN MINE
//==============================
$C0005B4B
DWARVEN MINE
(c)2018 JEPH STAHL BASED ON THE
BOARD GAME DIAMANT BY ALAN MOON
AND BRUNO FAIDUTTI

CONTROLS:
---------
[1] - Stay in mine
[2] - Leave the mine
ENTER - Lock in choice

INSTRUCTIONS:
-------------
Add up to 1-4 computer players.

Dwarves love nothing more than
mining for gems. They have the
constitution to stand up to many
dangers, but if they come across
them again, they know to close a
mine down for good.

As a dwarf miner, you head into
5 mines. In each mine you will
come across gems and dangers.
Gems are split evenly amongst
the dwarves in the mine. Any
remainders are left on the
trail. For each sequential mine
path the player will decide to
stay (1+ENT) or leave (2+ENT).
Dwarves leaving will split any
gems remaining on the path and
safely store their haul in their
chest. Dwarves staying will face
the next mine path.

The first of each type of danger
does not threaten the dwarves,
but a second of any type will
cause any dwarves in the mine to
drop their gems and leave,
abandoning the mine forever.

The dwarf with the most gems at
the end of the 5 mines is the
winner.

Occasionally, the dwarves might
come across a rare large gem.
Unable to divide the large gem,
it will only be available to the
next dwarf to leave the mine
alone. The large gem is worth 10
gems.

The contents of your treasure
chest is kept secret from your
fellow dwarves. While you are
still in the mine, you may press
down on the disc to reveal your
score. Be careful to keep the
score secret!!

The AI dwarves each have their
own strategies for winning.
Learn their intricacies to be
able to take home more gems.
Each mine has 30 possible
outcomes containing 3 of each of
the 5 dangers, 1 large gem and
small gems ranging from 2 to 17.

//==============================
// FLAPEE BIRD
//==============================
$9C7DE352
FLAPEE BIRD
(c)2015 COLLECTORVISION,
ORIGINAL GAME (c)GEARS STUDIOS

Help Mr. Flapee get home. He
must avoid dangerous pipes along
the way.

OBJECT OF THE GAME:
-------------------
Travel as far as you can without
touching any obstacles or the
ground.

CONTROLS:
---------
Use any DISC direction or any
SIDE ACTION BUTTON to flap.

//==============================
// FROG BOG
//==============================
$37222762
FROG BOG
(c)1982, 1998 INTELLIVISION
PRODUCTIONS, INC.

OBJECT OF THE GAME:
-------------------
Go for the high score by making
a frog jump off a lily pad and
catch insects with his flashing
tongue!  Flying critters float
across, high or low, anywhere on
the screen. They even reverse
direction! Jump your frog too
late and you'll miss. Jump him
too far and he lands in the pond.
You'll have to wait for him to
swim back to the pad before try-
ing again. Day or night action.
May the best "croaker" win!

CONTROLS:
---------
DISC - Jump
SIDE ACTION BUTTONS - Tongue
Skill Level:
CLEAR - Fixed arc (easy)
  [0] - Direction (medium)
ENTER - Direction+tongue (hard)
Note: Difficulty can be changed
      after game begins.
Game Select:
  [1] - Day
  [3] - Night

SELECT SKILL LEVEL:
-------------------
EASY- Frog will jump the same
way (in a fixed arc) every time.

MEDIUM- You control direction
(arc) frog will take.

HARD- You control both direction
(arc) and when frog's tongue
will flick out to catch bug.

(Use SIDE ACTION BUTTONS to
control flick of frog's tongue.)

SELECT GAME:
------------
DAY -- Two frogs, side-by-side
on lily pads. Game automatically
starts at the EASY skill level.
Game continues until sundown. As
the sun sets, you're running out
of scoring time. Game's over
when sky goes black and all bugs
have gone away. Stars come out.
Frogs sleep. Croaking sound.
  
NIGHT -- Same two frogs and lily
pads. Game automatically starts
at the MEDIUM skill level. Bugs
twinkle like fireflies. Scoring
time continues so long as the
moon shines. Game's over when
stars come out and frogs sleep.

(Games last 3 min, Day or Night)

LET'S PLAY!
-----------
GAME STARTS at once. Stay alert!
Insects will begin to fly across
your screen. They'll come high
or low, anywhere at random.

PRESS DISC to make frog jump,
flick out his toungue and catch
bugs! When you get your frog
close enough to catch a bug,
tongue will either flash out
automatically (EASY and MEDIUM)
or flash out when you press any
SIDE ACTION BUTTON (HARD). Frog
will swallow bug, earning points.

Press edges of DISC for right or
left movement. Frog will always
jump from one lily-pad to the
other each time you press the
DISC on EASY (Same arc).

For MEDIUM and HARD, you CONTROL
the frog's direction and arc as
he jumps. How far your frog
jumps depends on how long you
hold down the DISC. Tap the DISC
and your frog will jump only a
short distance. Hold the DISC
down and frog will jump for a
longer distance. With practice,
you should be able to jump your
frog across the screen to catch
a far-ranging bug, or just make
him turn around where he is and
catch a low-flying bug (he can't
catch flies with the back of his
head!).

When frog jumps too far, he
lands in the water. You MUST
WAIT for him to swim back to his
pad, before trying another jump
(No jumps from the water).

SCORING:
--------
There are 4 different kinds of
bugs. Each has a different point
value: 5, 10, 15 and 35 points.
Harder to catch bugs are worth
extra points. They fly faster
and change direction more often.
They're the small bugs.

WINNING TIPS:
-------------
1. DON'T GO IN THE WATER. Your
frog will be out of action
(can't score) if he falls in the
pond. Before you can try again,
you MUST WAIT until he swims
back to the pad.

2. AUTOMATIC TONGUE works best
when frog ISN'T on the way up or
down. In other words, time your
jump to get close to the bug at
highest or lowest part of jump.

3. MAKE UP YOUR MIND. High-
scoring bug or low-scoring bug?
Watch your running score totals.
If you need some sure points to
get back in the game, low-
scoring bugs are EASIER to catch.

4. WATCH YOUR TIME. Day or night,
game time (scoring) time is 3
minutes. Watch for the changing
sky -- from daylight to sunset
and darkness -- from full moon
at night to fading moonlight.
Changes in the sky mean you're
running out of time.

MAYBE YOU'RE NOT ALONE!
-----------------------
In the ONE PLAYER game, the
computer CAN BEAT you by working
the frog you're not using auto-
matically. A second set of score
totals will appear. Wherever a
frog is NOT jumped for 10
seconds at the start of a game
or 20 seconds during a game, the
computer will take over and jump
the frog automatically!

FINAL REMINDER:
---------------
When a game is OVER (after 3
minutes) you must press the
RESET button to bring back the
title frame. Select DAY or NIGHT
next and a new game begins.

//==============================
// FROGGER
//==============================
$D27495E9
FROGGER
(c)1982, 1983 PARKER BROTHERS

Leapin' Frogger! Home may look
like it's only a hop, skip, and
a jump away, but looks can be
deceiving. First, there's a
dangerous highway to hop across,
full of cars and trucks. Then
there's a swirling river to leap,
full of frog-eating creatures.
How's Frogger going to get home
safely? By letting you hop him
on his way. Guide Frogger safely
through this perilous journey,
and you'll jump for joy!

CONTROLS:
---------
DISC - Move Frogger
Press ENTER to start hopping.

GAME SELECTION:
---------------
Game 1- Frogger can safely float
 off-screen. Game difficulty
 increases with each 5 frogs
 brought home.

Game 2- Frogger can safely float
 off-screen. Game begins at a
 more difficult level, with
 alligators, snakes and otters.

Game 3- Frogger can't float off-
 screen. Difficulty increases
 with each 5 frogs brought home.
 
Game 4- Frogger can't float off-
 screen. Game begins at a more
 difficult level, with
 alligators, snakes and otters.

PLAYING THE GAME:
-----------------
The object of the game is to hop
as many frogs to safety as you
can -- and to score the most
points along the way! You'll
start the game with 5 frogs.
The first frog is shown on the
sidewalk below the traffic. The
remaining frogs are indicated by
a number on the lower left
corner of the screen.

TIME BAND:
----------
You have only a limited amount
of time to move Frogger from the
sidewalk and into a home bay,
one of the blue, open-ended
squares at the top of the screen.

Time is monitored by the time
band, the black line located at
the bottom center of the screen.
You have approximately 30
seconds, or 60 "ticks" on the
cartridge timer, to move Frogger
home. If you run out of time
before you get Frogger home,
you'll "splooch" him (lose him).
You'll hear a sound, then see a
skull and crossbones symbol on
the spot where Frogger was when
his time ran out.

However, if you take Frogger
home before the time band
disappears, you'll see "TIME",
and the number of "ticks" you
had left on the center of the
sidewalk. You'll score 10 points
per remaining "tick" of time.

FROM SIDEWALK TO RIVERBANK:
---------------------------
Frogger starts his perilous
journey on the sidewalk, facing
four lanes of cars and trucks.
As soon as the music starts to
play, you're ready to start
Frogger hopping!

Try to get Frogger through the
lanes of traffic. Traffic
travels in alternating direc-
tions and at different speeds,
so be careful. Frogger will get
splooched if he touches any part
of a vehicle or is run over!

FROM RIVERBANK TO RIVER:
------------------------
Because Frogger can't swim in
the river (the current is too
strong), hop him from one row of
logs, turtles, or alligators
onto the next in order to cross.

Logs-- Frogger can hop from side
to side on a log; he can also
jump forward and backward onto
another floating object. But
he'll land in the river if he
leaps left or right off a log.
 
Turtles-- The orange objects
that float in the river are the
turtles. Frogger can hop on
their backs as well as between a
set of them (2 or 3 turtles in a
row). He can jump forward and
backward from a turtle onto
another floating object. But
he'll land in the river if he
jumps to the left or right off
either of the end turtles.

Diving Turtles-- These tricky
turtles can float on the water
and dive under the water! When
they're orange, it's safe for
Frogger to jump on their backs.
But once they turn brown, watch
out! That means they're getting
ready to dive, so hop Frogger
onto another floating object
fast! If you're not quick enough,
Frogger will get "splooched".

But these turtles can't stay
underwater forever. When you see
a set of brown turtles suddenly
appear on the screen, this means
they're coming up for air.
They'll soon be changing from
brown to orange, so Frogger will
be safe on their backs until
they dive again.
 
Some other things to watch for
while crossing the river:

Pink Frog-- Occasionally you'll
see a pink "lady" frog on a log.
Hop Frogger onto the log and try
to rescue her. If you do, you'll
hear a sound, then you won't see
the pink frog. Now try to get
Frogger home to safety. When you
do, you'll earn bonus points.
 
Alligators-- There are alli-
gators hiding in the logs. But
you'll know what logs they're in
because you'll see their heads
poking out. They'll snap their
jaws open and closed, just
waiting for a tender Frogger
morsel to jump their way!
Frogger is safe on the log, but
is a goner if he jumps onto the
alligator's jaws!

Floating Off-Screen-- In levels
1 and 2, Frogger can safely
float off-screen. However,
Frogger will move slightly while
he's off-screen, sometimes he'll
even reappear floating on top of
the water! He won't get
"splooched" at this time, but
hop him to safety fast. 

Snakes-- Snakes will appear on
the riverbank as the game gets
more difficult. Don't hop him
onto any part of the snake or
Frogger will get "splooched".
 
Otters-- The river otters are
very fast swimmers, and they'll
try to grab Frogger off the end
of a log, alligator, or row of
turtles. Keep Frogger as far
away from them as possible, or
he'll get "splooched". 

FROM RIVER TO HOME BAY:
-----------------------
Successfully hop Frogger into a
home bay, and he's safe and
sound! You'll score points each
time you bring Frogger home, and
get bonus points each time you
bring 5 frogs home.

When leaping Frogger into his
home bay, here are some things
to watch for:

Jumping Home -- Hop Frogger into
a home bay when he's directly in
front of it. If Frogger hits any
part of the green shrubbery on
the sides of home bay, he'll get
"splooched".
 
Occupied Home Bay -- Frogger
can't jump into a home bay that
is occupied by another frog.

Alligator's Head -- If an alli-
gator's head is showing in a
home bay, it's not safe for
Frogger to jump in. However, if
the head is just beginning to
show, Frogger won't be harmed.
 
Fly -- If you hop Frogger into a
home bay while a fly is showing,
Frogger gets a free meal -- and
you score extra points. 

GAME DIFFICULTY:
----------------
Each time you bring 5 frogs home,
you'll hear a short tune. Then
the game will continue at a more
difficult game level with your
remaining frogs. The speed of
the cars and trucks will vary
from lane to lane. Traffic
patterns will change. There will
be fewer floating objects on the
river, and the speed of the
objects will vary from fast to
slow. Frogger-eating snakes will
appear on the riverbank and
otters will swim in the river.

END OF GAME:
------------
The game ends when no frogs are
left. To play again, press
RESET, then reselect the game
level you want and begin play.
If, at any time, the screen goes
blank, simply press the RESET
button and begin play.

SCORING:
--------
Your score is displayed through-
out the game on the bottom left
side of the screen. Points
accumulate as follows:

Jump Frogger forward      10 pts 
Jump Frogger home         50 pts 
Jump 5 frogs home      1,000 pts 
Take a pink frog home    200 pts 
Eat a fly                200 pts 
Extra time remaining  10 pts/sec

Every time you score a total of
20,000 points and have fewer
than 4 frogs left, you'll get
another Frogger! When this
happens, you'll see "EXTRA FROG"
on the riverbank.

//==============================
// GOATNOM
//==============================
$99E7B4FC
$deb4dc77
GOATNOM
(c)2016 FREEWHEELING GAMES

IT'S LOVE AT FIRST SIGHT!
-------------------------
A mean ol' farmer stands in the
way of a goat's happiness. All
year long the farmer throws
everything he can at the goat to
dissuade him. If the goat can
survive all four seasons, true
love awaits. Intellivoice
enhanced!

CONTROLS:
---------
DISC - Move
SIDE ACTION BUTTONS - Kick

HOW TO PLAY:
------------
As the goat, you must eat as
much "good stuff" as you can,
avoiding the black objects and
kicking them when possible. Move
using the DISC, and kick using
the controller's ACTION BUTTONS.

Spring -- Eat fish, cans and
shirts. Kick or avoid rocks.

Summer -- Eat popsicles, hot
dogs and bananas. Kick or avoid
old tires.

Fall -- Eat pumpkins, apples and
skulls. Kick or avoid hammers.

Winter -- Eat stockings, candy
canes and yellow snowballs. Kick
or avoid deadly grenades.

The Nom meter fills up as you
eat and kick objects. When
objects get past you, though,
the meter empties. Fill up the
meter to complete one season and
move on to the next.

Objects speed up as the meter
starts to get full, and the
Farmer's Almanac says winter
will be brutal, so keep those
feet moving!

HOW TO WIN:
-----------
A full game consists of all four
seasons. Your total time will be
displayed on the screen when the
game is over. Can you stay alive
for a full year and reunite with
your sweetheart?

//==============================
// GRAIL OF THE GODS
//==============================
$ef662b2b
GRAIL OF THE GODS
(c)2018 OSCAR TOLEDO GUTIERREZ,
GRAPHICS BY KIWI, SOUND EFFECTS
BY ARTRAG, MUSIC BY NYUUNDERE,
INSTRUCTIONS BY MTHOMPSON

Seek the Grail Of The Gods
through ten randomly generated
levels. Battle fourteen monsters,
from the lowly rat to the mighty
dragon. Discover twenty-five
different weapons and armors.

(Note: JLP support required)

CONTROLS:
---------
DISC - Move in 4 directions

GAMEPLAY:
---------
The dungeon is revealed as you
move through it. Get too close
to a monster, and it's a fight
to the death! Your sword and
armor degrade with use, so be
sure to find replacements. Shiny
gold adds to your wealth and
experience. Avoid deadly traps,
and drink the healing potions on
each level. Look for the Grail
on level 10.

GAME SCREEN:
------------
DP = Dungeon Depth
LV = Experience Level
XP = Experience Points on the
  current level, listed as N/M
  where N is how many points you
  currently have and M is the
  required number of points to
  gain one level in experience
GD = Gold
AT = Attack Level
AR = Armor Level
HP = Hit Points

You get one experience point
every time you kill a monster or
pick up some gold. When you gain
a level of experience, the
counter is reset, but the goal
is higher.

AT indicates the quality of the
weapon you currently are using.
AT and AR are reduced to zero as
you are fighting; therefore, you
need to pick up new armor and
weapons regularly.

Hit points start at a high
number (increasing as you gain
experience levels) and are
reduced every time a monster
hits you. If you drink a healing
potion, your hit points are
restored to the highest possible
at the experience level you
currently are at. If you already
have maximum hit points for your
experience level, you won't see
a difference. When you're below
zero hit points, you are dead,
and the game is over.

//==============================
// HAPPY TRAILS
//==============================
$4B8C5932
$120b53a9
HAPPY TRAILS
(c)1983 ACTIVISION

Black Bart's robbed the
stagecoach! He's headed for the
Badlands, and you've got to
track him down. But first, learn
the laws of the West: blaze a
trail to the moneybags by
arranging the maze, and git
deputized by collecting the
sheriff's badge. Then, go out
and round up Black Bart!

CONTROLS:
---------
DISC - Move trail panel
TOP SIDE BUTTONS - Travel faster
LOWER SIDE BUTTONS - Reverse dir
[1-8] - Game type

Press DISC to start game.

GAMES:
------
Each Happy Trails game variation
has 16 sizes of trail mazes to
travel on. The first maze is the
smallest. Starting with the 17th
maze, trail size starts over,
but you'll move at a faster pace
and the trail patterns will be
tougher to solve.

Game 1: Standard trails
Game 3: Random trails
Game 5: Fast standard trails
Game 7: Fast random trails

The game selected will start
automatically. To change the
game level, press CLEAR and then
select the game level desired.

SCORING:
--------
Moneybag/Sheriff's badge  100pts
1st Black Bart capture/
  collision in any round  300pts
Moneybag after 1st Black
  Bart captured           200pts
2nd Black Bart capture/
  collision in any round  600pts
Moneybag after 2nd Black
  Bart captured           400pts

Each bonus moneybag is worth the
Bonus Timer amount at the end of
each round. After eight bonus
moneybags are earned, additional
bonus moneybags are worth 50 pts

SPECIAL FEATURES:
-----------------
1. The Sheriff's Badge. You can
only catch Black Bart after
you've been deputized. The red
sheriff's badge gives you this
power (and points) when you move
over it. Once you start blinking
move fast! This power won't last

2. Losing Your Hats. You begin
with one hat on the trail and
three in reserve. It'll cost you
a hat each time you blaze into a
dead end or the black space.
You'll also lose a hat if you
run into Black Bart without
being deputized or if the bonus
timer runs down to -0- while a
moneybag or sheriff's badge is
still on the screen. The game
ends when all your hats are gone.

3. The Bonus Timer is at the
bottom right corner of the
screen. It starts at 500 and
counts down to -0-. When it
reaches 100, you'll hear the
warning buzzer. Hurry! Don't let
it reach -0- before you've
collected the moneybags and the
sheriff's badge.

4. Bonus Hats. A bonus hat
appears after you earn your
first 10,000 points, and then,
with each 20,000 points there-
after. You can only have six
reserve hats on the screen at
any one time.

GETTING THE HANG OF HAPPY TRAILS
--------------------------------
To be a bountiful trailblazer,
you've got to watch where you're
going -- BEFORE you get there.
So, don't start the action until
you've taken the time to study
the upcoming terrain. This study
time before each round will help
your pattern recognition, and
you'll soon be blazing your way
through even the most complex
mazes.

Also, you'll find that you can
slide a panel while your hat is
on it. Practice this technique.
It can get you out of some tight
spots and will save you time.

HOW TO BLAZE A HAPPY TRAIL:
---------------------------
Tips from Carol Shaw, designer
of Happy Trails.

To really play well, you'll need
three things: patience, practice
and planning. Here are some
specific pointers that can help:

1. Use the reverse button to
avoid dead-ends, the black space
or Black Bart. But to really
take advantage of this feature,
use the reverse button to move
your hat back and forth over a
'safe' area, while you're busy
rearranging the trail.

2. Once a trail is cleared, use
the speed button to move quickly.
By saving time, you'll earn more
bonus points and reduce the
chances of the Bonus Timer
reaching zero.

3. As you arrange your trail,
keep in mind that you are also
arranging Black Bart's trail.
Occasionally, you might like to
hold Bart hostage by making him
walk in a circle, so you can
plan your next move.

//==============================
// HELI
//==============================
$906989e2
H.E.L.I.
(c)2020 CARLOS MADRUGA,
INTELLIVISIONREVOLUTION

Volcanic activity has trapped
miners miles underground.
R. Heli, leader of Helicopter
Emergency Livesaving, Inc.
(H.E.L.I.), must navigate the
tricky maze of mineshafts to
save as many of them as he can.
He'll maneuver with his Prop-
pac, zap creepy critters with
his Microlaser Beam, and
demolish walls with dynamite.
Magma deposits and lava rivers
will block his path. If he can
rescue the miners on all 23
levels before his power runs
out, he'll be a true hero!

SELECT GAME OPTIONS:
--------------------
At the title screen, use the
DISC to choose the options for
playing your game of H.E.L.I.
Press a TOP ACTION BUTTON to
lock in your selection.

ENTER CODE: Use the keypad to
enter a code for alternate game
modes(see ALTERNATE GAME CODES).

SETTINGS: Use the DISC to choose
difficulty (Easy, Normal, Hard)
and music On/Off plus volume.

When you are ready to begin the
mission, select START and press
a TOP ACTION BUTTON.

CONTROLS:
---------
DISC - Move/fly
TOP SIDE BUTTONS - Laser
LOWER SIDE BUTTONS - TNT
CLEAR - Pause game
ENTER - Exit menu

In Trainer Mode:
[7] - Screen forward
[8] - Lights on/off
[9] - Screen back
[0] - Abort

HOW TO PLAY:
------------
Activate the Prop-pac and fly
R. Heli through the mineshafts.
Press up on the DISC to fly up,
and press left or right to fly
left or right, or to run.

Zap enemies with the Microlaser
Beam by pressing a TOP ACTION
BUTTON. Hold for continuous
fire. The Beam can destroy walls
too, but it takes some time.

Set TNT charges by pressing a
BOTTOM ACTION BUTTON. Move away
quickly so you don't get caught
in the blast! Destroy walls or
generate a flash of light. You
get six sticks of dynamite to
use in each level.

Traverse lava lakes with rafts
when they're available.

MEET THE MINESHAFTS:
--------------------
Mineshafts extend both horizon-
tally and vertically deep into
the mountain. Some dead end, and
others are blocked by walls.
Some walls and surfaces glow red
with molten lava. They're as
deadly as the spiders, bats,
moths, and snakes that inhabit
the mine. You'll either have to
blast them or avoid them.

Lanterns light the way in some
areas. If you touch or shoot
them, the shaft goes dark!
Setting off a stick of dynamite
is the only way to create some
momentary light to help you find
your way.

You must locate a miner on each
level before moving deeper into
the mine. The deeper you go, the
more dangerous and numerous the
challenges become - and the
harder it gets to find the
miners.

Move quickly! If your power runs
out before you rescue a miner,
you'll lose one of your reserve
lives. When they're all gone,
the game is over. You've saved
the day when you've rescued the
last miner on level 23.

SCORING:
--------
Shoot a Critter           50 pts
Surplus Dynamite Sticks   50 pts
Destroy a Wall            75 pts
Surplus Power        50 pts/unit

An extra life is awarded after
completing levels 5, 10, 15 & 20.

ALTERNATE GAME CODES:
---------------------
[1002] Trainer Mode
  Practice with invincibility
  and unlimited TNT charges

[1225] Christmas Mode
  Play as Santa and rescue
  Rudolph before the temperature
  drops too much. Watch out for
  goblins!

[1610] Bottoms Up Mode
  Start at the end of the mine
  and work your way back to the
  start

[1979] Dark Mode
  Lights go out quickly after
  you enter each mineshaft

[2600] Stella Mode
  Gives the game a retro look

[1927] Plimpton Mode
  Activates Stella mode on every
  other level of the mine

[4321] Alternate Logo
  Modify title screen game logo

Enter "0000" to remove all
previously entered codes. Note:
You can combine modes by enter-
ing multiple codes in succession.

TIPS FOR SUCCESS:
-----------------
1. The dynamite R. Heli carries
is potent. He doesn't need to be
right next to a wall to blow it
up.

2. If R. Heli runs out of dyna-
mite, he can eliminate walls
with the Microlaser Beam. The
closer he stands to the wall,
the faster he'll break through.

3. A TNT charge set off next to
a pit can both open a new pas-
sage and clear out vermin below.

4. When flying above a lava
river, ride the ceiling by
pressing the DISC up as well as
left or right.

5. Ride rafts whenever possible
since it is easier than trying
to go under a lava ceiling.

//==============================
// ISTAR
//==============================
$8ae91ade
ISTAR
(c)2010 DAVID AKERS

This game started out as a set
of programs called DSTAR for the
TI graphical calculators created
by Joe Wingbermuehle and Andrew
Von Dollen. The Intellivision
conversion includes the twenty-
five "classic" levels from the
TI-83 calculator version, plus
eleven all new levels.

CONTROLS:
---------
DISC - Move
[7] - Select level
[9] - Press while playing the
 game to switch to level editor.
 You can edit your own level and
 test it out. Unfortunately
 there is no way to save your
 level.

//==============================
// JR. PAC-MAN
//==============================
$613e109b
JR. PAC-MAN
(c)2017 INTELLIVISIONREVOLUTION

LEADER OF THE PAC! The stork
makes a special delivery to Mr.
and Ms. Pac-Man, and before you
know it, Junior is out exploring
the world on his own. He meets
Yum-Yum, the love of his life.
Will Blinky succeed in keeping
them apart? Only time will tell
if these kids can get together.

CONTROLS:
---------
DISC- Move Junior
TOP SIDE BUTTONS - Start/Select
LOWER SIDE BUTTONS - Play sounds
Press 1+9 together to pause game

OBJECT OF THE GAME:
-------------------
Guide Junior through a series of
mazes, evading the ghosts while
eating all the dots, power pills,
and prizes to earn the highest
possible score.

SELECT OPTIONS AND MODE:
------------------------
When the game menu appears, use
the DISC and ACTION BUTTONS to
select game options and modes.

OPTIONS
-------
Bonus -- Extra lives can be
awarded at either 10,000,
15,000, 20,000, or 30,000 points,
just like the arcade!

Lives -- Start with 1-5.

Fast Jr. -- Turn on this option
to give Junior a speed boost!

Level -- Select standard or
extra mazes. Both come either
with or without ice and snow!

Start Level -- Choose which of
the game's 7 mazes to begin play.

Sound Test -- Play each of the
game's sound effects.

MODES
-----
Choose the number of players.
Then select the game's start
mode. Choose either the original
arcade screens, the Atari title
screen, or Mattel title screen.
Then press one of the control-
ler's Action Buttons to begin.

Whichever mode you choose, be
sure to watch the story of
Junior's arrival before you
press the ACTION BUTTON again to
start playing!

THE MAZES:
----------
Junior starts each level near
the center of the maze. The dis-
play at the top of the screen
shows the current score. The
bottom of the screen shows num-
ber of lives in reserve. Level
number is shown in brackets.

As Junior moves through the maze,
gobbling up the dots in his path,
the screen will scroll horizon-
tally and vertically. Clear the
maze of all its dots to move on
to the next level. But watch out
for the four ghosts, Blinky,
Pinky, Inky, and Tim. If they
catch Junior, you lose a life!

When Junior eats one of the
large power pills, the ghosts
turn blue for a short time and
Junior can gobble them up for
points. The higher the level,
the shorter the time the ghosts
stay blue!

SCORING:
--------
For every item Junior eats,
points are awarded. Extra lives
are earned at scores determined
by the bonus option selected
before the game.

Dot                       10 pts
Donut                     50 pts
Power Pill                50 pts
1st Ghost                200 pts
2nd Ghost                400 pts
3rd Ghost                800 pts
4th Ghost              1,600 pts

BONUS ITEMS:
------------
Each level has a unique bonus
item that moves across the maze.
Listen for the bonus item sound
to know when it appears in the
maze. Each prize is worth a
different number of points when
Junior runs into it.

Level 1    Tricycle      100 pts
Level 2    Kite          200 pts
Level 3    Drum          500 pts
Level 4    Balloon       700 pts
Level 5    Train       1,000 pts
Level 6    Kitty       2,000 pts
Level 7+   Root Beer   5,000 pts

When a bonus item touches the
dots, it transforms them into
donuts, which score more points
but slow Junior down as he's
eating them. If the bonus item
touches a power pill, however,
they'll both be destroyed! So
don't let the bonus item move
across the maze for too long!

HIGHER LEVELS:
--------------
As you clear mazes and move from
one level to the next, the
game's difficulty increases.
Eating power pills will have
less of an effect on the ghosts.
You'll notice that they'll turn
blue for shorter and shorter
periods of times before flashing
and returning to their original
colors and behaviors.

The maze layouts become more
challenging, with more places to
get trapped by the ghosts.
Levels 6 and 7 have only four
power pills instead of the usual
six. When you pass level 7, the
mazes cycle back to maze number
4 in a repeating loop. From then
on it's a race to see how many
points you can accumulate before
your lives run out!

After you've tried your luck
with the standard arcade mazes,
see how well you can do with the
7 extra mazes that are included
in this edition of Jr. Pac-Man!

TIPS FOR SUCCESS:
-----------------
1. Eating dots slows Junior down,
and eating donuts slows him even
more. When you need speed, head
for the corners and empty parts
of the maze.

2. Power pills are good for more
than scoring points. They make
the ghosts change direction when
you need them to!

3. Each ghost has a unique
personality and behavior. Get to
know them so you can outsmart
them!

4. Listen to the game sounds.
They'll let you know what's hap-
pening in parts of the maze that
aren't visible on the screen.

5. Let the bonus objects trans-
form the dots into donuts for
awhile so you can gobble up
extra points.

6. Keep Junior moving to stay
ahead of the ghosts. Anticipate
turns and press the DISC early
for fast and efficient cornering.

//==============================
// KILLER BEES+
//==============================
$53BC0939

KILLER BEES+
(c)2018 CARLOS MADRUGA

Objective is to move your white
bee swarm and get on top of the
red/blue walkers to kill them.
Doing that will activate a
single killer ray shot that can
be fired with a button. Other
bee swarms and zombie walkers
will try to kill you.

CONTROLS:
---------
DISC - Move white bee swarm
ANY SIDE BUTTON - Killer ray

HOW TO PLAY:
------------
Advance through the game by
killing all walking robots that
appear on each level. You
control a white bee swarm, and
can kill those robots by moving
on top of them. Attack is
automatic.

Avoid or kill enemy bees by
using the killer ray, which is
armed by killing robots. You get
one shot, then need to rearm
again. Aim well!

Doors open and close randomly.
Use them to teleport around.
Beware: enemy bees will always
respawn in front of open doors.

Sometimes dead robots will rise
as green zombies. Don't touch
them. They can be temporarily
neutralized by the killer ray.

Power up pills will replenish
health, increase your speed or
arm the killer ray immediately.

//==============================
// LADY BUG
//==============================
$A6840736
LADY BUG
(c)1981 UNIVERSAL CO. LTD.,
(c)1983 COLECO INDUSTRIES, INC.

GAME DESCRIPTION:
-----------------
Lady Bug gobbles her way through
a maze. Suddenly a starving
insect charges after her! Use
turnstiles to change the maze
and block the predator's pursuit.
But remember to avoid deadly
pesticide skulls. Lady Bug earns
points by eating flowers, hearts
and vegetables and by spelling
the word 'EXTRA'. How many
points can you rack up before
the predators catch Lady Bug?

CONTROLS:
---------
DISC - Move Lady Bug
[1-4] - Select skill level
(You will receive five Lady Bugs
in Skill Level 1 and three Lady
Bugs in all other skill levels)

Press ENTER to start.

ENTER THE LADY BUG:
-------------------
Press Enter and a screen appears
with the letters and number of
hearts and skulls you will find
in the maze. Lady Bug glides in
and stops below the bug box.
You're ready to begin.

THE FEAST:
----------
Move Lady Bug through the maze.
She's a hungry sort, eating as
many flowers, hearts and letters
as she can find. Watch the color
of the hearts and letters Lady
Bug eats. Red hearts and letters
are worth the most!

MULTIPLY YOUR SCORE:
--------------------
Eat one blue heart and double
your score for the rest of the
play level. Eat another blue
heart and your score triples.
Eat a third and your score will
be multiplied by five! Keep an
eye on the Score Multiplier
Indicator to see how fast your
score will grow.

EXTRA!
------
Each maze features two letters.
Eat the letters when they're
yellow to spell the word 'EXTRA'
in the EXTRA Indicator. When you
spell 'EXTRA,' you automatically
finish the maze and earn a bonus
Lady Bug.

THE CHASE BEGINS!
-----------------
When the timing border changes
color completely, a predator
insect leaves the bug box to
chase Lady Bug. Avoid predatory
insects by steering Lady Bug
through the turnstiles. But be
careful. If a predator follows
Lady Bug closely enough, it can
slip through the turnstile and
catch her!

USE YOUR SKULL:
---------------
Let Lady Bug guide the predatory
insects into the fearsome skulls.
The skulls eliminate predators
on contact. But keep Lady Bug
away from the skulls. If she
touches one, she is eliminated
along with all of the skulls!

A VEGETABLE SNACK:
------------------
After all the predatory insects
have left the bug box, a
vegetable appears there. Guide
your Lady Bug into the box for a
feast of points! But remember,
if a predatory insect is
eliminated by a skull, the
vegetable is immediately
replaced by the eliminated
insect. Afer the timing border
changes color again, that insect
emerges from the bug box to
chase Lady Bug once more!

GOING TO A NEW MAZE:
--------------------
When Lady Bug has eaten all the
flowers, hearts and letters in
the maze, another full maze
appears for more action!

SCORING:
--------
Flower                    10 pts
Blue Heart or Letter     100 pts
Yellow Heart or Letter   300 pts
Red Heart of Letter      800 pts
Spell 'EXTRA'            800 pts
(Plus a bonus Lady Bug)
First Vegetable        1,000 pts
Each Thereafter     500 pts more 

THE FUN OF DISCOVERY:
---------------------
This instruction booklet will
provide the basic information
you need to get started playing
LADY BUG, but it is only the
beginning! You'll find that this
cartridge is full of special
features to make LADY BUG
exciting every time you play.
Experiment with different
techniques - and enjoy the game!

//==============================
// LOCK 'N' CHASE
//==============================
$E00D1399
$5C7E9848
LOCK 'N' CHASE*
(c)1982, 1998 INTELLIVISION
PRODUCTIONS, INC.
*TRADEMARK OF DATA EAST USA, INC

OBJECT OF THE GAME:
-------------------
Your thief's robbing a local
bank. Police are in hot pursuit!
Make tracks down the vault
corridors. Swipe gold coins and
other treasures as you go! Keep
one step ahead of the law! Lock
doors and throw cops off your
trail! Collide with a cop and
he's "caught"! Keep on the run!

CONTROLS:
---------
DISC - Move Lupin
ANY SIDE BUTTON - Lock a door

Playing Speed:
DISC = Fastest (White)
 [3] = Fast (Red)
 [2] = Medium (Green)
 [1] = Slow (Blue)

A dot in the upper right corner
of the screen indicates which
speed you choose. The color of
the dot matches the speed button.

Press ENTER to start game.

HOW TO PLAY:
------------
After a moment's delay, Lupin
automatically enters the vault.
The escape doors lock shut! He
can't go through either escape
door until all the gold coins
are picked up. The four police
officers begin to chase him down! 

Lupin can dodge police by
running through the open side
doors. When he exits through one
side, he quickly enters on the
other side. Be careful! Don't
run smack into a policeman on
the other side! 

Note that there are four side
doors, but only TWO are open at
a time! Sometimes the top two
are open, and sometimes the
bottom two are open. This
changes at random so watch out. 

Your thief picks up gold coins
as he runs. Once Lupin has
gotten all the gold coins, run
him through the top or bottom
escape door! You foiled the
cops! Play begins again with a
whole new set of gold coins to
pick up! Points are mounting! 

Sometimes "treasures" appear in
the center of the screen. You
have to land on these fast, they
only appear for a short time! 

If Lupin collides with police,
he'll be caught! Action stops
and your next thief enters the
vault. The game ends when all of
your thieves are "caught".
 
RULES OF THE CHASE:
-------------------
LOCK DOORS-- Automatic doors are
constantly locking and unlocking
in the vault. They are solid
green when locked and disappear
when unlocked. Police and Lupin
can't get through these doors
until they unlock and disappear.

Give the cops the slip by lock-
ing doors behind you! To do this,
press any SIDE BUTTON, and the
last door Lupin came through
locks shut! These doors are red.
You can only lock two doors at a
time. After a few seconds, the
doors automatically unlock.
Doors lock horizontally or
vertically at the "light" lines
in the corridors. Try not to run
into a locked door, as you might
stick to it!

THE THIEVES-- You start with 5
thieves. Only one is in the
vault at a time. Maneuver Lupin
and try to give cops the slip!
After one thief is caught,
another enters the vault. The
number of thieves you have left
shows on the screen. When your
last thief is caught, the jig is
up, and the game ends!

THE POLICE-- 4 police officers
are constantly tailing Lupin!
Sometimes you can run right
through one. But you never know
when this will happen!

THE MONEY-- There are gold coins
throughout the vault. Pick them
up and your scores rises. When
the cash bag or one of the ten
treasures appears on the screen,
run over it quickly! When Lupin
grabs the loot, the screen shows
how many points you got.

TIPS:
-----
1. You can lock Lupin behind
doors to keep the cops away.
Hope they move on and you can
escape when the door unlocks!

2. The police can come through
the open side doors too...so
don't stay around these areas!

3. You can set the speed for the
next game and at the same time
keep the high score from the
last game. Do this at the end of
game by pressing 1, 2 or 3 for
the slow speeds or press any
SIDE BUTTON for fastest speed.
[NOTE: A bug in the program
keeps this from working properly.
Pressing a SIDE BUTTON will re-
play the game at the SAME speed
instead of FASTEST. There is no
way to go from a slower speed to
the fastest while keeping the
high score.]

4. When the police are tailing
close in any of the four corners,
try to trap them in the corner
by locking a door behind and in
front of him. Get extra points
for this!

SCORING:
--------
Each gold coin            20 pts
Lupin can pick up 4 cash
bags in each vault:
  1st cash bag           500 pts
  2nd cash bag         1,000 pts
  3rd cash bag         2,000 pts
  4th cash bag         4,000 pts
Treasures:
  1st Vault (Hat)        200 pts
  2nd Vault (Crown)      300 pts
  3rd Vault (Briefcase)  500 pts
  4th Vault (Phone)      100 pts
  5th-10th Vault (?)     ??? pts
Extra Thief     Every 20,000 pts

When you get 100,000 points, the
game automatically sets up at
the highest speed! Once you get
300,000 points, the scoring
begins at zero again. At the end
of each game you will see a
number under the center score.
[NOTE: A bug in the program
keeps this number from showing
up in a 1-player game]. This
tells you how many times you
have reached 300,000. You can
reach 300,000 a total of 200
times...for a possible score of
60 million! Good luck! 

//==============================
// LOCO-MOTION
//==============================
$6B6E80EE
LOCO-MOTION*
(c)1982, 1998 INTELLIVISION
PRODUCTIONS, INC.
*TRADEMARK OF KONAMI INDUSTRY CO

Are you ready? START YOUR
ENGINE! You're in the engineer's
seat with full control... or so
you think! This railway chal-
lenges you with troubles galore!

OBJECT OF THE GAME:
-------------------
Score as many points as possible
by arranging track sections and
routing the Train to pick up
passengers at the stations.
Don't delay or they get angry,
riot and blow up stations! Avoid
Crazy Train or Loop Sweeper
collisions -- they're out to get
you! And Crazy Tracks side-track
you off in another direction!
Panic at the wrong time and it
may hurt! You have 3 Trains...
keep playing until you lose all
3! Pick up all passengers on a
screen and a new screen appears,
with an even greater challenge!

CONTROLS:
---------
DISC - Switch track pieces
ANY SIDE BUTTON - Accelerate
ENTER - Panic

CHOOSE YOUR SPEED:
------------------
When game title appears, choose
your playing speed. For fastest
speed possible, press DISC. The
1, 2 and 3 buttons give you
slower speeds (3 is slowest).

Press DISC to start game. Press
ANY SIDE BUTTON for autoplay.

ALL ABOARD!
-----------
There are between 8 and 12 train
stations along the edges of the
screen. With each new screen,
there are passengers waiting at
each station (shown by a pair of
faces, some happy and some not
so happy!) A YELLOW light speeds
in front of your Train, indi-
cating the route you are taking.
When passengers see that they
are on your route, they become
happy, but change your route and
they become angry until they see
the YELLOW light.

You arrange those sections of
track on which your Train will
roll. Hurry to pick up all the
passengers! Stay alert! Don't
run out of railway! Use the DISC
to SWITCH pieces of track into
the empty space!

Press the PANIC BUTTON to avoid
crashing into any TRAIN STOPS!
Panic at the right time and it
can help!

To complete a screen, you must
pick up passengers at all of the
stations; if any of the stations
have blown up, you are awarded a
CLEAR after you complete the
screen. If you are diligent and
do not allow any stations to
blow up, you are awarded a
PERFECT CLEAR. Sound easy? This
is the least of your worries!

STATION REWARD:
---------------
After some time, passengers
waiting at a station get rest-
less. They offer a reward
(BONUS points) if you hurry over
to pick them up. Sometimes this
reward is offered even after the
passengers have been picked up.
Listen for the sound of a horn
and watch for the BONUS display
on the screen. This reward
decreases with time and if you
let it go to zero, one of two
terrible things can happen!

1. The people at the station
riot and blow up the station!

2. The people construct a CRAZY
TRAIN (a real "Loose Caboose")
that comes chasing after you!

If you crash into a CRAZY TRAIN,
that "Loose Caboose" will cost
you a Train! Watch out for that
bunch! And that's not all!
Stations are also blown up if a
CRAZY TRAIN crashes with another
CRAZY TRAIN or a LOOP SWEEPER
while in a station!

ON NO! LOOP SWEEPERS!
---------------------
These guys will straighten you
right out! To keep you from
going in circles, the train-
riding public has gotten
together and developed a strange
contraption called a LOOP
SWEEPER! After traveling in a
closed loop for some time, the
LOOP SWEEPER starts flashing,
warning you of its construction.
If you fail to break the loop,
the LOOP SWEEPER will be
completed and quickly travel
down the track trying to crash
into you!

AND THEN THERE ARE CRAZY TRACKS!
--------------------------------
These tracks will take YOU for a
ride! On certain screens you'll
find CRAZY TRACKS, which send
you off in another direction and
chances are it's not the one in
which you want to go!

PANIC BUTTON WARNING!
---------------------
If you panic at the right time,
it can help... pressing this
button causes the track your
Train is on, along with your
Train, to be interchanged with
some other track on the screen.
And each time the PANIC BUTTON
is used successfully, it causes
the addition of one pair of 
TRAIN STOPS to some piece of
track.

But watch out! Panic at the
wrong time and it can hurt, as
the PANIC BUTTON is DEACTIVATED
if there is a Crazy Train or
Loop Sweeper on the same piece
of track as your Train! And if
you PANIC while in a train
station, both your Train and the
station blow up!

RAILWAY RULES:
--------------
You start with 3 Trains. Only 1
appears on the track at a time.
Route that Train and pick up as
many passengers as possible!

Each time you lose a Train,
another enters the track. Keep
in mind the many ways you can
lose trains:

1. Run out of track(hit a blank)
2. Run into a train stop
3. Crash into a Crazy Train
4. Crash into a Loop Sweeper
5. At a station when it blows up
6. Panic while in a station

The number of trains you have
left shows on the screen. When
you crash your last Train or it
is blown up, it's the end of the
line for you and the game! When
game is over, play again by
pressing ANY SIDE ACTION BUTTON.

SCORING:
--------
The score is shown when you lose
a Train or "CLEAR" a screen.

Track section crossed     10 pts
Pick up passengers       100 pts
Crazy Track crossed      150 pts
Station Reward     Varies w/Time
Clear a screen         1,000 pts
Perfect Clear          5,000 pts
Bonus Trains          10,000 pts
   (every 70,000 pts thereafter)

Each new screen offers you a
tougher challenge with more and
more excitement... CRAZY TRAINS
go faster, more TRAIN STOPS
appear, and STATION REWARDS
decrease in value a lot quicker!

WINNING TIPS:
-------------
1. The piece of track that your
Train is on may be switched into
the blank. The Train will move
with the track.

2. Learn to identify in which
direction a track goes
(straight, right or left) by the
color of the track.

3. The piece of track your Train
is on is illuminated by a
stationary yellow light. Use
this light as an indicator of
when you have safely moved onto
the next piece of track.

4. Go for the BONUS stations
first! Score more points than
those offered for picking up
passengers at regular stations!

5. Try to arrange track sections
so that two CRAZY TRAINS crash.
It will cause the addition of
one pair of TRAIN STOPS on the
tracks where the collision
occurred. A fixed hazard is
easier to deal with than a
moving one!

6. Use your PANIC BUTTON wisely!
Remember when used successfully,
it cause the addition of one
pair of TRAIN STOPS (a fixed
hazard) to some piece of track,
and those TRAIN STOPS carry over
to the next screen!

//==============================
// MISSILE DOMINATION
//==============================
$EC2E2320
MISSILE DOMINATION
(c)2015 INTELLIVISIONREVOLUTION

You are the country's defense
force commander, trying to hold
off an attack that threatens to
devastate your nation. Bombers
fly overhead while enemy
missiles rain destruction on
your cities. And the computer's
voice circuit has a virus! Using
the arsenal at your disposal,
you must intercept and destroy
the incoming warheads. The
future of civilization depends
on your skill at holding off the
endless waves of attacks!
(Intellivoice enabled)

CONTROLS:
---------
DISC - Move crosshair
TOP SIDE BUTTONS - Fire center
LOWER LEFT BUTTON - Fire left
LOWER RIGHT BUTTON - Fire right
[5] - Options Screen 
Press 1+9 together to pause game

OBJECT OF THE GAME:
-------------------
Score as many points as possible
by defending your cities and
bases, destroying enemy
missiles, bombers, killer satel-
lites, and smart bombs before
they reduce everything to
rubble.

SELECT OPTIONS:
---------------
Press "5" for the game options.
Toggle options by pressing DISC
up and down, left and right.

Difficulty -- Hard: fast speed,
  Easy: slow speed
Initial Cities -- 4, 5 or 6
Crosshair -- "+", "x" or "o"
Bonus City -- 8,000-20,000 pts
Launch Mode -- Normal: player
  selects launch locations using
  the controller. Nearest:
  computer selects launch
  locations. Single: one launch
  base at center of screen

Select Done when you have
finished choosing options.

THE GAME BEGINS:
----------------
Before each wave of attack, the
screen shows the number of
cities that need to be defended.
Unlike cities, all bases are
intact at the start of each
wave. Also displayed is the
scoring multiplier for that
wave. When you hear the sound of
air raid sirens, prepare to
defend the cities!

PLAYING THE GAME:
-----------------
Your screen will show incoming
missiles headed for your cities
and bases. Move the crosshair
using the DISC to aim for the
end of a missile trail and then
press an ACTION BUTTON on the
controller to fire. Remember
that it takes time for your
missile to arrive at the spot
you selected, so lead your
targets. The missile will
detonate wherever your cursor is
when you launch from your base.

Each base has a limited supply
of defensive missiles, indicated
by the number below the base.
When a city is hit, it explodes
in a nuclear mushroom cloud, and
all that remains is a pile of
debris. If a base suffers a hit,
it is also reduced to rubble and
cannot be used for the remainder
of that attack wave.

MULTIPLE TARGETS:
-----------------
Several types of targets will
appear on your screen as the
game progresses. Your skill at
destroying these will determine
your ultimate success in the
game.

MIRVs                     25 pts
(Multiple Independently
Targetable Reentry Vehicles)
  Enter at the top of the screen,
  split off, and continue diag-
  onally towards their targets.

BOMBERS                  100 pts
  Appear at either side of the
  screen and travel horizontally
  at a fixed altitude.

KILLER SATELLITES        100 pts
  Also appear at either side of
  the screen and travel hori-
  zontally at a fixed altitude.

SMART BOMBS              125 pts
  Decend from the top of the
  screen and take deadly aim at
  either a city or a base.

BONUS SCORING:
--------------
At the end of each wave, 5 pts
are awarded for each missile
remaining and 100 pts for each
city saved. Scoring multipliers
increase as the game progresses:
  Waves 1-2  = x 1
  Waves 3-4  = x 2
  Waves 5-6  = x 3
  Waves 7-8  = x 4
  Waves 9-10 = x 5
  Waves 11+  = x 6

GAME OVER:
----------
The enemy is relentless. If all
of the cities are destroyed at
the end of a wave, the game is
over. You will still receive
your bonus points for missiles
remaining. These will be added
to your final score.

STRATEGIC TIPS:
---------------
1. Once a city is destroyed,
concentrate on defending your
remaining cities and bases.
Incoming missiles hitting
destroyed cities are no threat.

2. You can have up to three
missiles in the air at any one
time. There is no need to wait
until the first missile explodes
before firing a second or third.

3. Toward the end of an attack
wave, if you have plenty of
missiles in reserve, increase
your bonus score by targeting
incoming missiles, even though
they're headed for a destroyed
city.

PLAYING AGAIN:
--------------
If you set a new high score,
enter your initials on the High
Score screen and see where you
rank. To play again, just wait a
few seconds and the game will
automatically return to the
title screen.

//==============================
// MOTOCROSS
//==============================
$5F6E1AF6
MOTOCROSS
(c)1983, 1998 INTELLIVISION
PRODUCTIONS, INC.

The big time is here! Daredevil
you! You'll prove once and for
all that no one can outrace you,
outshine you, in the frenzied
world of MOTOCROSS!

CONTROLS:
---------
DISC - Steering
TOP SIDE BUTTONS - Accelerate
LOWER SIDE BUTTONS - Brake

NOTE: DO NOT USE THE KEYPAD AND
DISC AT THE SAME TIME!

OBJECT OF THE GAME:
-------------------
You CHOOSE or DESIGN your own
course -- long straights, "S"
turns, jumps, or combination of
these. Get it easy or rough! You
select the number of laps and
the type of confrontation you
want, you against the clock or
you against the computer! Play
it normal or in reverse
direction! You are on your own
now! Go! Clock starts! Watch
YOUR TIME at the FINISH LINE! Or
lay back and watch the computer
race its own bike!

GET READY:
----------
Choose the Course Number
------------------------
[1] Largest Course
[2] Rough Course
[3] Popular Course
[4] Custom Course
[5] Last Designed Course

Select the Number of Laps
-------------------------
Press desired number on keypad,
press -0- for 10 Laps (maximum).

Enter Play Option
-----------------
[1] One Player
[3] One Player against Computer
[4] One-bike Spectator Game
[5] Two-bike Spectator Game

Select Steering Option
----------------------
[1] Directional(screen oriented)
[2] Left/Right (bike oriented)

Choose Driving Direction
------------------------
[1] Reverse
[2] Forward

ON YOUR MARK!
-------------
As the race starts (clock's
running!), press either TOP SIDE
BUTTON to make your bike move.
Press longer to make it move
FASTER. Use DISC to steer your
bike. If you selected "Direc-
tional" steering, press DISC in
the direction you want your
bike to go. Bike will turn to
that direction. Release DISC
after direction is reached. For
"Left/Right" steering, press
DISC left to turn left; press
DISC right to turn right.

Touch your DISC SLIGHTLY and
DON'T OVERSTEER...otherwise your
motorcycle will go berserk
before your eyes, hurtle onto
the grass, and land your brave
rider on top of his head!

Take advantage of a straight --
ACCELERATE! Keep pressing TOP 
SIDE BUTTON! Slow down BEFORE
you reach a curve. Press either
BOTTOM SIDE BUTTON to brake.
Touch DISC slightly to steer
bike...so it doesn't sideslip
and skid off the road.

So many things can go wrong in a
race. Don't just zoom at top
speed through a jump -- slow
down a bit and be careful or you
might end up eating dirt again!

TWO-BIKE RACES!
---------------
One player controls the red bike, 
the other the black. At time
zero, both bikes start at the
line of departure...and WHHHRRRR
out and away they go! Watch both
clocks begin to race, too!
Hitting another bike, with in-
tent or by mistake, will mess up
your game and smack you down
to the ground. Try to avoid it.

MAKING YOUR OWN COURSE:
-----------------------
When you choose Course #4 before
the game starts, you are given
an opportunity to DESIGN your
own race course. A map will be
displayed immediately on the
screen for you to start work.
Use DISC to select a piece of
the course, then press ENTER.
Select another piece and ENTER.
Press CLEAR anytime you want to
remove a piece you've already
placed. Continue until your
design is completed.

Press ENTER to exit to the
Number of Laps selection. Select
the number of laps, then move on
to the next game option selec-
tions as your normally do before
starting a game. And play on the
course you have just designed!

To play again on it, you will
have to Press 5 (Last Designed
Course) when choosing the Course
Number at the start of your game
option selections.

WINNING!
--------
Winning means CROSSING the
FINISH LINE, whether there are
one or two bikes in the race.
Bikes will drive off the screen
and the clocks will stop. Player
with lowest time is the winner.
The maximum time possible is 999
seconds. If you take longer than
that, your time will show 999!

PLAY AGAIN:
-----------
To start again, press a number
key on the keypad. The following
message will appear on your
screen: "Same Race?".  Press "1"
for Yes and "2" for No.

REMEMBER:
---------
SLIDES -- Traction is reduced
when your bike goes faster.
Begin steering in advance of a
turn or your bike will slide.

JUMPS -- When your bike hits a
jump, it will go into the air
and land later. The faster your
bike takes a jump, the higher
and farther it will go.

COLLISIONS -- If your bike goes
all the way off the course, it
will spin and turn you upside
down. Then the computer will
assist you back onto the track.
Computer-controlled bikes can
crash too. If a bike hits
another, both bikes will spin
and riders will turn upside down.

DISQUALIFIED -- A bike that goes
too far backwards on a course
will be disqualified.

//==============================
// MOUSE TRAP
//==============================
$598662F2
MOUSE TRAP
(c)1981 EXIDY, INC.,
(c)1982 COLECO INDUSTRIES, INC.

GAME DESCRIPTION:
-----------------
Based on the fun-filled arcade
game, Exidy's MOUSE TRAP for
Intellivision features a cheese-
chomping mouse that you dash
around a maze. Open and shut
maze doors to escape the
pursuing cats. Eat a bone, then
turn your mouse into a cat-
biting dog. But watch out for
the treacherous hawk!

CONTROLS:
---------
DISC - Move mouse
[1-4] - Select skill level
1(RED) - Open/close red doors
2(YELLOW) - Open/cl yellow doors
3(BLUE) - Open/close blue doors
5(GREEN) - Change mouse into dog
CLEAR - Turn sound off/on

Press any KEYPAD BUTTON to start

CAT AND MOUSE:
--------------
Move your mouse through the maze
trying to eat all the small
cheeses. Watch out for the
pursuing cats! Open and close
maze doors to block their paths.

DOG GONE IT!
------------
When the cats become too clever,
your mouse can become a dog if
it has eaten a bone (you get one
bone at game start). Check the
Bones Remaining Indicator. If
you have a bone, press the green
Dog Button (5) to turn your
mouse into a cat-biting dog for
a few happy moments. But be
careful. Each time you press the
green Dog Button (5), you use up
one bone. So eat more bones, but
save them up to get your mouse
out of tight spots.

HAWK ALERT!
-----------
When playing games at Skills 2,
3 and 4, beware of the hawk that
flies out to catch your mouse or
dog. Enter the "IN" box to
escape to one of the maze
corners and confuse the hawk.

EAT AND RUN:
------------
Bonus prizes appear one at a
time in certain locations in the
maze and earn you bonus points
when eaten. Start with the large
cheese and go on to other
special treats. Eat all the
small cheeses and win a bonus -
then move on to another maze and
even livlier action. Keep play-
ing until you run out of mice.

SCORING:
--------
Small cheese             100 pts 
1st Cat bitten           100 pts 
2nd Cat                  300 pts 
3rd Cat                  600 pts 
4th Cat & up             900 pts 
First Large Cheese     1,200 pts
Each Thereafter     100 pts more

You begin with six mice. Each
time your score reaches a
multiple of 20,000, you win a
bonus mouse!

You receive a 10,000-point bonus
each time you eat all the small
cheeses in a maze.

THE FUN OF DISCOVERY:
---------------------
This instruction booklet will
provide the basic information
you need to get started playing
MOUSE TRAP, but it is only the
beginning! You'll find that this
cartridge is full of special
features to make MOUSE TRAP
exciting every time you play.
Experiment with different
techniques - and enjoy the game!

//==============================
// MS. NIGHT STALKER
//==============================
$4601a4c5
MS. NIGHT STALKER
(c)2014 INTELLIGENTVISION

You are not trapped in a maze,
you want to be there! Face the
robots head on and watch the
bats and spiders shiver knowing
you are nearby. They will be
relentless in their attacks on
you, so play it smart. Be
patient, and wait for the right
opportunity to attack. The fight
will be a long one, but then,
you are Ms. Night Stalker!

CONTROLS:
---------
DISC - Move Ms. Night Stalker
 [2] - Shoot up
 [4] - Shoot left
 [6] - Shoot right
 [8] - Shoot down

On title screen:
[1-9] - Select maze
 (CLASSIC maze is the default)

Press ENTER to start game.

STARTING THE GAME:
------------------
When the game starts, Ms. Night
Stalker is located inside the
bunker in the center of the
screen. There is only one exit
and entrance, located at the top
of the bunker.

GET MOVING:
-----------
Your first objective is to
retrieve the gun flashing some-
where in the maze. Run! Use the
DISC to move up, down, left, or
right. Taking the shortest path
may not be the best way to track
the gun down.

Once you have the gun in hand,
the number of bullets in the gun
are displayed in black on the
bottom left of the screen. Each
gun you pick up will have 3 to 9
bullets. Make sure you watch
this number. Your life may
depend on it!

With the gun in hand, it is now
time to hunt down robots, bats,
and spiders. Use the keypad to
shoot the gun in the UP, LEFT,
RIGHT, or DOWN directions. Make
sure you time your shot!

A word of caution -- you can not
run and shoot at the same time
unless you use a hidden feature.
The controller side buttons may
be used to shoot while you press
the disc to move! To shoot left,
press the LOWER LEFT SIDE BUTTON.
To shoot right, press the LOWER
RIGHT SIDE BUTTON. The UPPER
SIDE BUTTONS are used to shoot
up and down but the direction
must be set prior to pressing
the SIDE BUTTON. To set the dir-
ection, press "1" on the keypad
to set the direction to UP, and
press "7" on the keypad to set
the direction to DOWN. The color
of the number that shows how
many bullets are left in the gun
will be black when set to up and
red when set to down.

THE MAZE:
---------
For you to succeed, it is
important to understand
everything in the maze.

MS. NIGHT STALKER has 5 lives at
the start of the game. Each time
she dies, the remaining amount
of lives is briefly displayed in
yellow at the bottom left of the
screen (where the bullet count
is shown). You earn additional
lives every 10,000 points.

The BUNKER is your "safe" house.
This is where you start off at
the beginning of the game and
after each time you are killed.
It protects you from the spider
and bats and most bullets. It is
not advisable to hang out in the
bunker for long.

Your GUN is your only tool to
destroy the robots, bats, and
spider. It is powerful but needs
time to recharge. Therefore, you
can only have one shot in the
air at a time. Make each shot
count! When the gun runs out of
bullets, a new gun will appear
at a random location in the maze.

The SPIDER can be your friend!
Even though the spider will stun
you and paralyze you for a few
seconds, the web it leaves
behind can provide protection by
stopping bullets from robots.
Only the robots can destroy the
web. A new spider will always
show up on the top left corner
of the maze after you shoot the
spider in the maze.

BATS, like the spider, will stun
and paralyze you. To shoot them,
you must be more accurate with
your shots. Do not be surprised
when you miss them. After they
are shot, they will either
regenerate or become a light
blue robot similar in shape to
the red robot.

There are 5 different ROBOTS
with different characteristics.
Their objective is to track you
down at all cost. They have an
unlimited amount of shots. The
red, blue and light blue robots
are aggressive in tracking you
down. The white robot has a
shield which requires 3 shots to
destroy. The black robot adds
an energy bolt which absorbs
your bullets. If the energy bolt
is yellow, it could begin to
destroy the bunker. The most
challenging robot is the invis-
ible robot which comes out after
50,000 points. Track it by its
bullets, when it travels through
the web, over another robot,
bats, or the spider.

After you destroy a robot, a
randomly selected robot will
replace it. Your heartbeat will
increase with the difficulty of
robot that appears.

TIPS:
-----
1. Shooting bats may be easy
points but keep in mind that you
could have additional robots
hunting you down shooting at you
from different angles.

2. Use one controller to fire
the gun and the other controller
to move. This allows you to move
and shoot at the same time!
Better yet, use the SIDE BUTTONS
to shoot!

3. Use the intersections and
corners to ambush robots. As
your points go up, you will want
to stay further away from them
as their bullets will be moving
faster.

4. The robots will be confused
as to where you are after you
die. Run as soon as you appear
in the bunker as the robots will
not shoot at you for a few
seconds.

5. As your score goes up, it is
more likely that the black and
invisible robot will shoot
energy bolts that destroy the
bunker.

SCORING:
--------
Spider                   100 pts
Bats                     300 pts
Light Blue Robot         300 pts
Red Robot                400 pts
Blue Robot               500 pts
White Robot            1,000 pts
Black Robot            2,000 pts
Invisible Robot        4,000 pts

//==============================
// MS. PAC-MAN
//==============================
$0753544F
$3b636837
MS. PAC-MAN
(c)2015 CARL MUELLER, JR.,
INTELLIGENTVISION

Pac-Man introduced the world to
eating dots and ghosts. Ms. Pac-
Man took the game play to the
next level, making her the most
popular game girl! Ms. Pac-Man
for the Intellivision takes the
game to an even higher level!
Prepare yourself as you
experience all the excitement of
the arcade game plus more!

CONTROLS:
---------
DISC - Move
SIDE BUTTONS - Increase speed
TOP SIDE BUTTONS - Store energy
  pill (when playing as Pac-Man)
[8] - Pause game

STARTING GAME:
--------------
On the title screen, you may
start the game or change how the
game plays. Use the DISC to
highlight your selection. Then
press the ENTER key or any SIDE
BUTTON to start the game, or go
to the options screen.

SELECTING OPTIONS:
------------------
Change how the game plays on the
options screen. Choices are the
character you play with, diffi-
culty of game, amount of lives
you have, score you get a bonus
life at, if you can speed up,
how ghosts think, game rules,
and mazes played. Use the DISC
to navigate up and down and
change the option by going left
and right. Press the SIDE KEY to
return to the title screen.

1P and 2P -- Change which char-
acter you play with. Choose
Ms. Pac-Man, Pac-Man or Junior.

Mode -- This determines diffi-
cultly. Select NORMAL or HARD.

Lives -- Number of lives you
have in the game. Select 1, 2,
3 or 5 lives.

Bonus -- The amount of points
you need to reach to earn an
extra life. Select 10,000, 
15,000, 20,000 or no bonus.

Speed -- Your character can move
quickly or at a normal speed.
OFF disables this ability, ON
makes you move fast all the time,
and BUTTON allows you to use the
top side button to move fast.

Ghosts -- Select how the ghosts
move. Choose between red, pink,
cyan, orange (they move as the
arcade) and purple, tan, gray,
light blue (they move slower
than the arcade).

Rules -- Play the game using Ms.
Pac-Man game rules or Pac-Man
game rules.

Mazes -- ARCADE plays the
original 4 arcade mazes, EXTRA
continues the arcade feel, WIDE
mazes use more of the screen so
you may not see the border walls,
STRANGE mazes may not have sym-
metry or have other interesting
designs, and RANDOM will select
the next maze from all the mazes
in the game.

GAME PLAY:
----------
Your goal is to score as many
points as you can while you eat
dots, bonus objects bouncing
around the maze, energy pills
and ghosts. Score 15,000 points
to earn an extra life.

The game starts with you having
three lives, which are indicated
by Pac-Man symbols at the right
side of the screen. When the
game play begins, your character
is located close to the center
of the screen, just below the
ghosts' reincarnation chamber in
the center of the maze. Use your
controller's DISC to move
through the maze. When you pass
over dots, you gobble them up,
and score points. If you eat all
the dots on the screen, the maze
flashes momentarily, and you
move on to the next level.

Ms. Pac-Man encounters bouncing
objects traveling around the
maze. Gobble up these munchies
and you score bonus points.

But watch out! Fearful ghosts
scurry about trying to gobble
you up. Your only recourse is to
eat an energy pill and then go
after the ghosts. The pills are
generally located in the corners
of the maze, are much larger
than the other dots, and blink.
As soon as you gulp down an
energy pill, the ghosts turn
blue with fright. This is your
chance to eat them!

You earn 200 points for the 1st
ghost, 400 points for the 2nd
ghost, 800 for the 3rd ghost and
a whopping 1,600 points for the
4th ghost, all on the same
energy pill.

Unfortunately, the effect of
eating an energy pill is short-
lived, so you'll have to move
fast. After the ghosts are
gobbled up, their eyes head back
to the chamber in the center of
the screen for reincarnation. If
you don't quickly gobble up the
ghosts, they start to blink just
before they turn back to their
original colors and come after
you again.

HIGH SCORE:
-----------
The high score is shown on the
title screen. It is set to 3,200
points the first time you play
the game. You will hear a "ding-
ding" sound when you pass the
high score.

TIPS:
-----
1. Practice clearing the maze of
dots before trying to gobble up
the ghosts.

2. Hang out near an energy pill
before eating it and tease the
ghosts into moving toward you.
When the ghosts get close, eat
the energy pill and gobble up
all the ghosts.

3. The openings in the maze are
escape tunnels. Go through the
tunnels to move quickly to the
other side of the maze.

4. Don't forget, different mazes
have different tunnels and not
all mazes have tunnels! Some are
stranger than others!

5. Each selectable character has
special abilities:

Ms. Pac-Man
-----------
Receives a slight speed boost
when she eats an energy pill.

Pac-Man
-------
Can store an energy pill to be
used later. Store the pill by
holding the TOP SIDE BUTTON. The
energy pill is activated once
you let go of the button.

Jr. Pac-Man
-----------
Can hide out in the ghost box.
He also gets a speed boost when
traveling through a tunnel.

SCORING:
--------
Dots                      10 pts
Energizer Dot             50 pts
1st Ghost                200 pts
2nd Ghost                400 pts
3rd Ghost                800 pts
4th Ghost              1,600 pts
Cherry,Bunch,Donut,Key   100 pts
Strwberry,Hambrger,Shoe  200 pts
Orange, Corn, Egg, Bell  500 pts
Pretzel, Peach, Clover   700 pts
Apple, Pie, Galaxian   1,000 pts
Pear,Melon,Cup,Present 2,000 pts
Banana,Mushroom,Star   5,000 pts

//==============================
// MYSTIC CASTLE
//==============================
$67ca7c0a
MYSTIC CASTLE
(c)2016 INTELLIGENTVISION

Guide your knight through the
deadly mazes of Mystic castle,
slaying evil dragons, sorcerers
and demons as you go. Watch for
gates that block your path...
magic objects that grant special
powers, extra points, or extra
lives...and magic creatures that
energize your knight. Complete
all three mazes -- forest,
castle and dungeon -- and the
game starts over at a faster
speed. Continue playing,
increasing your score, until all
of your knight's lives are lost.

CONTROLS:
---------
DISC - Move your knight
SIDE BUTTONS - Use magic object

To save time, press the DISC to
turn your knight before he
reaches a turn in the maze. The
knight will continue in his
present direction until the turn
is possible.

Press any SIDE ACTION BUTTON to
activate a magic object after
your knight picks it up. Each
object can be activated only
once, unless picked up again.

TO START THE GAME:
------------------
Press any key to move to the
Options Screen. Use the keypad
to select your skill level:
[1] Squire (Beginner)
[2] Apprentice (Intermediate)
[3] Archer (Advanced)
[4] Knight (Pro)

GAME IN BRIEF:
--------------
1. Three dragons appear in the
forest maze, one at a time. Slay
all three dragons and advance to
the castle maze.

2. Six sorcerers guard the
castle maze, appearing two at a
time. Slay all six sorcerers and
advance to the dungeon maze.

3. Nine demons guard the dungeon
maze, appearing three at a time.
Slay all nine demons and
advance to the next, faster
forest maze.

4. To slay a dragon, sorcerer or
demon, move ENERGIZED knight on
top of guardian. If knight comes
into contact with guardian while
not energized, knight will lose
one life.

5. To energize knight, touch a
magic creature: bat in forest,
mouse in castle, or red skull in
dungeon. Energy lasts several
seconds, then disappears.

6. Pick up magic objects for
extra points, lives or powers.
Avoid the crossbones. To pick up
object, move knight on top of
it. Object picked up replaces
any unused object in your
possession. To use object, press
SIDE ACTION BUTTON. Object
disappears after use.

7. Knight starts with four lives.
Additional lives are earned by
picking up heart or accumulating
points. Game ends when all lives
are lost.

MAZES:
------
There are three levels to Mystic
Castle: forest, castle and
dungeon. The forest level is the
slowest. The dungeon level is
the fastest. If you make it
through all three levels, game
play resumes at the forest, but
game speed continues to increase.
There are several possible mazes
for each level. Once a maze
appears, it does not change
until the next level is reached.

WALLS AND GATES:
----------------
Knights and evil guardians can
move only along open passageways.
Magic creatures can move through
walls and gates. All mazes have
gates that randomly open and
close. Gates are invisible until
they close. Gates remain closed
for a few seconds, then reopen.

MAGIC CREATURES:
----------------
All mazes have magic creatures
that energize your knight when
touched.

Forest maze - Three bats
Castle maze - One mouse
Dungeon maze - One red skull

The knight remains energized for
a few seconds, during which he
flashes and special music plays.
Only while energized can the
knight slay evil guardians.

EVIL GUARDIANS:
---------------
All mazes have evil guardians
that must be slain to advance to
the next level. Evil guardians
come in three colors. Green:
slower than your knight, worth
300 points when slain. Gold:
almost as fast as your knight
and worth 400 points when slain.
Red: faster than your knight and
worth 500 points when slain.

Guardians pursue your knight
when he is not energized; flee
from your knight when he is
energized. If your knight
touches or is touched by a
guardian while not energized,
he will lose a life.

Different mazes contain
different evil guardians: 

Dragons -- Three in the forest
maze. Appear one at a time.

Sorcerers -- Six in the castle
maze. Appear two at a time, and
can move as a pair or split up
and attack from diff directions.

Demons -- Nine in the dungeon
maze. Appear three at a time,
can move together or split up
and attack from diff directions.

MAGIC OBJECTS:
--------------
Magic objects appear at various
times, in various locations
throughout each maze, remaining
for several seconds before 
disappearing again. To pick up a
magic object, move your knight
on top of it. To use the object,
press any SIDE ACTION BUTTON.

An object's power can be used
only once each time it is picked
up. An object remains in your
knight's possession until it is
used or replaced by a different
object (knight can carry only
one object at a time).

Grail- Energizes knight
Crown- Freezes guardian(s) for a
 few seconds
Necklace- Speeds knight up for a
 few seconds
Lantern- Doubles knight's energy
Key- Lets knight move through
 gate or wall
Ring- Moves knight to random
 location in maze

The above objects also add
points to your score. The first
object picked up within a maze
adds 100 points. The second adds
200 pts. All subsequent objects
within that maze add 300 points.

Some objects can be picked up
without replacing the object
already in possession:

Coins- Add 500 points to score
Heart- Extra life
Crossbones- Cuts score in half

GAME LIVES:
-----------
Each knight starts with four
lives, and loses one life if
touched by an evil guardian
while not energized. Additional
lives can be earned by picking
up a magic heart, and by
reaching scores of 5,000,
10,000, 20,000, 50,000 and
100,000 points.

Game ends when all of your
knight's lives are lost. Number
of lives left, in addition to
present life, appear in the
upper right corner of the screen,
next to your game score.

SCORING:
--------
Slay Green Guardian      300 pts
Slay Gold Guardian       400 pts
Slay Red Guardian        500 pts
Pick up magic object
(excl. coins, heart, crossbones)
 1st Object in Maze      100 pts
 2nd Object in Maze      200 pts
 Addt'l Objects in Maze  300 pts
Coins                    500 pts
Heart                 Extra Life
Crossbones       Lose 50% of pts
Extra Life at 5,000, 10,000,
  20,000, 50,000 and 100,000 pts

WINNING TIPS:
-------------
1. Lure an evil guardian as
close as possible to your knight
before touching a magic creature.
Your knight will be energized
for only a few seconds and
meanwhile, the guardian is
running away from you!

2. Try to anticipate gates, to
trap a guardian in a dead end.
Corners also slow guardians down.

3. Pick up the most useful magic
objects. Although all objects
give points, some are more
useful than others. Exceptions:
always pick up coins and hearts.
The extra points and lives don't
affect other magic powers.

4. Avoid touching the crossbones
whenever possible, but don't be
afraid to sacrifice points, if
the crossbones stands between
your knight and a safe retreat.

//==============================
// NIGHT STALKER
//==============================
$7334CD44
NIGHT STALKER
(c)1982, 1997 INTELLIVISION
PRODUCTIONS, INC.

OBJECT OF THE GAME:
-------------------
Night Stalker is trapped in a
maze. Robots relentlessly track
him down. Keep him away from
spiders and bats. Watch out for
robot fire! React quickly. The
key to survival is to destroy
them before they destroy you!
Rack up as many points as you
can! It's you against them...
to the end!

CONTROLS:
---------
DISC - Move Night Stalker
 [2] - Shoot up
 [4] - Shoot left
 [6] - Shoot right
 [8] - Shoot down

Choose your speed:
DISC - Fastest
 [1] - Fast
 [2] - Medium
 [3] - Slow

HOW TO PLAY:
------------
The game begins immediately,
with Night Stalker inside the
center bunker. His loaded weapon
is lying in the maze and is
flashing. He must leave the
bunker and walk over the weapon
to pick it up.

Once Night Stalker has picked up
the weapon, he has six bullets
and can now shoot in four
different directions.

RULES OF THE MAZE:
------------------
BUNKER
------
There is only one safe place for
Night Stalker to hide and that's
inside the bunker, in the center
of the maze. When he's inside,
spiders and bats cannot bite him,
and the robot's bullets will not
harm him - until the Black Robot
appears (see below). IMPORTANT:
If your man isn't all the way
inside the bunker, he can be
blasted by robot fire!

LIVES
-----
You start off with 6 men. After
one man is shot, the next one
appears inside the bunker, and
the number of men you have left
shows on the screen. Each time
you rack up about 10,000 points,
you get another man. When your
last man is downed by robot fire,
the game is over!

WEAPON
------
Night Stalker's main defense in
the creature-infested maze is
his loaded weapon. Each weapon
holds six shots, and will drop
bats, spiders and robots in
their tracks. IMPORTANT: Time
your shots carefully! Once you
fire, you cannot shoot again
until that bullet disappears
from the screen. While his
bullet is traveling, Night
Stalker can run to dodge fire. 

Night Stalker is out of bullets
when you see the weapon flashing
on the screen. He must then walk
over a weapon to pick it up.

Occasionally you might have
bullets left after you have
fired off six shots. When the
weapon ran out of ammunition,
the next weapon was placed right
where Night Stalker was standing
and he automatically picked it
up. Keep on shooting!

SPIDER
------
A single menacing spider creeps
throughout the maze, ready to
bite Night Stalker whenever they
come in contact. Once Night
Stalker is bitten, he falls
down, paralyzed for a few
seconds. When he's down, he
cannot fire his weapon or run.
He's vulnerable to robot attack!

To avoid being bitten, fire off
a shot. If it hits the spider,
he vanishes. But another quickly
appears in the spider's web and
begins to crawl around. Robots'
fire does not zap the spider!

The spider web is a semi-
protected area. All the maze
creatures and Night Stalker can
enter the web. Sometimes the
bullets from Night Stalker and 
the robots will penetrate the
web. Sometimes they will not.

BATS
----
Two bats, hanging upside down,
awaken and wing their way
through the pathways of the
maze. Either bat can bite Night
Stalker when they come in
contact. He falls down and is
paralyzed the same as when
bitten by a spider. He cannot
shoot or move. 

After you shoot a bat, or a bat
is hit by robot fire, it is
replaced by another. But if it
isn't a direct hit, the bat is
still there to torment you!
IMPORTANT: The game changes once
your score is over 5,000 points.
Now when a bat is hit by robot
fire or your shot, a gray robot
takes its place. If both bats
get hit, you will have 3 extra
robots to contend with! 

ROBOTS
------
Night Stalker's most persistent
enemy in the maze is the robot.
In the course of the game you
will encounter 5 different
types. As your score gets higher,
the robots become more and more
sophisticated. Each new robot
has all the characteristics of
the previous robot, plus new
features.

All robots will fire at Night
Stalker! They have unlimited
ammunition. Their shots are the
same as his...only one bullet
shows on the screen at a time.
When Night Stalker's bullet hits
a robot, he explodes. Another
robot quickly replaces him.
Robots always enter the maze at
the lower left corner. 

TAKE A LOOK AT YOUR ADVERSARIES:
--------------------------------
Gray Robot -- This robot is slow
on the attack. He patrols the
maze at random, shooting only
when he sees Night Staler. After
5,000 points, when a bat is
shot, this robot takes its place
in the maze! 

Blue Robot -- After 5,000 points,
a blue robot appears on the
screen. He's more determined to
track Night Stalker wherever he
goes! He's hard to lose!

White Robot -- After 15,000
points, the white robot appears
and aggressively seeks out
Night Stalker. The white robot's
shield protects him from your
bullets. It takes 3 bullets to
penetrate the shield and blow
this robot away! 

Black Robot -- After 30,000
points, the black robot appears
and advances with power! He is
capable of firing white "energy
bolts" that absorb Night
Stalker's bullets on contact.
After 50,000 points, this robot
shoots yellow "energy bolts".
These can now crash into the
bunker and slowly wear it away.
Once the bunker is gone, there's
no safe place for you to hide.

Invisible Robot -- He's in the
maze after 80,000 points, and is
the ultimate aggressor! It's a
sneak attack! His bullets are
visible. That's your only clue
about where he is! 

SCORING:
--------
Destroy a Spider         100 pts
Destroy a Bat            300 pts
Destroy Blue Robot       500 pts
Destroy White Robot    1,000 pts
Destroy Black Robot    2,000 pts
Destroy InvisibleRobot 4,000 pts

STRATEGY TIPS:
--------------
1. Once an aggressive robot is
after Night Stalker, lay in wait
at corners and intersections.
When the robot advances, get off
a shot and quickly retreat!

2. For the white, black and
invisible robots, it's helpful
to count your bullets. Try to
use your last bullet to blast
the robot. This gives you some
time to run and pick up the
weapon while the next robot
enters the maze. 

3. Knock off sleeping bats for
quick points!

//==============================
// PAC-MAN
//==============================
$A21C31C3
$6E4E8EB4
PAC-MAN
(c)1983 ATARISOFT

CONTROLS:
---------
DISC - Maneuver Pac-Man
SIDE BUTTONS - Start game again
Press 1+CLEAR - Pause for 30 sec
Press 1+9 - Pause

Press any key (other than "2")
to start a one-player game.

Use the DISC to maneuver PAC-MAN
around the maze. Use the DISC to
slide PAC-MAN in and out of the
openings on either side of the
maze. If he exits on the right,
he reenters on the left (and
vice versa). But beware, ghosts
can travel these routes too!

GAME PLAY:
----------
Keep PAC-MAN alive. Guide him
and protect him from the ghosts.
Gobble up dots, energy pills,
fruit, bells, keys and ghosts to
score points. Eat all the dots
on the screen and the maze
starts over. Score 10,000 points
and you'll earn a bonus PAC-MAN.

The game starts with three lives,
which are indicated by the
number at the lower right corner
of the screen. When game play
begins PAC-MAN moves to the
starting position at the center,
close to the bottom of the
screen. Use the DISC to guide
PAC-MAN around the maze. As he
passes over the dots, he gobbles
them up and you score points.
Also in the maze are four feisty
ghosts. They are out to devour
PAC-MAN, but the energy pills
give PAC-MAN the necessary power
to gobble up ghosts before they
gobble him up.

When PAC-MAN eats an energy pill,
the ghosts turn blue with fright.
PAC-MAN can then chase the
ghosts and gobble them up. But
watch out when the ghosts start
to blink, run quickly as they're
going to change back to their
original colors. The more ghosts
you gobble up with one energy
pill, the more points you score.

For a tasty bonus treat, PAC-MAN
delights in munching fruit.
Cherries, strawberries, peaches,
apples, and pineapples appear at
the center of the screen. They
only last a few seconds, so eat
the fruit quickly to score bonus
points. After munching all the
fruit, PAC-MAN can collect other
valuable bonus prizes like bells
and keys.

SCORING:
--------
The current score appears along-
side the right portion of the
screen. When the game is over,
the high game score appears with
the current game score.

HELPFUL HINTS:
--------------
1. Novice PAC-MAN players should
practice eating all the dots to
clear the maze before trying to
eat the ghosts.
 
2. Stay close to an energy pill
before you eat it, and tease the
ghosts into moving toward you.
When the ghosts get close, eat
the energy pill and gobble up as
many of them as you can.

3. Use the side openings of the
maze like an escape tunnel. Move
to either side while evading the
ghosts.

4. Use strategy, and try to save
your energy pills until you
absolutely need them. When you
are in a hurry, travel a route
already cleared of dots: you can
move 20 percent faster. 

5. Look for patterns which work
best for you. 

//==============================
// POPEYE
//==============================
$C51464E0
POPEYE
(c)1983 PARKER BROTHERS

OBJECT OF THE GAME:
-------------------
In this game you're POPEYE! And
your goal is to catch all of
Olive's hearts, notes, and cries
for H-E-L-P before they hit the
water and sink - or before
Brutus, the Sea Hag, or some
vulture knocks you overboard.

CONTROLS:
---------
DISC - Move Popeye
TOP ACTION BUTTONS - Punch
Press ENTER to start.

GAME SELECTION:
---------------
Game 1 - Easy, 5 Popeyes
Game 2 - Difficult, 5 Popeyes
Game 3 - Difficult, 4 Popeyes
Game 4 - Difficult, 3 Popeyes

PLAYING THE GAME:
-----------------
Use the directional DISC to
guide Popeye up and down stairs,
and across different platforms.
Press either one of the TOP
ACTION BUTTONS whenever you want
Popeye to punch Brutus' or the
Sea Hag's bottles, knock out
vultures, hit the punching bag,
or grab his spinach. With each
press of the button, Popeye will
swing his fist once.

You will begin each round with a
specific number of Popeyes (see
GAME SELECTION). The number of
Popeyes remaining is indicated
at the top, left-hand side of
the screen. The first Popeye
will appear on the left, top-
most ledge as soon as you press
the ENTER button.

In each round, Popeye must win
Olive's affection by catching
all of her hearts, notes, or
cries for H-E-L-P, depending
upon which round you're playing.
But Brutus, the Sea Hag, and the
vultures all do their best to
knock Popeye overboard - Brutus
with his fists and bottles, the
Sea Hag with her fast-flying
bottles, and the vultures with
their good aim! When any of them
hit Popeye - or if any of
Olive's tokens fall into the
water and are not pulled out in
time - you lose Popeye. If you
have a remaining Popeye, he will
appear on the top ledge, ready
to try again!

SPINACH:
--------
Throughout the rounds, Popeye's
spinach will randomly appear in
specific places on the screen
(see SPINACH section under each
round). Whenever you see it,
press one of the TOP ACTION 
BUTTONS. If you reach it in time,
you'll hear the "Popeye Theme".
This is your chance to catch up
with Brutus and knock him over-
board. When you do, you gain
3,000 points! In addition, if
you catch any of Olive's tokens
while the tune is playing, you
receive DOUBLE THE SCORE FOR
EACH. Once Popeye uses his
spinach, it will not appear in
that same round again.

THE SEA HAG:
------------
You never know when this nasty
ol' biddy is going to jump out
from the side lines and pelt
Popeye with a bottle. But she'll
only let one fly (sometimes
two!) when she's on the same
platform as Popeye. If Popeye's
not fast enough with his fists
to punch the bottle, and it hits
him, you lost that Popeye. If
you have a remaining Popeye, he
will appear on the top ledge.

SWEET HEARTS - ROUND #1:
------------------------
In this round, you must catch
all 20 hearts before they fall
into the water and sink - and
without being knocked over by
Brutus or the Sea Hag. Each time
you catch a heart, a red brick
will appear on the side of
Popeye's house, located at the
top of the screen. Once there
are 20 bricks, you'll auto-
matically begin the next round.

"Thru" Ledges
-------------
As the round begins, Popeye
appears on the left, topmost
ledge. You may move Popeye off
this ledge and land him safely
onto the platform below. Or you
may move him in the opposite
direction and he'll travel
around to the other ledge. You
may move Popeye back and forth
between the ledges, or off
either side and onto the
platform below at any time.
Brutus cannot walk on these
ledges, BUT HE CAN JUMP UP AND
KNOCK POPEYE OVERBOARD!

Stairs
------
On each platform, there are sets
of stairs which Popeye and
Brutus must use to move from
platform to platform. Use your
joystick to guide Popeye up and
down these sets of stairs.

Spinach
-------
Popeye's spinach will randomly
appear on the stairs to the left,
either on platform #2 or #3.

"Down" Ladder
-------------
In the center of the screen,
there is a ladder which connects
platform #2 and platform #3.
Popeye is the only one who can
use this ladder, and only to
move downward. However, Brutus
can reach up or down this ladder
to knock Popeye over.

Punching Bag and Bucket
-----------------------
You'll notice a punching bag
located near the center, topmost
part of the screen. When Popeye
is on the right "Thru" ledge, he
may punch the bag, causing the
bucket to fall. If Brutus is
directly below the bucket, it
will stop him in his tracks and
you gain extra points depending
upon what level Brutus is on.
NOTE: Each of your Popeyes can
only hit the punching bag once.
Brutus cannot knock Popeye over
while bucket is on top of him.

LOVE NOTES - ROUND #2:
----------------------
Similar to Round #1, you must
catch all 16 love notes before
they sink into the water, and
without being knocked overboard.
Once you've caught all 16 notes,
you'll begin the next round.

"Thru" Ledges
-------------
In this round, the "Thru" ledges
are located on platform #2.
Popeye can move off these ledges
and land safely onto the plat-
form below, or he can move to
the opposite ledge. Brutus can
also move about on the ledges,
however, he cannot travel around
to the opposite ledge.

See-Saw
-------
At the bottom, left-had side of
the screen there is a see-saw.
Whenever Popeye is on the 3rd
platform, he can jump off the
ledge, land on the see-saw, and
bounce upwards. Popeye will
either land on the 2nd or 3rd
platform. Brutus will land on
platform #2 whenever he bounces
on the see-saw.

Spinach
-------
Popeye's spinach will randomly
appear on the stairs to the
right of the 3rd or 4th platform.

HELP! - ROUND #3:
-----------------
This time, Olive Oyl is crying
H-E-L-P and Popeye must catch
all 16 letters. Each time you
catch a letter, another rung is
added to the ladder located in
the center of the screen. When
you've caught all 16 letters,
you'll return to Round #1, but
at a greater difficulty level.

Sliding Platform
----------------
In the center of platform #1,
there is a sliding platform.
When Popeye steps onto it, he'll
be whisked across to the other
side. If Popeye misses the
sliding platform, he falls to
the next platform.

Vultures
--------
In this round, vultures may
appear and swoop down at Popeye.
If you're quick enough, Popeye
can punch these vultures, and
you gain 1,000 points for each
one he knocks out. But if you
miss, the vultures can knock
Popeye overboard and you lose
that Popeye. If you have a
remaining Popeye, he will appear
on the top, left-hand side of
the screen.

Spinach
-------
In this round, Popeye's spinach
will randomly appear at the
right, on platform #2 or #3.

END OF ROUND AND GAME:
----------------------
The round ends once you've
collected all of Olive's tokens.
As long as you have a remaining
Popeye, you'll automatically
advance to the next round.

The game ends when you run out
of Popeyes. To play again,
press the RESET button, then
press ENTER and select the game
level at which you wish to play.

SCORING:
--------
The number of points for each
heart, note, or letter caught
depends upon which platform
Popeye is on when he catches it.

Hearts, Notes & Letters
  Platform #1            500 pts
  Platform #2            300 pts
  Platform #3            200 pts
  Platform #4            100 pts
Tokens in Water          100 pts
Hitting Punching Bag     100 pts
Punching Bottles         100 pts
Punching Vultures      1,000 pts
Hitting Brutus w/Bucket
  Platform #2          1,000 pts
  Platform #3          2,000 pts
  Platform #4          4,000 pts
Knock Brutus Overboard 3,000 pts
Bonus Popeye    After 30,000 pts

You'll receive double the point
value of a token if Popeye
catches it while the "Popeye
Theme" is playing.

//==============================
// Q-BERT
//==============================
$D8C9856A
Q-BERT
(c)1983 PARKER BROTHERS

OBJECT OF THE GAME:
-------------------
To score as many points as
possible by changing the color
of the cubes on the pyramid from
a starting color to a desti-
nation color. You'll do this by
hopping Q-bert from cube to cube
while avoiding the "nasty"
characters who will try to stop
him. Try to complete as many
pyramids as you can. There are 9
game levels, 4 rounds per level.

CONTROLS:
---------
DISC - Move Q-bert
Press ENTER to start.

PLAYING THE GAME:
-----------------
You'll start the game with three
Q-berts. The first Q-bert will
appear on the topmost cube as
soon as you hit ENTER. The
remaining Q-berts are shown to
the left of the pyramid.

Try to hop Q-bert onto each and
every cube, so that eventually
the entire pyramid becomes the
destination color. The
destination color indicator is
on the left of the screen.

Be careful not to hop Q-bert off
the sides of the pyramid or off
the bottom row of cubes. If you
do, he falls and you lose that
Q-bert. When this happens, the
next Q-bert will apear on the
topmost cube ready to try again.

RED BALL
--------
When Red Ball starts rolling,
get Q-bert out of its path or it
will squash him! If this happens
the next Q-bert will appear on
the cube where the last one was
squashed.

PURPLE BALL
-----------
Poses the same kind of danger as
Red Ball, except that when
Purple Ball reaches the bottom
of the pyramid, it hatches Coily
the snake!

COILY
-----
He's the snake with the
perilous pounce! The only way to
get rid of Coily is to lure him
off the pyramid by hopping a
flying disc. The best way to do
this is to hop Q-bert onto the
exit cube. (There is only one
correct exit cube for each
flying disc.) Then as soon as
Coily approaches the exit cube,
hop Q-bert aboard the flying
disc. Q-bert flies off to safety
while Coily falls into space.

FLYING DISCS
------------
When Q-bert's in trouble, he can
board a flying disc that will
whisk him off to safety at the
top of the pyramid. The number
of discs and their placement to
the sides of the pyramid will
differ, depending on the game
level an round. Just make sure
Q-bert boards the flying disc
from the correct exit cube or
else he'll fall off the pyramid.

UGG
---
Ugg appears on the lower portion
of the pyramid and travels
sideways and upwards, ready to
jump on Q-bert. If he does, the
next Q-bert will appear on the
cube where the last one was
jumped.

SLICK
-----
Even though Slick can't catch
Q-bert, he's still a very crafty
fellow. He changes the cubes'
colors back again so Q-bert's
got to retrace his tracks. If
Q-bert stops him, however (by 
running into him), you'll earn
bonus points.

GREEN BALL
----------
Green Ball is the other green
character that can't catch
Q-bert either. But if Q-bert
catches Green Ball, all the
characters except Q-bert freeze
for a moment, Q-bert can
continue to hop, and you'll earn
bonus points.

END OF ROUND
------------
The round ends when you complete
the pyramid. As long as you have
a Q-bert remaining, a new
pyramid will appear with a new
destination color.

ROUND PROGRESSION
-----------------
As you progress from round to
round, Q-bert's speed, the speed
of the other characters, and the
frequency of the other charact-
ers' appearances will increase.

END OF GAME
-----------
The game ends when you run out
of Q-berts. To play again, press
RESET, then ENTER. The game will
begin at Level 1, Round 1.

SCORING:
--------
Q-bert changes cube to:
 Destination color        25 pts 
 Intermediate color       15 pts
Q-bert:
 Catches Slick           300 pts 
 Catches Green Ball      100 pts 
 Lures Coily off pyramid 500 pts 
Unused flying discs, per  50 pts 
Complete 1st round     1,000 pts
 (+125 pts for each successive
 round, up to 5,000 pts)
 
Bonus Q-bert every 10,000 pts.

//==============================
// REVERSI
//==============================
$C7BB1B0E
REVERSI
(c)1981, 1998 INTELLIVISION
PRODUCTIONS, INC.

Turn most of the pieces to your
color, by bracketing your
opponent's pieces in any row
(vertical, horizontal or
diagonal). Occupy the outer
edges and corners to dominate
the board and get the biggest
margin of victory. Make every
move count, and THINK AHEAD!

CONTROLS:
---------
DISC- Move cursor
TOP SIDE BUTTONS- Place piece
LOWER SIDE BUTTONS- Preview move
[1-3]- Board size(6x6/8x8/10x10)
[4-6]- CPU starts, you start, 2p
[7-9]- Skill level(9 is hardest)

After game starts, press any key
to see computer's suggested move.

HOW TO PLAY:
------------
The cursor color indicates which
player has the current move. Use
DISC to move the cursor. To
place your piece, press either
TOP ACTION BUTTON; to preview
any play, press either LOWER
BUTTON. THE COMPUTER WILL NOT
LET YOU MAKE AN ILLEGAL MOVE.
Digital clocks in each player's
color show time remaining,
change to red numerals for
"overtime".

RULES OF THE GAME:
------------------
1. Players take alternate turns
placing one piece each time.

2. At the start of the game, the
first four pieces must be placed
in the four center squares of
the board.

3. Every piece must be placed
adjacent to at least one
different colored piece.

4. Every move must result in
reversing the color of at least
one of the opponent's pieces.
Color is reversed when pieces
are bracketed in any vertical,
horizontal or diagonal row. 

5. If a player cannot place a
piece as noted in #3 and #4,
they must forfeit their turn.

6. When the board is completely
filled, the game is over (tie
scores are possible).

STRATEGY TIPS:
--------------
1. The corner squares are the
best ones to occupy, because you
can't be outflanked there. Try
to get the corner!

2. If possible, don't place your
pieces in squares adjacent to
corners as they might give your
opponent an opportunity to get
those key positions.

3. The scoring lead will often
change several times during a
game. Don't get discouraged if
you are behind! It is frequently
desirable to have the lower
score during the early stages of
the game. Many of your
opponent's pieces are scoring
opportunities - right up to the
end of the game.

4. Use the "Preview" feature to
analyze your potential moves. As
soon as you press a "Place
Piece" action button, you can't
change your mind!

5. If you want to see the
computer's suggestion for your
next move, press any key. The
suggested move will reflect the
skill level you selected at the
start of the game.

//==============================
// SAMEGAME & ROBOTS
//==============================
$6E0882E7
$12BA58D1
$239bd45e
SAMEGAME & ROBOTS
(c)2012 INTELLIGENTVISION

Strategy and planning is the
name of the game regardless of
which title you choose to test
your wits against. Learn to
analyze and predict how the game
will unfold, to score the most
points while successfully
completing each game. Welcome to
the peaceful world of SameGame
and the tense world of Robots.
Either choice is an addicting
path.

CONTROLS:
---------
DISC - Move cursor
SIDE BUTTONS - Select piece
[1-4]/[6-9] - Move robot
[5] - Pass
[0] - Bomb
CLEAR - Hyperspace
ENTER - Exit

MENU OPTIONS:
-------------
There are three different games
to choose from. Before starting
any of the games, you have the
option to have music play in the
background. (See SameGame Rules
for difference between Option 1
and 2). Press number 4 to select
the first song. Press again to
continue going through the list
of songs. When music is playing
during a game, some sound
effects are disabled. If the
Intellivoice is connected,
phrases will be spoken regard-
less of whether music is playing
or not (See Using Voice). Press
1, 2, or 3 to begin game play.

SAMEGAME:
=========
There are three different shapes
on the board. Connect as many of
one type of shape to score
higher points and clear the
board. There are two variations
of the game.

GAME PLAY
---------
The cursor will pulse in the
center of the screen indicating
that play is ready. There are
three different shapes (Red
Circle, Blue Triangle, and Green
"X"). Use the DISC to move the
cursor in one of four direc-
tions: up, down, left and right.

To remove shapes from the board,
the cursor must be over a shape
with similar joining shapes
above, below, left and/or right.
Press any SIDE ACTION BUTTON and
all similar shapes touching will
be removed from the screen.
Remaining shapes will fall into
the empty slots.

When a column is cleared, the
columns will shift from right to
left. The points earned will
float from the cursor to the
right of the screen. The Turn
Score will become the earned
value and decrease as it is
added to the Current Score.

SCORING
-------
Points earned are calculated as
the number of shapes cleared,
times the number of shapes
cleared minus one, divided by
two. Example: 5 shapes cleared
would score [ 5 x (5-1) / 2 ],
or 10 points.

SAMEGAME RULES
--------------
The following rules apply to
SameGame Pro (Option 1):

1. A minimum of two pieces of
   the same shape must be in
   contact to remove from the
   board and collect points.
2. The game ends when there are
   no two adjacent shapes of the
   same type on the board.
3. 500 point bonus is awarded if
   board is cleared of pieces.

The following rules apply to
SameGame (Option 2):

1. One piece may be removed from
   the board when the score is
   over 100 points. 100 points
   are deducted for this move.
2. When two or more pieces of
   the same shape are in contact
   and removed from the board,
   points are collected.
3. The game ends when all pieces
   are removed from the board or
   there are no two pieces of
   the same shape in contact and
   score is less than 100 points.

GAME OVER
---------
To exit the game early, press
ENTER. When game play ends,
press any button on the keypad
to play a new round or press the
DISC to return to the Main Menu.

ROBOTS:
=======
Move your robot to destroy all
the robots on the screen by
making them collide into each
other, hit their leftover scrap,
or by using a bomb.

GAME PLAY
---------
Your white robot will be in the
center of the screen indicating
that play is ready. Use the
KEYPAD to move the cursor one
block in any direction. For
every move you make, the robots
get one move. Robots will
collide with each other when
they move and two robots end up
occupying one space at the same
time. Robot collisions will
leave behind a piece of scrap.

Pressing CLEAR ("HYPERSPAPE") on
the KEYPAD will move the cursor
to a random location. Pressing
"0" ("BOMB") on the KEYPAD will
kill all robots one block away
from the cursor. Landing on the
Super Bomb will kill all the
robots two blocks away after the
robots move.

Pressing ENTER ("EXIT") will let
the robots move until they all
crash or land on your robot; you
will not be able to move. Use
this when you are sure that all
the robots will crash or when
you want to exit the game early.

SCORING
-------
Points are awarded at the end of
each completed level:
Use Bomb or Super Bomb     5 pts
Robot Hits Scrap Piece    10 pts
Robots Collide            15 pts
Level Bonus Based on
 Completion Time          20 pts
         (increases 5 pts/level)

GAME OVER
---------
You have one life. The game ends
when a robot reaches your white
robot. When the high scores are
shown, press any button on the
keypad to play a new round or
press the DISC to return to the
Main Menu.

USING VOICE:
------------
Add an additional dimension to
the game by using Intellivoice.

In SameGame, you will hear:
1. How many pieces of each shape
   are on the board
2. A rating for your score
   ("Great", "Super", "Expert")
3. Final Score
4. Quitting early

In Robots, you will hear:
1. Count of Robots in the level
2. Level completed
3. Final Score

...and more!

//==============================
// SHARP SHOT
//==============================
$FF7CB79E
SHARP SHOT
(c)1982, 1998 INTELLIVISION
PRODUCTIONS, INC.

CONTROLS:
---------
[1] - Football Passing
[2] - Space Gunner
[3] - Submarine
[4] - Maze Shoot
ANY ACTION KEY - Fire/Pass
DISC - Start game

GAME 1 (TOUCHDOWN PASSING):
---------------------------
Throw ball to either blue
receiver until clock reads -0-.

Touch DISC to start clock and
action. When your downfield
receiver is in the clear, press
any ACTION BUTTON to pass. Keep
passing as fast as you can to
get a high score before time
runs out. Each completed pass
scores 7. Incomplete and inter-
cepted passes don't count
against you, but cost you time!

GAME 2 (SPACE GUNNER):
----------------------
Fire at spaceships in gunsight
until clock reads zero.

Touch DISC to start clock and
action. When target flies into
your gunsight, press any ACTION
BUTTON to fire gun. Keep
shooting to get a high score
before time runs out. Watch for
bunches of targets: it's
possible to get 6 at once!

GAME 3 (SUBMARINE):
-------------------
Sink as many ships as you can
until clock reads zero.

Touch DISC to start clock and
action. When a ship approaches,
press any ACTION BUTTON to fire
torpedo. Up to 3 torpedoes can
go at the same time. Keep firing
to get a high score before time
runs out. Each ship you sink
scores 1 point.

GAME 4 (MAZE SHOOT):
--------------------
Hit as many monsters as you can
until clock reads zero. Try to
get them before they steal
points from your score!

Touch DISC to start clock and
action. When monsters appear,
press any ACTION BUTTON to shoot
arrow. Keep shooting to get a
high score before time runs out.
Each hit scores 1 point. If a
monster reaches your treasure it
turns black and heads for the
pyramid. If you let them get
away with it, you lose a point!
Arrow resets to starting
position when you shoot. Use
carom shots to cover more than
one lane of the maze.

HAVE A FOUR-WAY GAME:
---------------------
It's fun to play all four games
one after the other, then add up
your scores. If you get 200
points, you're an Ace 
Sharp-shooter for sure!

//==============================
// MOUNTAIN MADNESS SUPERPRO SKIING
//==============================
$6B5EA9C4
MOUNTAIN MADNESS SUPERPRO SKIING
(c)1987, 1998 INTELLIVISION
PRODUCTIONS, INC.

CONTROLS:
---------
DISC - Turn skier
TOP SIDE KEYS - Power turn
BOTTOM SIDE KEYS - Jump

Press DISC to start the clock.

SELECT GATE WIDTH:
------------------
The downhill course is defined
by pairs of flags, or gates,
that you ski through. Select
wide gates by pressing 1
(Downhill). Select more
challenging narrow gates by
pressing 2 (Slalom.) Select no
gates, allowing you to choose
your own path down the mountain,
by pressing 3 (No Flags). After
pressing 1, 2, or 3, press ENTER.

SELECT COURSE:
--------------
Select from 32 built-in courses,
each with its own obstacles and
challenges, or choose a new
course, designed either by you
or by the computer. Press 1 to
32 to select one of the built-in
courses (see below on previewing
courses), press 33 to have the
computer design a new course
("helicopter skiing"), or press
34 to design a new course
yourself. After you make your
selection, press ENTER.

PREVIEW BUILT-IN COURSES:
-------------------------
You may preview any of the 32
built-in courses before
selecting one. Press 1 to 32, as
described above, but before
pressing ENTER, press the DISC.
A map appears, with the main
characteristic of each course
segment color-coded:

Green -- Clear skiing
Dark Blue -- Icy patches
Gray -- Moguls (bumps)
Lt Blue -- Powder(unpacked snow)

Warning: Only the MAIN char-
acteristic is color coded; for
example, a green segment may
include a mogul, or a gray
segment may include an icy patch.
Also, patches of ground do not
appear on the preview!

Press the TOP and BOTTOM of the
DISC to see the entire course.
Press any KEY to return to the
SELECT COURSE SCREEN. Press
ENTER to ski the course, press
CLEAR to preview/select another.

HELICOPTER SKIING:
------------------
Pressing 33 followed by ENTER
causes a new course to be
created at random by the
computer. This simulates
"helicopter skiing" - the thrill
of a helicopter dropping your
ski party at the top of an un-
charted mountain. For the
complete sensation of uncharted
territory, Helicopter Skiing
should be selected after the No
Flags option, although you can
still select Helicopter Skiing
with Downhill or Slalom gates.
The course is different every
time you select this option.

CREATE YOUR OWN COURSE:
-----------------------
Pressing 34 followed by ENTER
displays the COURSE EDITOR
SCREEN. String together from 3
to 15 course segments to build a
new course. Press the TOP or
BOTTOM of the DISC to display
the 28 available segments, one
at a time. Press ENTER to add
the displayed segment to the
course; press CLEAR to erase the
last-added segment. Press -0- 
when finished.

Note: The segments are color-
coded by main characteristic as
in PREVIEW BUILT-IN COURSE above.
Each segment may contain other
obstacles that will only show up
when you actually ski the course.

SELECT SLOPE:
-------------
Enter the slope, from 1 to 15.
The higher the slope, the faster
you accelerate down the course.
Start with lower numbers until
you have mastered running and
jumping. Press ENTER after
selecting the slope.

PREVIEW COURSE:
---------------
A map of the course now appears,
color-coded as described in
PREVIEW BUILT-IN COURSE, above.
Press the BOTTOM and TOP of the
DISC to view the entire course.
When you are familiar with the
course, press any KEY and get
ready to hit the slopes!

THE RACE IS ON:
---------------
Your skier is in the starting
gate. Press the DISC to start
the clock and the skier starts
down the mountain! 

Press LEFT and RIGHT side of
DISC for "snowplow" turn (slows
you down). Hold down a TOP SIDE
KEY while pressing DISC for
"parallel" POWER TURN (does not
slow you down). Jump over
obstacles by pressing either
BOTTOM SIDE KEY.

Note: Hit certain obstacles or
try to ski backwards and you'll
fall! You'll get back up auto-
matically, but you'll have
wasted precious time!

GATES:
------
The left flag changes color for
each gate you ski through. A
2-second penalty is added to
your time for each gate you miss.
It's okay to knock over a flag
as you go through the gate, but
it will slow you down. It's also
okay to pass through a gate from
below; if you pass a gate to the
side, turn, ski uphill into the
gate then turn and ski back down.

TERRAIN & OBSTACLES:
--------------------
Learn to recognize the various
obstacles. You can jump over
some, others you have to ski
around:

Trees-- Knock you down when hit.
Flags--  Slow you down when hit.
Icy Patches (dark blue lines)--
          You can't turn on ice.
Powder (light blue dots)--
                 Slows you down.
Moguls (gray bumps)--
                 Knock you down.
Patches of Ground (brown spots)-
                 Knock you down.

BEST TIME:
----------
Your skier has 3 chances to
record their fastest time. The
clock records the time, adding
a 2-second penalty for each
missed gate. The time for each
run appears at the finish line.
The best time so far appears at
the starting gate. After the 3rd
heat, your best time is shown.

//==============================
// STAMPEDE
//==============================
$2DEACD15
STAMPEDE
(c)1982 ACTIVISION

The object of Stampede is to
score as many points as possible
by roping as many dogies as you
can, before too many stray
behind you.

CONTROLS:
---------
DISC - Move the cowboy
SIDE BUTTONS - Throw the lasso
CLEAR - Begin play / new game

GETTING STARTED:
----------------
Press DISC for game selection.
Select game level by pressing
appropriate number on keypad:
[1] - Slow Cows
[2] - Slow Random Cows
[3] - Fast Cows
[4] - Fast Random Cows 

The game selected will then
start automatically. To change
the game level, press CLEAR.

SCORING:
--------
You score points by roping
cattle. Each dogie is worth
points, depending on its color:
 Black Angus             100 pts
 Light Brown Guernseys    15 pts 
 White Jersey             25 pts
 Dark Red Herefords        3 pts
 
The number on the upper right
side of the screen indicates the
player's score. The number on
the upper left side of the
screen indicates the number of
dogies which you can allow to
stray behind you before the game
ends. This number starts at 3
and decreases by one each time a
dogie strays off the left side
of your screen. When the last
on strays behind your horse, the
game is over. 

GETTING THE FEEL OF STAMPEDE:
-----------------------------
Climb into the saddle and start
ridin'! You'll want to practice
placing your cowboy in the right
position to rope and herd those
dogies wighout letting any get
by you and to dodge any sur-
prises on the trail.

To rope, position your horse
directly behind the dogie you
wish to lasso. The rope will
always be thrown directly in
front of your horse, and the
loop must touch a dogie in order
to rope him. If you attempt to
rope a steer which is too far
away or too close, you'll come
up empty. When you get more at
home on the range, you'll know
the right time to throw your
rope.

It's impossible to score well if
you can't keep the game going
long enough to rope a passel of
dogies. The only way to do that
successfully is to keep the
cattle in a herd in front of you.
Herding is as important as
roping in helping you run up
your score.

To herd dogies, bring your horse
into contact with them without
throwing your lasso. You'll
notice they'll speed up and run
farther out in front of your
horse. Since all dogies do not
run at the same speed, you will
have your work cut out for you
to keep them ahead of you.

GAMES:
------
Each game of Stampede offers a
different pattern, speed and
movement of the dogies, pro-
viding new challenges every time
you play.

Game 1 (Slow Cows) -- When the
game begins, dogies lope along,
gradually running faster as the
game progresses. They will run
only straight ahead, and they
travel in a specific pattern.

Game 2 (Slow Random Cows) --
Same as Game 1, but there is no
set pattern of appearance of
dogies on the screen.

Game 3 (Fast Cows) -- Dogies
appear in same pattern as Game 1
except all dogies start out at a
faster pace.

Game 4 (Fast Random Cows) --
Same as Game2, except all dogies
start out at a faster pace.

SPECIAL FEATURES OF STAMPEDE:
-----------------------------
Dangers on the trail -- The
cattle drives of the Old West
had their share of hazards - and
Stampede does, too. Occasionally,
you'll come upon an old bleached
skull on the trail, and your
horse will rear if you attempt
to ride over it. If that happens,
some of the dogies you are
herding and roping could stray
by, so look out and be prepared
to ride around the skulls.

There's also a Black Angus who
pops up every now and then
(worth 100 pts if you rope him),
and he can be a bum steer. Since
he's sitting still and facing
you - and can't be herded - he's
tough to rope. Worse, if you
bump into him, not only will he
have strayed out of the herd but
your horse will rear, slowing
your pursuit of the other dogies.

Lasso -- Once you've thrown your
lasso, you cannot move your
horse up or down until you've
got your lasso back.

No time limit -- You can keep on
ridin' and ropin' as long as
your "stray count" (number on
the left side of the screen) is
1 or more. The better you get at
roping and herding dogies, the
longer your roundup will last.

Increasing your stray allowance-
After each 1,000 pts, your stray
count will increase by one,
giving you more of a chance to
rope and ride. The number will
never get larger than 9.

HOW TO BECOME A CATTLE BARON:
-----------------------------
Tips from Bob Whitehead,
designer of Stampede.

If you are really a savvy
cowboy, you could probably play
Stampede till the cows come home.
Strategy, patience and smart
herding and roping are what
really count.

1. First of all, keep in mind
the particular sequences in
which the dogies appear. My
advice is to establish a
priority for roping the
stampeding herd.

2. One strategy is to lasso the
high-point dogies first, while
keeping the darker (low-point)
ones herded in front of you.

3. Herding is the most important
part of the game. But remember,
a dogie that is repeatedly
herded will get tired and
become more difficult to herd,
because they won't run as far
ahead on the screen.

4. You'll notice that the dogies
appear in rows. When you rope
the last one of a group of dark
red Herefords, get set for some
fast action, 'cause there's
trouble ahead!

//==============================
// STONIX
//==============================
$66D396C0
STONIX
(c)2004 ARNAULD CHEVALLIER,
INTELLIGENTVISION

You have come head-to-head with
the enemy, STONIX! His goal is
to exhaust your life energy;
yours is to destroy his power
source! It will take time to
reach it because he has laid
many barriers that you need to
penetrate. Lucky for you, your
power balls mix with his shields
to give you zapping deflectors,
larger deflectors and even extra
life power! Stay sharp, you have
a long journey ahead of you!

CONTROLS:
---------
DISC - Move deflector
SIDE BUTTONS - Launch/fire
Press 1+9 together - Pause

BONUS CAPSULES:
---------------
[50] POINTS - (Tan)
[B]ONUS LIFE - (White)
SLOW [D]OWN - (Green)
[E]NERGY - (Yellow)
[L]ARGE DEFLECTOR - (Pink)
[M]ULTI BALL - (Cyan)
[S]UPER BALL - (Orange)
[Z]APPING DEFLECTOR(Light Green)

STAGES AND LEVELS:
------------------
Your advancement to STONIX is
broken into STAGES and LEVELS.
Each STAGE consists of 5 LEVELS.
At the completion of 5 LEVELS,
you are given a Bonus Life and a
PASSWORD that allows you to
start at the stage indicated.

GET READY!
----------
When you select NEW GAME, the
battle for the STONIX power
source begins! You start the
battle with the deflector in the
center of the screen and your
energy ball on the deflector.

1. Press any side button to
release the ball or wait several
seconds and it will release on
its own.

2. Move the deflector by press-
ing the left side (9 o'clock
position) or right side (3
o'clock position) of the DISC.
To move the deflector slowly,
press the lower side (7 o'clock
and 5 o'clock position respec-
tively) of the DISC. Move it
faster by pressing the upper
side (11 o'clock and 1 o'clock
position respectively) of DISC.

3. Line up the deflector to hit
the ball as it comes back down.

4. When the energy ball hits a
shield element, it will be
destroyed unless the shield is
Resistant or Indestructible in
nature. See "STONIX SHIELDS"
section for details.

5. At times, a BONUS will fall
after the destruction of a piece
of the shield. Learn the
different types and decide if
you should catch the bonus. See
"BONUSES" section for details.

6. If the energy ball escapes
the playing field, the deflector
will disintegrate and your total
LIVES count will drop by one. A
new deflector will appear in the
middle of the screen with an
energy ball as long as you have
more LIVES.

7. The battle ends when the
LIVES count hits zero and you
lose the last ball or you
destroy the STONIX power source!

STONIX SHIELDS:
---------------
Normal Shield Element
  (Solid Colors) -- Destroyed as
  soon as it is hit.

Resistant Shield Element
  (Gray) -- Must be hit twice to
  be destroyed, except if the
  "SUPER Ball" bonus is active.
  See "BONUSES" section.

Indestructible Shield Element
  (Tan) -- Can never be 
  destroyed and will remain on
  the screen permanently.

The level ends when all NORMAL
and RESISTANT parts of the
shields are destroyed.

FLYING OBJECTS:
---------------
During the game, flying objects
are released from the two trap
doors located at the top of the
screen. You collect extra points
by destroying the objects but
they will throw off the path of
the ball making it difficult to
return at times. Destroy one
flying object and a new one will
appear at a trap door. Should a
flying object go low enough,
slam it with your deflector to
destroy it!

BONUSES:
--------
Bonus capsules are released
randomly after an element of a
shield is destroyed. It will
then slowly fall until it
reaches the bottom of the
screen. Move your deflector
under a capsule to collect it
and enable the bonus.

There are 8 different bonuses:

1. [50] Points (tan) -- Increase
your score by 50 points.

2. [B]onus Life (white) --
Increase your LIVES by one.
Maximum LIVES possible are 9.

3. Slow [D]own (green) --
Decrease the speed of the ball.

4. [E]nergy (yellow) -- This
makes the energy ball stick to
the deflector for a few seconds
(the same way it does when you
start a new level or lose a
life). Press any SIDE BUTTON to
launch it. The ball will go in
the direction it would have gone
if it had immediately bounced
off the deflector.

5. [L]arge Deflector (pink) --
Double the size of the deflector.

6. [M]ulti Ball (cyan) -- Add a
second ball to the playing field.
This bonus does not disappear
when another bonus is caught,
and you do not lose a life when
one ball escapes the play area.

7. [S]uper Ball (orange) -- Goes
through normal and resistant
shields without bouncing but
will still bounce off indestruc-
tible shields. Also, its trajec-
tory may still be altered when
hitting a flying object. Your
energy ball will change colors
from white to orange.

8. [Z]apping Deflector (light
green) -- Shoot electrical
charges from the deflector to
destroy the shields and flying
objects. It takes time for the
deflector to recharge leaving
you with the ability to only
have one active charge on the
screen at a time.

NOTE: Getting a new bonus
disables effects of the previous
one. The exceptions are "MULTI
BALL" and "SLOW DOWN" which are
not disabled.

SCORING:
--------
Hit NORMAL Shield Element  1 pt
Destroy RESISTANT Element  1 pt
Destroy Flying Object      5 pts
Capture a BONUS            5 pts
Capture a "50" BONUS      50 pts
Extra Life         Every 500 pts

When you reach the Stonix power
source, you accumulate points
for hitting it even when it is
not destroyed.

GAME OVER:
----------
When you run out of lives, GAME
OVER will be displayed along
with the highest score played
since the console has been on.
Press any key to display the
Player Options screen. You now
have the ability to resume play
from the beginning of the last
stage passed. Press "1" to
continue or CLEAR to return to
the Main Menu.

HINTS:
------
1. Some BONUSES are better than
others. Determine which bonus
you play best with.

2. Hit the 500 point levels for
additional LIVES.

3. Stay away from the FLYING
OBJECTS when they are in the
middle or lower part of the
screen as you have no idea where
the ball will bounce after
destroying one.

4. The ball goes faster and
faster as time passes. Catch the
"SLOW [D]OWN" bonus regularly to
slow the ball down.

5. Avoid hitting the ball on the
lower part of the deflector's
side. You will lose control of
the deflector and the ball.

6. Beware when you come head-to-
head with Stonix. He will deploy
his ultimate weapon - FIREBALLS!

//==============================
// SYDNEY HUNTER & THE SACRED TRIBE
//==============================
$31badc41
SYDNEY HUNTER & THE SACRED TRIBE
(c)2015 COLLECTORVISION GAMES

You're Sydney Hunter, the great
adventurer. You've been ex-
ploring the Yucatan Peninsula,
seeking treasures. As you trav-
eled, you were captured in the
night by a mysterious tribe.
Although they claim they won't
hurt you, you are still their
prisoner.

CONTROLS:
---------
DISC - Move Sydney, use stairs
SIDE ACTION BUTTONS - Jump
[1] - Inventory
[5] - Skip scenes/text

HOW TO PLAY:
------------
The object of the game is to
collect all the gems in the
temple. The tribe has lost
access to the Sacred Door which
leads to the other side of the
island where the Mayans live.
The tribe trades food with the
Mayans by giving them precious
diamonds. The tribe needs your
help to get the gems to open the
Sacred Door to get food.

Press outside edge of DISC in
direction you want Sydney Hunter
to walk (left or right) or to
climb (up or down). Press any
SIDE ACTION BUTTON to jump.

You can view your inventory by
pressing "1" on the keypad. To
skip scenes and text in the game,
press "5" on the keypad. Use
stairs by pressing the DISC up
when you are next to an entrance.
Sydney Hunter will automatically
go up or down stairs.

NOTES:
------
1. You need keys to open chests,
which usually contain many gems.

2. You can't jump over snakes.

3. Each pineapple gives you an
extra life.

4. Each diamond gives you 1, 5,
10 or 30 points depending on its
color.

//==============================
// THIN ICE
//==============================
$F3DF94E0
$975AE6DF
$D6495910
$945717ce
THIN ICE
(c)1986, 1998 INTELLIVISION
PRODUCTIONS, INC.

Oh, no! Duncan is on the loose!
Duncan is a penguin who loves to
skate on thin ice, much to the
dismay of the other penguins. As
Duncan skates he weakens the
ice -- if he skates completely
around another penguin, KER-
PLASH! -- the ice collapses and
the penguin falls into the pond.

Duncan has only two worries --
the seal who loves to bounce him
on her nose, and the lumbering
polar bears who like to bat him
around.

CONTROLS:
---------
DISC - Control Duncan
SIDE BUTTONS - Freeze polar bear
Press 1+9 together to pause game

Press ENTER to start

GAME PLAY:
----------
Skate around the other penguins,
dunking them in the pond. Avoid
or dunk the seal and polar bears.
Gobble shrimp cocktails for
extra speed. Dunk all of the
penguins, then take the Zamboni
ice resurfacer out for a spin to
fix up the pond -- more penguins
show up and the game continues
at the next level!

You start the game with 4 turns.
Your turn ends when Duncan is
thrown into the water or off of
the ice by the seal or a polar
bear. A message to "GET READY"
will appear before your next
turn. The number of turns you
have left is displayed in the
middle of the top right half of
the screen.

DUNKING:
--------
As Duncan skates on the thin
ice, he cuts it. You can see the
cut by the thin white line
trailing him. Draw a square with
this white line around a
penguin, seal, or polar bear and
-- KER-PLASH! -- they're dunked!

Part of the line erases whenever
a penguin or a polar bear
touches it, or whenever Duncan
swims across a hole in the ice.
Part of it also disappears
anytime Duncan zigzags.

THE SEAL:
---------
As much as Duncan loves dunking
penguins, the seal loves to
bounce Duncan around on her nose.
The seal chases Duncan by
trailing the white line of cut
ice (turning it red). If Duncan
is quick, he can dunk the seal
by using the red line to
complete a square around her.

He can also throw the seal off
the trail by erasing part of the
line -- swim through a hole in
the ice or zigzag! When the seal
loses the trail, she is
momentarily confused and doesn't
move -- a perfect opportunity to
dunk her!

POLAR BEARS:
------------
Polar Bears lumber around the
ice looking for Duncan. If they
catch him -- FWAP! -- they swat
him off the pond.

The Polar Bears can be hard to
dunk, since they move around so
much -- but they can be stopped!
Press any SIDE ACTION KEY to
temporarily FREEZE them! This
gives you your best chance to
dunk 'em, but use it sparingly -
you start the game with only
five "freezes". Extra freezes
can be earned by grabbing one of
the lobsters that occasionally
ramble across the ice. The
number in the upper right corner
of the screen tells you how many
freezes you have left.

HIGHER LEVELS:
--------------
Each time you dunk all the
penguins on screen, you move to
a higher, harder level. The
level you are on is indicated by
the number of igloos shown at
the top of the screen. WARNING:
The longer you stay on one
level, the faster the seal and
the polar bears become!

SCORING:
--------
Dunk the seal          1,000 pts
Dunk a polar bear        450 pts
Dunk a penguin           100 pts
Gobble shrimp cocktail    60 pts
Scarf up lobster          50 pts
Extra turn      every 10,000 pts

Get bonus points for the size of
the hole you make when you dunk
'em -- from 40 to over 6,000
points for skating around the
ENTIRE POND (it CAN be done!).

//==============================
// THUNDER CASTLE
//==============================
$C1F1CA74
THUNDER CASTLE
(c)1986, 1998 INTELLIVISION
PRODUCTIONS, INC.

Guide your knight through the
deadly mazes of Thunder castle,
slaying evil dragons, sorcerers
and demons as you go. Watch for
gates that block your path...
magic objects that grant special
powers, extra points, or extra
lives...and magic creatures that
energize your knight. Complete
all three mazes -- forest,
castle and dungeon -- and the
game starts over at a faster
speed. Continue playing,
increasing your score, until all
of your knight's lives are lost.

CONTROLS:
---------
DISC - Move your knight
SIDE BUTTONS - Use magic object

To save time, press the DISC to
turn your knight before he
reaches a turn in the maze. The
knight will continue in his
present direction until the turn
is possible.

Press any SIDE ACTION BUTTON to
activate a magic object after
your knight picks it up. Each
object can be activated only
once, unless picked up again.

Press any key to start the game.

GAME IN BRIEF:
--------------
1. Three dragons appear in the
forest maze, one at a time. Slay
all three dragons and advance to
the castle maze.

2. Six sorcerers guard the
castle maze, appearing two at a
time. Slay all six sorcerers and
advance to the dungeon maze.

3. Nine demons guard the dungeon
maze, appearing three at a time.
Slay all nine demons and
advance to the next, faster
forest maze.

4. To slay a dragon, sorcerer or
demon, move ENERGIZED knight on
top of guardian. If knight comes
into contact with guardian while
not energized, knight will lose
one life.

5. To energize knight, touch a
magic creature: bat in forest,
mouse in castle, or red skull in
dungeon. Energy lasts several
seconds, then disappears.

6. Pick up magic objects for
extra points, lives or powers.
Avoid the comb. To pick up
object, move knight on top of
it. Object picked up replaces
any unused object in your
possession. To use object, press
SIDE ACTION BUTTON. Object
disappears after use.

7. Knight starts with four lives.
Additional lives are earned by
picking up candlestick or
accumulating points. Game ends
when all lives are lost.

MAZES:
------
There are three levels to
Thunder Castle: forest, castle
and dungeon. The forest level is
the slowest. The dungeon level
is the fastest. If you make it
through all three levels, game
play resumes at the forest, but
game speed continues to increase.
There are several possible mazes
for each level. Once a maze
appears, it does not change
until the next level is reached.

WALLS AND GATES:
----------------
Knights and evil guardians can
move only along open passageways.
Magic creatures can move through
walls and gates. All mazes have
gates that randomly open and
close. Gates are invisible until
they close. Gates remain closed
for a few seconds, then reopen.

MAGIC CREATURES:
----------------
All mazes have magic creatures
that energize your knight when
touched.

Forest maze - Three bats
Castle maze - One mouse
Dungeon maze - One red skull

The knight remains energized for
a few seconds, during which he
flashes and special music plays.
Only while energized can the
knight slay evil guardians.

EVIL GUARDIANS:
---------------
All mazes have evil guardians
that must be slain to advance to
the next level. Evil guardians
come in three colors. Green:
slower than your knight, worth
300 points when slain. Gold:
almost as fast as your knight
and worth 400 points when slain.
Red: faster than your knight and
worth 500 points when slain.

Guardians pursue your knight
when he is not energized; flee
from your knight when he is
energized. If your knight
touches or is touched by a
guardian while not energized,
he will lose a life.

Different mazes contain
different evil guardians: 

Dragons -- Three in the forest
maze. Appear one at a time.

Sorcerers -- Six in the castle
maze. Appear two at a time, and
can move as a pair or split up
and attack from diff directions.

Demons -- Nine in the dungeon
maze. Appear three at a time,
can move together or split up
and attack from diff directions.

MAGIC OBJECTS:
--------------
Magic objects appear at various
times, in various locations
throughout each maze, remaining
for several seconds before 
disappearing again. To pick up a
magic object, move your knight
on top of it. To use the object,
press any SIDE ACTION BUTTON.

An object's power can be used
only once each time it is picked
up. An object remains in your
knight's possession until it is
used or replaced by a different
object (knight can carry only
one object at a time).

Grail- Energizes knight
Crown- Freezes guardian(s) for a
 few seconds
Necklace- Speeds knight up for a
 few seconds
Lantern- Doubles knight's energy
Key- Lets knight move through
 gate or wall
Ring- Moves knight to random
 location in maze

The above objects also add
points to your score. The first
object picked up within a maze
adds 100 points. The second adds
200 pts. All subsequent objects
within that maze add 300 points.

Some objects can be picked up
without replacing the object
already in possession:

Coins- Add 500 points to score
Candlestick- Extra life
Comb- Cuts your score in half

GAME LIVES:
-----------
Each knight starts with four
lives, and loses one life if
touched by an evil guardian
while not energized. Additional
lives can be earned by picking
up a magic candlestick, and by
reaching scores of 5,000,
10,000, 20,000, 50,000 and
100,000 points.

Game ends when all of your
knight's lives are lost. Number
of lives left, in addition to
present life, appear in the
upper right corner of the screen,
next to your game score.

SCORING:
--------
Slay Green Guardian      300 pts
Slay Gold Guardian       400 pts
Slay Red Guardian        500 pts
Pick up magic object
(excl. coins, candlestick, comb)
 1st Object in Maze      100 pts
 2nd Object in Maze      200 pts
 Addt'l Objects in Maze  300 pts
Coins                    500 pts
Candlestick           Extra Life
Comb             Lose 50% of pts
Extra Life at 5,000, 10,000,
  20,000, 50,000 and 100,000 pts

WINNING TIPS:
-------------
1. Lure an evil guardian as
close as possible to your knight
before touching a magic creature.
Your knight will be energized
for only a few seconds and
meanwhile, the guardian is
running away from you!

2. Try to anticipate gates, to
trap a guardian in a dead end.
Corners also slow guardians down.

3. Pick up the most useful magic
objects. Although all objects
give points, some are more
useful than others. Exceptions:
always pick up coins and
candlesticks. The extra points
and lives don't affect other
magic powers.

4. Avoid touching the comb when-
ever possible, but don't be
afraid to sacrifice points, if
the comb stands between your
knight and a safe retreat.

//==============================
// TOWER OF DOOM
//==============================
$D1D352A0
TOWER OF DOOM
(c)1987 INTV CORP.

Monsters. Magic. Good. Evil. 
Strength. Cunning. Traps. Mazes.
Prepare to face the greatest 
challenge any mortal has ever
known -- the Tower of Doom. 

Select your adventure. 
Select your character. 
Then enter the Tower of Doom!

THE ADVENTURES:
----------------
NOVICE
No. of Levels: 6
Mazes: Same each time
Difficulty: Easiest
Color of Items: Same*

THE TOWER
No. of Levels: 8, 12 or 20
Mazes: Same each time
Difficulty: Easy
Color of Items: Same*

THE CATACOMBS
No. of Levels: 12, 18 or 32
Mazes: Different each time
Difficulty: Medium
Color of Items: Different

THE FORTRESS
No. of Levels: 6, 12, 18 or 32
Mazes: Different each time
Difficulty: Difficult
Color of Items: Different

THE CHALLENGE
No. of Levels: 14
Mazes: Different each time
Difficulty: Difficult
Color of Items: Same

WIZARD HUNT
No. of Levels: 32
Mazes: Different each time
Difficulty: Difficult
Color of Items: Different

GRAIL QUEST
No. of Levels: 32
Mazes: Different each time
Difficulty: The Hardest
Color of Items: Different

COLORS:
-----------------
Gray     - Weakest
Cyan
Orange
Brown
Pink
Lavender
Green
Magenta  - Strongest

CHARACTERS:
-----------------
Novice      3     12  12  12
Warrior     2.25  13   9  12
Archer      3.25  10  13   8
Knight      4     11  11  11
Trader      2     13   6  18
Barbarian   2.25  12   9  10
Waif        1.5    6   6   6
Friar       3.75  10  10  10
Warlord     5.5    9   9   9
Warlock     4.5    9   9   9

BOOKS:
-----------------
Gray      Book of Strength
Cyan      Book of Blindness
Orange    Book of Stamina
Brown     Book of Weakness
Pink      Book of Diplomacy
Lavender  Book of Affliction
Green     Book of Experience
Magenta   Book of Inexperience

CLOAKS:
-----------------
Gray      Cloak of Helping
Cyan      Cloak of Weakness
Orange    Cloak of Protection+1
Brown     Cloak of Protection+2
Pink      Cloak of Protection+3
Lavender  Cloak of Protection+4
Green     Cloak of Protection+5
Magenta   Cloak of Good Karma

GRAILS:
-----------------
Gray      Grail of Strength
Cyan      Grail of Superpower
Orange    False Grail of Str
Brown     False Grail of Sta
Pink      Grail of Diplomacy
Lavender  Grail of Mystery
Green     Grail of Glory
Magenta   The Holy Grail!

POTIONS - BOTTLE:
-----------------
Gray      Bottle of Healing
Cyan      Bottle of Slowness
Orange    Bottle of Fire Prot
Brown     Bottle of Haste
Pink      Bottle of Blindness
Lavender  Bottle of Sight
Green     Bottle of Strength
Magenta   Bottle of Power

POTIONS - FLASK:
-----------------
Gray      Flask of Healing
Cyan      Flask of Poison
Orange    Flask of Toughness
Brown     Flask of Invisibility
Pink      Flask of Paralysis
Lavender  Flask of Confusion
Green     Flask of Bartering
Magenta   Flask of Superpower

RINGS:
-----------------
Gray      Ring of Rapid Healing
Cyan      Ring of Weakness
Orange    Ring of Defense
Brown     Ring of Fire Protect
Pink      Ring of Helping
Lavender  Ring of Attacking
Green     Ring of Protection
Magenta   Ring of Magic

SMALL SCROLL:
-----------------
Gray      Scroll of Summoning
Cyan      Cursed Scroll
Orange    Enemy Slowness
Brown     Enemy Paralysis
Pink      Scroll of Friendship
Lavender  Enemy Haste
Green     Trap Removal
Magenta   Remove Curse

LARGE SCROLL:
-----------------
Gray      Scroll of Battle
Cyan      Exploding Scroll
Orange    Remove Curse
Brown     Teleportation
Pink      Scroll of Stamina
Lavender  Scroll of Helping
Green     Trap Removal
Magenta   Remove Curse

MORTAR & PESTLE:
-----------------
Gray      Healing
Cyan      Slowness
Orange    Friendship
Brown     Invisibility
Pink      Lose HP/Stanima
Lavender  Improve Battle
Green     Weakness
Magenta   Rudeness

ROSARY NECKLACE:
-----------------
Gray      Rosary of Potions
Cyan      Rosary of Darkness
Orange    Rosary of Healing
Brown     Rosary of Protection
Pink      Rosary of Blessing
Lavender  Rosary of Fulfillment
Green     Rosary of Literacy
Magenta   Rosary of Anti-Friend

KEYS:
-----------------
Gray      Bypass Transporter
Cyan      Bypass Transporter
Orange    Bypass Brown Gas
Brown     Bypass Brown Gas
Pink      Bypass Fire
Lavender  Bypass Confusion
Green     Bypass Green Gas
Magenta   Bypass Everything!


//==============================
// ULTIMATE PONG
//==============================
$6b8e956c
$30575596
ULTIMATE PONG
(c)2016 INTELLIVISIONREVOLUTION

IT'S BACK! Pong, the arcade
sensation of the '70s, is back
and expanded to include fourteen
variations of the classic game.

CONTROLS:
---------
DISC- Move paddle
TOP SIDE BUTTONS- Launch ball
LOWER SIDE BUTTONS- Shoot
[1-3]- Difficulty(1=easy,3=hard)
CLEAR- Music on/off
ENTER- Exit game
Press 1+9 together to pause game

14 GAMES TO CHOOSE FROM!
========================

PONG
----
It's the classic arcade ping
pong game that you remember!
Move your paddle to keep the
ball from getting past you.

BASKETBALL
----------
Shoot the ball into your oppo-
nent's basket to score. Make a
fast break! You have to play
both offense and defense to win
this game.

BARRIER TENNIS
--------------
It's tennis with a twist! Each
court has barriers that give
players two stationary barriers
on the court to block (or make)
shots. Move your paddle horizon-
tally or vertically. Think fast!

BATTLE PONG
-----------
Get the ball past your oppo-
nent's wall of bricks to score a
point. Shoot your laser to
eliminate their bricks and break
through their defenses, but
remember to keep the ball from
hitting your wall!

BRICK PONG
----------
Get the ball past your oppo-
nent's wall of bricks to score a
point. Each time ball strikes
the wall, a brick disappears.
Punch a hole in that wall!

CATCH
------
In Catch, you still try to get
the ball past your opponent, but
your large paddle has a gaping
hole in the middle, which works
as both an advantage and dis-
advantage. Deceptively tricky!

GRIDBALL
--------
Slide your paddles up and down
to create an opening and maneu-
ver the ball through the gates
and into your opponent's goal.
Are you sharp enough to watch
all three gates at once?

HOCKEY
------
Try for a fast break down the
ice to put the puck in the net.
But don't forget to move your
goalie into position when you're
on defense!

REBOUND
-------
Keep the ball from getting past
you as it rebounds off the top
and both sides of the court.
You'll have to play all the
angles to make a save and keep
the ball in play to have a
chance to win!

SOCCER
------
Move your paddle anywhere up and
down the field to get an advan-
tage and put the ball in the
goal. But don't leave your own
goal open too long or your oppo-
nent will move in for the score.

SQUASH
------
Players alternate hitting the
ball, trying to make their oppo-
nent miss. The ball changes
color to indicate whose turn it
is to hit.

TARGET
------
Move your crosshair to target
the ball as it moves across the
screen. Then use the BOTTOM SIDE
BUTTONS to shoot and score. Is
your eye-hand coordination up to
the task?

TENNIS
------
Besides moving up and down the
baseline, in this game you can
charge the net to speed things
up and try to catch your oppo-
nent off guard, just like in
real tennis!

VOLLEYBALL
----------
Use as many hits as you need to
get the ball over the net and
keep it in play. If the ball
isn't returned, a point is
scored.

//==============================
// UPMONSTERS
//==============================
$51870e4a
UPMONSTERS
(c)2018 CHRIS READ & 2600
CONNECTION

THE ALIENS ARE HERE!
--------------------
The aliens from the planet UP
have arrived! But no one on
Earth is panicking. Why? The
Upmonsters, as they're called,
have landed right in the middle
of the Sahara Desert. All 20 of
them went to explore, but after
finding absolutely nothing for
miles on end, they decided to go
home. But the UFO isn't working
very well in the desert heat, so
the aliens need to jump on the
clouds to get to the hovering
UFO. Only then will the aliens
be beamed up.

PLAYING THE GAME:
-----------------
The goal of the game is to get
all 20 aliens beamed up so the
UFO can go back to the planet UP.
The Upmonsters are eager to get
on the UFO, so they can't
control themselves when it comes
to jumping: They jump up and
down and there's no way to stop
that. There is, however, a way
to control them to go left or
right. You guessed it: The DISC
on your controller. Tap the DISC
to the left to go left. Tap the
disc to the right to go right.

When the Upmonster jumps on a
cloud, the screen scrolls up-
wards. For every 5 clouds you
pass, the level meter goes up a
notch and the score increases.
Fill up the level meter to make
the UFO beam the alien up and
you go on to the next level. If
you fall down out of the screen
or if the yellow bird that
periodically flies by hits you,
you lose a life. You get 4 lives
to start. The life counter shows
the number of chances you have
remaining. Losing a life sends
you back to the beginning of the
level and your progress is lost.

SCORING:
--------
Once all lives are lost, the
game goes back to the title
screen and the final score will
be displayed in white on the
right hand side of the screen.
A perfect score for completing
all 20 levels is 240 points. If
you press the RESET button on
the Intellivision console, all
scores will reset.

//==============================
// WHITE WATER!
//==============================
$F1ED7D27
WHITE WATER!
(c)1983 IMAGIC

For years, brave explorers have
plunged through the white waters.
Some purely for the thrill of
the river, others to find the
woodland's fabled treasures.
Ancient legend tells of Big
Kahuna, the Tribal Chief, who
offers valuable gifts to visi-
tors. But beware of his rage
when guests don't play by his
rules! Shoot the rapids for your
best time, or navigate the river
to collect treasures in the
forest.Hurry! The river beckons!

CONTROLS:
---------
While in raft:
 DISC (Top) - Paddle forward
 DISC (Bottom) - Paddle backward
 DISC (LEFT/RIGHT) - Turn raft
While out of raft:
 DISC - Move man
L LOWER BTN - Exit raft (left)
R LOWER BTN - Exit raft (right)
CLEAR - Reset game

Press ENTER to begin game.

OBJECTIVES:
-----------
WHITE WATER! has seven different
games, with one of the following
objectives:

River Runs (Games 1-4):
  Navigate the river in the
  shortest time possible. 

Riches Ritual (Games 5-7):
  Run the river and stop at
  beaches to collect as many
  treasures as possible.

PICK YOUR GAME:
---------------
1[1]: Beginner Raft Race
  Reach the flags on the river
  bank in the best time.
  (Men stay in raft, slow river)
 
2[4]: Speedy Beginner Raft Race
  Same as Game 1
  (Men stay in raft, fast river)
 
3[7]: Intermediate Raft Race
  Reach the flags on the river
  bank in the best time without
  losing 3 raftsmen.
  (Men can fall out, slow river)

4[2]: Experts Only Raft Race
  Same as Game 3.
  (Men can fall out, fast river)

5[3]: Beginner Riches Ritual
  Capture the treasure chest and
  return safely to the raft in
  best time w/out losing 3 men.
  (Men can fall out, slow river)

6[6]: Intermediate Riches Ritual
  Same as Game 5.
  (Men can fall out, fast river)

7[9]: Fortune Seeker's Favorite
  Score points by picking up as
  many treasures as possible
  before losing all 3 raftsmen.
  (Men fall out, slow then fast)

RIVER RAFTING:
--------------
Every game starts in the forest.
To get to the raft, press the
right side of the DISC. When you
run out of the forest to the
right, the river appears with
your two buddies waiting in a
raft on the beach. Guide the
adventurer to the raft. He
automatically jumps off the
small cliff and into the raft as
you steer him. Anytime the
explorer goes off the forest
screen in any direction except
the right, he is lost forever
and control returns to the
remaining paddlers in the raft. 

To control the raft, you must
know which end is the bow
(front). The raftsmen's arms
always point to the bow. To pad-
dle forward (in the direction of
the bow), press the top of the
DISC. To paddle backward, press
the bottom of the DISC. To turn
clockwise, press the right side
of the DISC. To turn counter-
clockwise, press the left side
of the DISC. To get a feel for
the controls, try steering the
raft while on the beach.

SURVIVING THE CURRENT:
----------------------
Once you shove off shore, you
naturally drift with the current.
With the bow of the raft facing
downstream, you may increase
speed by pressing the top of the
DISC. To stand still in rapids,
or backstroke in still water,
press the bottom of the DISC.
Patches of yellow signify shoals,
or shallow places in the river.
The raft stops when it hits a
shoal. You can push your way out
slowly by turning the raft in
the direction you want it to go,
then pressing top of the DISC.

WATCH OUT FOR RIVER HAZARDS!
----------------------------
# Whirlpools turn your raft
around a few times, causing a
temporary loss of raft control.
# Knocking into barrels or the
river bank bumps you off course.
# Running into rocks bounces
the raft, and, in some games,
throws a man into the water.

MAN OVERBOARD!
--------------
You start each game with three
raftsmen. You won't find more
raftsman along the way, so it is
important to keep your party in
the raft, and rescue them if
they fall out! When a paddler
falls out of the raft, you might
be able to save him. Steer the
raft in his direction. Touch him
and he'll jump back in the raft.

A swimmer is beyond rescue when: 
1. He floats off the screen
2. He runs into a rock
3. He is hit by a barrel
4. He is sucked into a whirlpool
 
If a swimmer washes up on the
shoal or the beach, he stays
there until you rescue him,
until a barrel hits him, or
until raft floats off the
screen. When all three raftsmen
fall out of the raft, you can no
longer steer the raft and the
game ends. An incomplete time
appears for your attempt.

THE RICHES RITUAL:
------------------
In games 5-7, the river natives
will share their treasures with
you, if you play their ancient
trading game according to their
rules!

STOP AT THE WHITE SAND BEACH
----------------------------
Stop at each white beach you
can. These only appear on the
left bank of the river. Use the
shoals to help you brake.
 
To leave the raft, press either
of the LOWER SIDE BUTTONS. To
jump out to the left of the raft,
press the LOWER LEFT BUTTON. To
jump out to the right, press the
LOWER RIGHT BUTTON. The DISC now
controls the man on shore. Guide
him to the left. He auto-
matically jumps up a cliff and
runs into a forest. An explorer
cannot leave the raft if one of
the raftsmen has fallen out and
can still be rescued.

GETTING THE URN
---------------
When you reach the forest you
will see a number of flags and
one valuable golden urn. To get
the urn without offending Big
Kahuna, you and the white native
must first take turns picking up
the flags. One rule of the
Riches Ritual: you take one or
two flags during one turn. The
native uses this rule to his
advantage. You should too!

You start the ritual. Pick up
one or two flags. The native
then runs and picks up a flag or
two. Continue taking turns. Once
all the flags are picked up, you
must race against the native for
the golden urn. He's fast! Plan
your game so you are closer to
the treasure than he is once all
the flags are picked up.

If you claim the golden urn, a
count is registered in yellow in
the upper left hand corner and a
sound is heard. Once the urn is
claimed, return to the raft and
paddle to the next beach.
 
In Game 7 only, the river tribe
leaves money bags for each man
in the raft. They may all be
taken at anytime during your
visit in the forest.

Anytime you leave the forest and
re-enter it, the native dis-
appears with all treasures. You
must paddle to another beach to
play again.

TRIBAL TABOO!
-------------
If you pick up more than two
flags in one turn, or the golden
urn before all flags are claimed,
Big Kahuna will throw tomahawks
at you. If a tomahawk hits you,
you lose one man and all treas-
ures earned in that forest.
Control automatically returns to
the raft. 

If you outmaneuver the tomahawks
and return safely to the raft,
beware of a raging river! Big
Kahuna turns the current into a
white water torrent, until you
play the Riches Ritual fairly.

FINDING THE VALUABLE TREASURE
-----------------------------
If you can claim as many as
three urns, Big Kahuna shows his
respect by adding a valuable
treasure chest and more golden
urns to the game. To get the
treasure chest, first take turns
with the native picking up flags,
as before. After all the flags
are claimed, take turns picking
up golden urns. You may take
one or two urns per turn. After
all the urns are picked up, race
for the treasure chest! If the
urns or chest is taken out of
sequence, Big Kahuna gets mad
and throws tomahawks! 

In games 5 and 6, the score is
determined by how fast you can
get the first treasure chest and
return to your raft. This
requires you to pick up three
golden urns and one treasure
chest. This will take at least
for visits to the forest.

FORTUNE SEEKER'S FAVORITE
-------------------------
In Game 7, you score by collect-
ing treasures, each of them
having different values. You
must acquire three golden urns
before the valuable treasure
chest appears. After acquiring
one treasure chest, you must
claim three more urns to compete
for another treasure chest.
 
The number in the upper left
hand corner counts the urns for
you. After each Riches Ritual in
which you take part, the river
current becomes faster, with
more barrels and whirlpools.
Game 7 ends when all three
raftsmen are lost.

SCORING:
--------
Games 1 through 6 are timed
games. Your score is your time. 
The lower the time the better.
If you do not reach your goal
when games ends, your time
appears with a red "I" next to
it. This stands for incomplete.
Try to get your best time for a
complete game. You know a game
is complete when you reach your
goal, and no "I" appears next to
the score. 

In Game 7, you score points for
each treasure picked up:

Treasure        Order        Pts
--------        -----        ---
Money Bags      Anytime       50
Flags           First         10 
Golden Urn      Second       200
Treasure Chest  Third      1,000 

WORDS TO THE WISE:
------------------
1. To get down the river, go
with the flow. You don't need to
steer the raft constantly.

2. Try differnet combinations
when racing with the natives.

3. You may have to play one way
when there is an even number of
flags and another way when there
is an odd number. Figure it out!

//==============================
// ZOMBIE MARBLES
//==============================
$75d5e125
ZOMBIE MARBLES
(c)2002 JOHN DOHERTY

A wall of random coloured zombie
marbles advances upon you. Use
your anti-marble shooter to
crush this advancing threat!

CONTROLS:
---------
DISC(UP/DOWN) - Position shooter
DISC(RIGHT) - Shoot marble
DISC(LEFT) - Shoot anti-marble

HOW TO PLAY:
------------
To eliminate marbles, create a
sequence of three or more same
coloured marbles either horizon-
tally, vertically or diagonally.
Use your controller DISC to move
up and down in the playing field.

Shoot your anti-marbles by
pressing the right side of the
DISC. When things get really
tough, toss a anti-marble bomb!
The bomb will eliminate all
zombie marbles of the same
colour as the current anti-
marble. Use them wisely! You
only have three. Shoot your
anti-marble bombs by pressing
the left side of the DISC. Game
ends when the marbles advance to
the end of the playing field.
